/* DUPLICATOR MYSQL SCRIPT CREATED ON : 2015-06-22 07:14:07 */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) NOT NULL DEFAULT '',
  `comment_type` varchar(20) NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` mediumblob NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_fw_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `fw_term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `fw_term_id` (`fw_term_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL DEFAULT '',
  `link_name` varchar(255) NOT NULL DEFAULT '',
  `link_image` varchar(255) NOT NULL DEFAULT '',
  `link_target` varchar(25) NOT NULL DEFAULT '',
  `link_description` varchar(255) NOT NULL DEFAULT '',
  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL DEFAULT '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) NOT NULL DEFAULT '',
  `option_value` longtext NOT NULL,
  `autoload` varchar(20) NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=555 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=1041 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_excerpt` text NOT NULL,
  `post_status` varchar(20) NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) NOT NULL DEFAULT 'open',
  `post_password` varchar(20) NOT NULL DEFAULT '',
  `post_name` varchar(200) NOT NULL DEFAULT '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=184 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) NOT NULL DEFAULT '',
  `description` longtext NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  `slug` varchar(200) NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) NOT NULL DEFAULT '',
  `user_pass` varchar(64) NOT NULL DEFAULT '',
  `user_nicename` varchar(50) NOT NULL DEFAULT '',
  `user_email` varchar(100) NOT NULL DEFAULT '',
  `user_url` varchar(100) NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("1", "strefawp", "5587b59fef5a99674150622071335", "20", "2015-06-22 07:14:07", "admin", "O:11:\"DUP_Package\":16:{s:2:\"ID\";i:1;s:4:\"Name\";s:8:\"strefawp\";s:4:\"Hash\";s:29:\"5587b59fef5a99674150622071335\";s:8:\"NameHash\";s:38:\"strefawp_5587b59fef5a99674150622071335\";s:7:\"Version\";s:6:\"0.5.22\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:67:\"C:/Bitnami/wordpress-4.2.2-0/apps/wordpress/htdocs/wp-snapshots/tmp\";s:8:\"StoreURL\";s:45:\"http://localhost:8080/wordpress/wp-snapshots/\";s:8:\"ScanFile\";s:48:\"strefawp_5587b59fef5a99674150622071335_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":17:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";s:50:\"strefawp_5587b59fef5a99674150622071335_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:50:\"C:/Bitnami/wordpress-4.2.2-0/apps/wordpress/htdocs\";s:4:\"Size\";i:0;s:12:\"WarnFileSize\";a:0:{}s:12:\"WarnFileName\";a:0:{}s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:5:\"Links\";a:0:{}s:8:\"OmitDirs\";a:0:{}s:9:\"OmitFiles\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:8:\"strefawp\";s:4:\"Hash\";s:29:\"5587b59fef5a99674150622071335\";s:8:\"NameHash\";s:38:\"strefawp_5587b59fef5a99674150622071335\";s:7:\"Version\";s:6:\"0.5.22\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:67:\"C:/Bitnami/wordpress-4.2.2-0/apps/wordpress/htdocs/wp-snapshots/tmp\";s:8:\"StoreURL\";s:45:\"http://localhost:8080/wordpress/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";r:15;s:9:\"Installer\";O:13:\"DUP_Installer\":12:{s:4:\"File\";s:52:\"strefawp_5587b59fef5a99674150622071335_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:30;}s:8:\"Database\";O:12:\"DUP_Database\":11:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:51:\"strefawp_5587b59fef5a99674150622071335_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";r:45;s:8:\"Database\";r:58;}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://127.0.0.1:8080/wordpress/", "yes");
INSERT INTO `wp_options` VALUES("2", "home", "http://127.0.0.1:8080/wordpress/", "yes");
INSERT INTO `wp_options` VALUES("3", "blogname", "Kurs WP", "yes");
INSERT INTO `wp_options` VALUES("4", "blogdescription", "Łatwe tworzenie szablonów", "yes");
INSERT INTO `wp_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("6", "admin_email", "admin@strefakursow.pl", "yes");
INSERT INTO `wp_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("11", "comments_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("19", "default_comment_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("20", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("21", "default_pingback_flag", "1", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "m/d/Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "H:i", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("26", "comment_moderation", "", "yes");
INSERT INTO `wp_options` VALUES("27", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("28", "permalink_structure", "/%year%/%monthnum%/%day%/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("29", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("33", "active_plugins", "a:5:{i:0;s:36:\"contact-form-7/wp-contact-form-7.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:23:\"ml-slider/ml-slider.php\";i:3;s:27:\"theme-check/theme-check.php\";i:4;s:17:\"unyson/unyson.php\";}", "yes");
INSERT INTO `wp_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("36", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("37", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("38", "gmt_offset", "", "yes");
INSERT INTO `wp_options` VALUES("39", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("40", "recently_edited", "", "no");
INSERT INTO `wp_options` VALUES("41", "template", "strefawp", "yes");
INSERT INTO `wp_options` VALUES("42", "stylesheet", "strefawp", "yes");
INSERT INTO `wp_options` VALUES("43", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("44", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("45", "comment_registration", "", "yes");
INSERT INTO `wp_options` VALUES("46", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("47", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("48", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("49", "db_version", "31535", "yes");
INSERT INTO `wp_options` VALUES("50", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("51", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("52", "blog_public", "0", "yes");
INSERT INTO `wp_options` VALUES("53", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("54", "show_on_front", "page", "yes");
INSERT INTO `wp_options` VALUES("55", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("56", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("57", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("58", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("59", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("60", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("61", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("62", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("63", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("64", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("65", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("66", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("67", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("68", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("69", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("70", "close_comments_for_old_posts", "", "yes");
INSERT INTO `wp_options` VALUES("71", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("72", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("73", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("74", "page_comments", "", "yes");
INSERT INTO `wp_options` VALUES("75", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("76", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("77", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("78", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("79", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("80", "widget_text", "a:4:{i:1;a:0:{}i:2;a:3:{s:5:\"title\";s:12:\"O nas widget\";s:4:\"text\";s:285:\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur pulvinar in nunc nec condimentum. Donec a pharetra turpis. Curabitur ac nulla quis elit tempus consequat vel sit amet nisi. Curabitur ac nulla quis elit tempus consequat vel sit amet nisi. Curabitur ac nulla quis nisi.\";s:6:\"filter\";b:0;}i:3;a:3:{s:5:\"title\";s:14:\"Kontakt z nami\";s:4:\"text\";s:618:\"<div class=\"footer-contact-item\">\r\n	<div class=\"footer-contact-item-icon\">\r\n		<i class=\"fa fa-envelope-square\"></i>\r\n	</div>\r\n	<h4>biuro@strefakursow.pl</h4>\r\n</div>\r\n<div class=\"footer-contact-item\">\r\n	<div class=\"footer-contact-item-icon\">\r\n		<i class=\"fa fa-phone\"></i>\r\n	</div>\r\n	<h4>tel. 888-223-111</h4>\r\n</div>\r\n<div class=\"footer-contact-item\">\r\n	<div class=\"footer-contact-item-icon\">\r\n		<i class=\"fa fa-phone\"></i>\r\n	</div>\r\n	<h4>tel. 888-223-111</h4>\r\n</div>\r\n<div class=\"footer-contact-item\">\r\n	<div class=\"footer-contact-item-icon\">\r\n		<i class=\"fa fa-home\"></i>\r\n	</div>\r\n	<h4>33-100 Tarnów</h4>\r\n</div>\";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("81", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("82", "uninstall_plugins", "a:0:{}", "no");
INSERT INTO `wp_options` VALUES("83", "timezone_string", "Europe/Warsaw", "yes");
INSERT INTO `wp_options` VALUES("84", "page_for_posts", "7", "yes");
INSERT INTO `wp_options` VALUES("85", "page_on_front", "5", "yes");
INSERT INTO `wp_options` VALUES("86", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("87", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("88", "initial_db_version", "31535", "yes");
INSERT INTO `wp_options` VALUES("89", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:62:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("90", "_transient_random_seed", "97ec559f8b08b3bb5063d8cf12a2baa0", "yes");
INSERT INTO `wp_options` VALUES("91", "widget_search", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("92", "widget_recent-posts", "a:3:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;s:9:\"show_date\";b:1;}i:3;a:3:{s:5:\"title\";s:15:\"Najnowsze wpisy\";s:6:\"number\";i:4;s:9:\"show_date\";b:1;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("93", "widget_recent-comments", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("94", "widget_archives", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("95", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("96", "sidebars_widgets", "a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:4:{i:0;s:14:\"recent-posts-2\";i:1;s:10:\"archives-2\";i:2;s:12:\"categories-2\";i:3;s:6:\"meta-2\";}s:8:\"footer-1\";a:1:{i:0;s:6:\"text-2\";}s:8:\"footer-2\";a:1:{i:0;s:14:\"recent-posts-3\";}s:8:\"footer-3\";a:1:{i:0;s:6:\"text-3\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("99", "cron", "a:5:{i:1434979543;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1434982066;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1434982249;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1435000380;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("118", "can_compress_scripts", "0", "yes");
INSERT INTO `wp_options` VALUES("134", "_site_transient_timeout_available_translations", "1433869680", "yes");
INSERT INTO `wp_options` VALUES("135", "_site_transient_available_translations", "a:56:{s:2:\"ar\";a:8:{s:8:\"language\";s:2:\"ar\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:57:37\";s:12:\"english_name\";s:6:\"Arabic\";s:11:\"native_name\";s:14:\"العربية\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/ar.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ar\";i:2;s:3:\"ara\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"المتابعة\";}}s:2:\"az\";a:8:{s:8:\"language\";s:2:\"az\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-06-01 14:30:22\";s:12:\"english_name\";s:11:\"Azerbaijani\";s:11:\"native_name\";s:16:\"Azərbaycan dili\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/az.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"az\";i:2;s:3:\"aze\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Davam\";}}s:5:\"bg_BG\";a:8:{s:8:\"language\";s:5:\"bg_BG\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-27 06:36:25\";s:12:\"english_name\";s:9:\"Bulgarian\";s:11:\"native_name\";s:18:\"Български\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/bg_BG.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bg\";i:2;s:3:\"bul\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:22:\"Продължение\";}}s:5:\"bs_BA\";a:8:{s:8:\"language\";s:5:\"bs_BA\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-25 18:55:51\";s:12:\"english_name\";s:7:\"Bosnian\";s:11:\"native_name\";s:8:\"Bosanski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/bs_BA.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bs\";i:2;s:3:\"bos\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:2:\"ca\";a:8:{s:8:\"language\";s:2:\"ca\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-24 05:23:15\";s:12:\"english_name\";s:7:\"Catalan\";s:11:\"native_name\";s:7:\"Català\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/ca.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ca\";i:2;s:3:\"cat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:2:\"cy\";a:8:{s:8:\"language\";s:2:\"cy\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-30 08:59:10\";s:12:\"english_name\";s:5:\"Welsh\";s:11:\"native_name\";s:7:\"Cymraeg\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/cy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cy\";i:2;s:3:\"cym\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Parhau\";}}s:5:\"da_DK\";a:8:{s:8:\"language\";s:5:\"da_DK\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-06-03 00:26:43\";s:12:\"english_name\";s:6:\"Danish\";s:11:\"native_name\";s:5:\"Dansk\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/da_DK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"da\";i:2;s:3:\"dan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Forts&#230;t\";}}s:5:\"de_CH\";a:8:{s:8:\"language\";s:5:\"de_CH\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:20:\"German (Switzerland)\";s:11:\"native_name\";s:17:\"Deutsch (Schweiz)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/de_CH.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Fortfahren\";}}s:5:\"de_DE\";a:8:{s:8:\"language\";s:5:\"de_DE\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-06-08 18:20:33\";s:12:\"english_name\";s:6:\"German\";s:11:\"native_name\";s:7:\"Deutsch\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/de_DE.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Fortfahren\";}}s:2:\"el\";a:8:{s:8:\"language\";s:2:\"el\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-06-01 09:29:51\";s:12:\"english_name\";s:5:\"Greek\";s:11:\"native_name\";s:16:\"Ελληνικά\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/el.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"el\";i:2;s:3:\"ell\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"Συνέχεια\";}}s:5:\"en_AU\";a:8:{s:8:\"language\";s:5:\"en_AU\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:09\";s:12:\"english_name\";s:19:\"English (Australia)\";s:11:\"native_name\";s:19:\"English (Australia)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/en_AU.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_GB\";a:8:{s:8:\"language\";s:5:\"en_GB\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:09\";s:12:\"english_name\";s:12:\"English (UK)\";s:11:\"native_name\";s:12:\"English (UK)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/en_GB.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_CA\";a:8:{s:8:\"language\";s:5:\"en_CA\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:16:\"English (Canada)\";s:11:\"native_name\";s:16:\"English (Canada)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/en_CA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"eo\";a:8:{s:8:\"language\";s:2:\"eo\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:09\";s:12:\"english_name\";s:9:\"Esperanto\";s:11:\"native_name\";s:9:\"Esperanto\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/eo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eo\";i:2;s:3:\"epo\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Daŭrigi\";}}s:5:\"es_PE\";a:8:{s:8:\"language\";s:5:\"es_PE\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-25 13:39:01\";s:12:\"english_name\";s:14:\"Spanish (Peru)\";s:11:\"native_name\";s:17:\"Español de Perú\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/es_PE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_ES\";a:8:{s:8:\"language\";s:5:\"es_ES\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-06-04 14:48:26\";s:12:\"english_name\";s:15:\"Spanish (Spain)\";s:11:\"native_name\";s:8:\"Español\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/es_ES.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"es\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_MX\";a:8:{s:8:\"language\";s:5:\"es_MX\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-29 17:53:27\";s:12:\"english_name\";s:16:\"Spanish (Mexico)\";s:11:\"native_name\";s:19:\"Español de México\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/es_MX.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CL\";a:8:{s:8:\"language\";s:5:\"es_CL\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-04 19:47:01\";s:12:\"english_name\";s:15:\"Spanish (Chile)\";s:11:\"native_name\";s:17:\"Español de Chile\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.0/es_CL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:2:\"eu\";a:8:{s:8:\"language\";s:2:\"eu\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:09\";s:12:\"english_name\";s:6:\"Basque\";s:11:\"native_name\";s:7:\"Euskara\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/eu.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eu\";i:2;s:3:\"eus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Jarraitu\";}}s:5:\"fa_IR\";a:8:{s:8:\"language\";s:5:\"fa_IR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-16 10:01:41\";s:12:\"english_name\";s:7:\"Persian\";s:11:\"native_name\";s:10:\"فارسی\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/fa_IR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fa\";i:2;s:3:\"fas\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:2:\"fi\";a:8:{s:8:\"language\";s:2:\"fi\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-15 10:49:37\";s:12:\"english_name\";s:7:\"Finnish\";s:11:\"native_name\";s:5:\"Suomi\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/fi.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fi\";i:2;s:3:\"fin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Jatka\";}}s:5:\"fr_FR\";a:8:{s:8:\"language\";s:5:\"fr_FR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-29 17:08:38\";s:12:\"english_name\";s:15:\"French (France)\";s:11:\"native_name\";s:9:\"Français\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/fr_FR.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"fr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:2:\"gd\";a:8:{s:8:\"language\";s:2:\"gd\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-05 17:37:43\";s:12:\"english_name\";s:15:\"Scottish Gaelic\";s:11:\"native_name\";s:9:\"Gàidhlig\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.0/gd.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"gd\";i:2;s:3:\"gla\";i:3;s:3:\"gla\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"Lean air adhart\";}}s:5:\"gl_ES\";a:8:{s:8:\"language\";s:5:\"gl_ES\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:8:\"Galician\";s:11:\"native_name\";s:6:\"Galego\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/gl_ES.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"gl\";i:2;s:3:\"glg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:3:\"haz\";a:8:{s:8:\"language\";s:3:\"haz\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-26 15:20:27\";s:12:\"english_name\";s:8:\"Hazaragi\";s:11:\"native_name\";s:15:\"هزاره گی\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1.5/haz.zip\";s:3:\"iso\";a:1:{i:2;s:3:\"haz\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:5:\"he_IL\";a:8:{s:8:\"language\";s:5:\"he_IL\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 19:32:58\";s:12:\"english_name\";s:6:\"Hebrew\";s:11:\"native_name\";s:16:\"עִבְרִית\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/he_IL.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"he\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"להמשיך\";}}s:2:\"hr\";a:8:{s:8:\"language\";s:2:\"hr\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-27 08:22:08\";s:12:\"english_name\";s:8:\"Croatian\";s:11:\"native_name\";s:8:\"Hrvatski\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/hr.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hr\";i:2;s:3:\"hrv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:5:\"hu_HU\";a:8:{s:8:\"language\";s:5:\"hu_HU\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:43:50\";s:12:\"english_name\";s:9:\"Hungarian\";s:11:\"native_name\";s:6:\"Magyar\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/hu_HU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hu\";i:2;s:3:\"hun\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Tovább\";}}s:5:\"id_ID\";a:8:{s:8:\"language\";s:5:\"id_ID\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 07:07:32\";s:12:\"english_name\";s:10:\"Indonesian\";s:11:\"native_name\";s:16:\"Bahasa Indonesia\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/id_ID.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"id\";i:2;s:3:\"ind\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Lanjutkan\";}}s:5:\"is_IS\";a:8:{s:8:\"language\";s:5:\"is_IS\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-27 11:14:20\";s:12:\"english_name\";s:9:\"Icelandic\";s:11:\"native_name\";s:9:\"Íslenska\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/is_IS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"is\";i:2;s:3:\"isl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Áfram\";}}s:5:\"it_IT\";a:8:{s:8:\"language\";s:5:\"it_IT\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-31 19:34:18\";s:12:\"english_name\";s:7:\"Italian\";s:11:\"native_name\";s:8:\"Italiano\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/it_IT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"it\";i:2;s:3:\"ita\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:2:\"ja\";a:8:{s:8:\"language\";s:2:\"ja\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-06-07 07:33:53\";s:12:\"english_name\";s:8:\"Japanese\";s:11:\"native_name\";s:9:\"日本語\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/ja.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"ja\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"続ける\";}}s:5:\"ko_KR\";a:8:{s:8:\"language\";s:5:\"ko_KR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:57:22\";s:12:\"english_name\";s:6:\"Korean\";s:11:\"native_name\";s:9:\"한국어\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/ko_KR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ko\";i:2;s:3:\"kor\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"계속\";}}s:5:\"lt_LT\";a:8:{s:8:\"language\";s:5:\"lt_LT\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:10:\"Lithuanian\";s:11:\"native_name\";s:15:\"Lietuvių kalba\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/lt_LT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lt\";i:2;s:3:\"lit\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Tęsti\";}}s:5:\"my_MM\";a:8:{s:8:\"language\";s:5:\"my_MM\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-26 15:57:42\";s:12:\"english_name\";s:17:\"Myanmar (Burmese)\";s:11:\"native_name\";s:15:\"ဗမာစာ\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.1.5/my_MM.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"my\";i:2;s:3:\"mya\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:54:\"ဆက်လက်လုပ်ေဆာင်ပါ။\";}}s:5:\"nb_NO\";a:8:{s:8:\"language\";s:5:\"nb_NO\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-27 10:29:43\";s:12:\"english_name\";s:19:\"Norwegian (Bokmål)\";s:11:\"native_name\";s:13:\"Norsk bokmål\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/nb_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nb\";i:2;s:3:\"nob\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Fortsett\";}}s:5:\"nl_NL\";a:8:{s:8:\"language\";s:5:\"nl_NL\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:59:29\";s:12:\"english_name\";s:5:\"Dutch\";s:11:\"native_name\";s:10:\"Nederlands\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/nl_NL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nn_NO\";a:8:{s:8:\"language\";s:5:\"nn_NO\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-06-08 07:10:14\";s:12:\"english_name\";s:19:\"Norwegian (Nynorsk)\";s:11:\"native_name\";s:13:\"Norsk nynorsk\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/nn_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nn\";i:2;s:3:\"nno\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Hald fram\";}}s:3:\"oci\";a:8:{s:8:\"language\";s:3:\"oci\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-25 19:53:10\";s:12:\"english_name\";s:7:\"Occitan\";s:11:\"native_name\";s:7:\"Occitan\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.2.2/oci.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"oc\";i:2;s:3:\"oci\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Contunhar\";}}s:5:\"pl_PL\";a:8:{s:8:\"language\";s:5:\"pl_PL\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-09 10:15:05\";s:12:\"english_name\";s:6:\"Polish\";s:11:\"native_name\";s:6:\"Polski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/pl_PL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pl\";i:2;s:3:\"pol\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Kontynuuj\";}}s:2:\"ps\";a:8:{s:8:\"language\";s:2:\"ps\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-29 22:19:48\";s:12:\"english_name\";s:6:\"Pashto\";s:11:\"native_name\";s:8:\"پښتو\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.1.5/ps.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"ps\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"دوام\";}}s:5:\"pt_PT\";a:8:{s:8:\"language\";s:5:\"pt_PT\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-27 09:25:14\";s:12:\"english_name\";s:21:\"Portuguese (Portugal)\";s:11:\"native_name\";s:10:\"Português\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/pt_PT.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"pt_BR\";a:8:{s:8:\"language\";s:5:\"pt_BR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 06:44:19\";s:12:\"english_name\";s:19:\"Portuguese (Brazil)\";s:11:\"native_name\";s:20:\"Português do Brasil\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/pt_BR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pt\";i:2;s:3:\"por\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"ro_RO\";a:8:{s:8:\"language\";s:5:\"ro_RO\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-21 15:14:01\";s:12:\"english_name\";s:8:\"Romanian\";s:11:\"native_name\";s:8:\"Română\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/ro_RO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ro\";i:2;s:3:\"ron\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuă\";}}s:5:\"ru_RU\";a:8:{s:8:\"language\";s:5:\"ru_RU\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-31 11:58:44\";s:12:\"english_name\";s:7:\"Russian\";s:11:\"native_name\";s:14:\"Русский\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/ru_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ru\";i:2;s:3:\"rus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продолжить\";}}s:5:\"sk_SK\";a:8:{s:8:\"language\";s:5:\"sk_SK\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 09:29:23\";s:12:\"english_name\";s:6:\"Slovak\";s:11:\"native_name\";s:11:\"Slovenčina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/sk_SK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sk\";i:2;s:3:\"slk\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Pokračovať\";}}s:5:\"sl_SI\";a:8:{s:8:\"language\";s:5:\"sl_SI\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-26 16:25:46\";s:12:\"english_name\";s:9:\"Slovenian\";s:11:\"native_name\";s:13:\"Slovenščina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.1.5/sl_SI.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sl\";i:2;s:3:\"slv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Nadaljujte\";}}s:2:\"sq\";a:8:{s:8:\"language\";s:2:\"sq\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-29 08:27:12\";s:12:\"english_name\";s:8:\"Albanian\";s:11:\"native_name\";s:5:\"Shqip\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/sq.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sq\";i:2;s:3:\"sqi\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Vazhdo\";}}s:5:\"sr_RS\";a:8:{s:8:\"language\";s:5:\"sr_RS\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-06-04 20:54:02\";s:12:\"english_name\";s:7:\"Serbian\";s:11:\"native_name\";s:23:\"Српски језик\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/sr_RS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sr\";i:2;s:3:\"srp\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:14:\"Настави\";}}s:5:\"sv_SE\";a:8:{s:8:\"language\";s:5:\"sv_SE\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 07:08:28\";s:12:\"english_name\";s:7:\"Swedish\";s:11:\"native_name\";s:7:\"Svenska\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/sv_SE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sv\";i:2;s:3:\"swe\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Fortsätt\";}}s:2:\"th\";a:8:{s:8:\"language\";s:2:\"th\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 15:16:26\";s:12:\"english_name\";s:4:\"Thai\";s:11:\"native_name\";s:9:\"ไทย\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/th.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"th\";i:2;s:3:\"tha\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"ต่อไป\";}}s:5:\"tr_TR\";a:8:{s:8:\"language\";s:5:\"tr_TR\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-26 07:01:28\";s:12:\"english_name\";s:7:\"Turkish\";s:11:\"native_name\";s:8:\"Türkçe\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/tr_TR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tr\";i:2;s:3:\"tur\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Devam\";}}s:5:\"ug_CN\";a:8:{s:8:\"language\";s:5:\"ug_CN\";s:7:\"version\";s:5:\"4.1.5\";s:7:\"updated\";s:19:\"2015-03-26 16:45:38\";s:12:\"english_name\";s:6:\"Uighur\";s:11:\"native_name\";s:9:\"Uyƣurqə\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.1.5/ug_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ug\";i:2;s:3:\"uig\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:26:\"داۋاملاشتۇرۇش\";}}s:2:\"uk\";a:8:{s:8:\"language\";s:2:\"uk\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-05-28 13:43:48\";s:12:\"english_name\";s:9:\"Ukrainian\";s:11:\"native_name\";s:20:\"Українська\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.2.2/uk.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"uk\";i:2;s:3:\"ukr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продовжити\";}}s:5:\"zh_TW\";a:8:{s:8:\"language\";s:5:\"zh_TW\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-29 06:37:03\";s:12:\"english_name\";s:16:\"Chinese (Taiwan)\";s:11:\"native_name\";s:12:\"繁體中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/zh_TW.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"繼續\";}}s:5:\"zh_CN\";a:8:{s:8:\"language\";s:5:\"zh_CN\";s:7:\"version\";s:5:\"4.2.2\";s:7:\"updated\";s:19:\"2015-04-23 15:23:08\";s:12:\"english_name\";s:15:\"Chinese (China)\";s:11:\"native_name\";s:12:\"简体中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.2.2/zh_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"继续\";}}}", "yes");
INSERT INTO `wp_options` VALUES("136", "WPLANG", "pl_PL", "yes");
INSERT INTO `wp_options` VALUES("142", "rewrite_rules", "a:71:{s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:38:\"index.php?&page_id=5&cpage=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:58:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:68:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:88:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/trackback/?$\";s:85:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&tb=1\";s:77:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:65:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/page/?([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&paged=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/comment-page-([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&cpage=$matches[5]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)(/[0-9]+)?/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&page=$matches[5]\";s:47:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:57:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:77:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&cpage=$matches[4]\";s:51:\"([0-9]{4})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&cpage=$matches[3]\";s:38:\"([0-9]{4})/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&cpage=$matches[2]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";}", "yes");
INSERT INTO `wp_options` VALUES("147", "_site_transient_timeout_wporg_theme_feature_list", "1433871521", "yes");
INSERT INTO `wp_options` VALUES("148", "_site_transient_wporg_theme_feature_list", "a:4:{s:6:\"Colors\";a:15:{i:0;s:5:\"black\";i:1;s:4:\"blue\";i:2;s:5:\"brown\";i:3;s:4:\"gray\";i:4;s:5:\"green\";i:5;s:6:\"orange\";i:6;s:4:\"pink\";i:7;s:6:\"purple\";i:8;s:3:\"red\";i:9;s:6:\"silver\";i:10;s:3:\"tan\";i:11;s:5:\"white\";i:12;s:6:\"yellow\";i:13;s:4:\"dark\";i:14;s:5:\"light\";}s:6:\"Layout\";a:9:{i:0;s:12:\"fixed-layout\";i:1;s:12:\"fluid-layout\";i:2;s:17:\"responsive-layout\";i:3;s:10:\"one-column\";i:4;s:11:\"two-columns\";i:5;s:13:\"three-columns\";i:6;s:12:\"four-columns\";i:7;s:12:\"left-sidebar\";i:8;s:13:\"right-sidebar\";}s:8:\"Features\";a:20:{i:0;s:19:\"accessibility-ready\";i:1;s:8:\"blavatar\";i:2;s:10:\"buddypress\";i:3;s:17:\"custom-background\";i:4;s:13:\"custom-colors\";i:5;s:13:\"custom-header\";i:6;s:11:\"custom-menu\";i:7;s:12:\"editor-style\";i:8;s:21:\"featured-image-header\";i:9;s:15:\"featured-images\";i:10;s:15:\"flexible-header\";i:11;s:20:\"front-page-post-form\";i:12;s:19:\"full-width-template\";i:13;s:12:\"microformats\";i:14;s:12:\"post-formats\";i:15;s:20:\"rtl-language-support\";i:16;s:11:\"sticky-post\";i:17;s:13:\"theme-options\";i:18;s:17:\"threaded-comments\";i:19;s:17:\"translation-ready\";}s:7:\"Subject\";a:3:{i:0;s:7:\"holiday\";i:1;s:13:\"photoblogging\";i:2;s:8:\"seasonal\";}}", "yes");
INSERT INTO `wp_options` VALUES("149", "widget_tag_cloud", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("150", "widget_calendar", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("152", "widget_pages", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("154", "widget_nav_menu", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("160", "current_theme", "MaterialWP", "yes");
INSERT INTO `wp_options` VALUES("161", "theme_mods_materialwp-materialwp", "a:2:{i:0;b:0;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1433920852;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `wp_options` VALUES("162", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("187", "theme_mods_strefawp", "a:2:{i:0;b:0;s:18:\"nav_menu_locations\";a:1:{s:7:\"primary\";i:4;}}", "yes");
INSERT INTO `wp_options` VALUES("190", "theme_mods_twentyfifteen", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1433921661;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `wp_options` VALUES("197", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("198", "fw_active_extensions", "a:10:{s:4:\"blog\";a:0:{}s:6:\"update\";a:0:{}s:13:\"github-update\";a:0:{}s:10:\"shortcodes\";a:0:{}s:12:\"page-builder\";a:0:{}s:17:\"editor-shortcodes\";a:0:{}s:7:\"builder\";a:0:{}s:5:\"forms\";a:0:{}s:13:\"contact-forms\";a:0:{}s:6:\"mailer\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("202", "_site_transient_timeout_fw_ext_manager_gh_download", "1433929184", "yes");
INSERT INTO `wp_options` VALUES("203", "_site_transient_fw_ext_manager_gh_download", "a:5:{s:37:\"ThemeFuse/Unyson-Shortcodes-Extension\";a:2:{s:11:\"zipball_url\";s:76:\"https://github.com/ThemeFuse/Unyson-Shortcodes-Extension/archive/v1.2.12.zip\";s:8:\"tag_name\";s:7:\"v1.2.12\";}s:38:\"ThemeFuse/Unyson-PageBuilder-Extension\";a:2:{s:11:\"zipball_url\";s:76:\"https://github.com/ThemeFuse/Unyson-PageBuilder-Extension/archive/v1.3.8.zip\";s:8:\"tag_name\";s:6:\"v1.3.8\";}s:34:\"ThemeFuse/Unyson-Builder-Extension\";a:2:{s:11:\"zipball_url\";s:73:\"https://github.com/ThemeFuse/Unyson-Builder-Extension/archive/v1.1.10.zip\";s:8:\"tag_name\";s:7:\"v1.1.10\";}s:32:\"ThemeFuse/Unyson-Forms-Extension\";a:2:{s:11:\"zipball_url\";s:70:\"https://github.com/ThemeFuse/Unyson-Forms-Extension/archive/v2.0.7.zip\";s:8:\"tag_name\";s:6:\"v2.0.7\";}s:33:\"ThemeFuse/Unyson-Mailer-Extension\";a:2:{s:11:\"zipball_url\";s:71:\"https://github.com/ThemeFuse/Unyson-Mailer-Extension/archive/v1.2.1.zip\";s:8:\"tag_name\";s:6:\"v1.2.1\";}}", "yes");
INSERT INTO `wp_options` VALUES("204", "fw_ext_settings_options:page-builder", "a:1:{s:10:\"post_types\";a:1:{s:4:\"page\";b:1;}}", "yes");
INSERT INTO `wp_options` VALUES("207", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("228", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("232", "_site_transient_timeout_browser_5e138ea562421d58242bbd9530e551ca", "1434550908", "yes");
INSERT INTO `wp_options` VALUES("233", "_site_transient_browser_5e138ea562421d58242bbd9530e551ca", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"43.0.2357.124\";s:10:\"update_url\";s:28:\"http://www.google.com/chrome\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/chrome.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/chrome.png\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("399", "_site_transient_timeout_browser_8ca75efe5d363f5ae57ae639e5f0a0e3", "1435133122", "yes");
INSERT INTO `wp_options` VALUES("400", "_site_transient_browser_8ca75efe5d363f5ae57ae639e5f0a0e3", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:7:\"Firefox\";s:7:\"version\";s:4:\"38.0\";s:10:\"update_url\";s:23:\"http://www.firefox.com/\";s:7:\"img_src\";s:50:\"http://s.wordpress.org/images/browsers/firefox.png\";s:11:\"img_src_ssl\";s:49:\"https://wordpress.org/images/browsers/firefox.png\";s:15:\"current_version\";s:2:\"16\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("421", "metaslider_systemcheck", "a:2:{s:16:\"wordPressVersion\";b:0;s:12:\"imageLibrary\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("422", "ml-slider_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("457", "wpcf7", "a:1:{s:7:\"version\";s:3:\"4.1\";}", "yes");
INSERT INTO `wp_options` VALUES("514", "_site_transient_timeout_theme_roots", "1434958384", "yes");
INSERT INTO `wp_options` VALUES("515", "_site_transient_theme_roots", "a:4:{s:8:\"strefawp\";s:7:\"/themes\";s:13:\"twentyfifteen\";s:7:\"/themes\";s:14:\"twentyfourteen\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("517", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:65:\"https://downloads.wordpress.org/release/pl_PL/wordpress-4.2.2.zip\";s:6:\"locale\";s:5:\"pl_PL\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:65:\"https://downloads.wordpress.org/release/pl_PL/wordpress-4.2.2.zip\";s:10:\"no_content\";b:0;s:11:\"new_bundled\";b:0;s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"4.2.2\";s:7:\"version\";s:5:\"4.2.2\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"4.1\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1434957191;s:15:\"version_checked\";s:5:\"4.2.2\";s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("518", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1434957205;s:7:\"checked\";a:4:{s:8:\"strefawp\";s:5:\"0.0.3\";s:13:\"twentyfifteen\";s:3:\"1.2\";s:14:\"twentyfourteen\";s:3:\"1.4\";s:14:\"twentythirteen\";s:3:\"1.5\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("520", "_site_transient_timeout_fw_ext_upd_gh_fw", "1435043007", "yes");
INSERT INTO `wp_options` VALUES("521", "_site_transient_fw_ext_upd_gh_fw", "a:7:{s:31:\"ThemeFuse/Unyson-Blog-Extension\";s:6:\"v1.0.0\";s:34:\"ThemeFuse/Unyson-Builder-Extension\";s:7:\"v1.1.10\";s:32:\"ThemeFuse/Unyson-Forms-Extension\";s:6:\"v2.0.8\";s:33:\"ThemeFuse/Unyson-Mailer-Extension\";s:6:\"v1.2.1\";s:37:\"ThemeFuse/Unyson-Shortcodes-Extension\";s:7:\"v1.2.12\";s:38:\"ThemeFuse/Unyson-PageBuilder-Extension\";s:6:\"v1.3.8\";s:33:\"ThemeFuse/Unyson-Update-Extension\";s:6:\"v1.0.6\";}", "yes");
INSERT INTO `wp_options` VALUES("522", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1434999809", "no");
INSERT INTO `wp_options` VALUES("523", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1434999809", "no");
INSERT INTO `wp_options` VALUES("524", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1434956609", "no");
INSERT INTO `wp_options` VALUES("525", "_transient_timeout_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "1434999811", "no");
INSERT INTO `wp_options` VALUES("526", "_transient_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Matt: Ornette Coleman’s Sound Grammar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45161\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://ma.tt/2015/06/ornette-colemans-sound-grammar/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:413:\"<p>Slate memorializes the passing of jazz great Ornette Coleman <a href=\"http://www.slate.com/articles/arts/music_box/2006/10/take_the_o_train.html\">with a review of his recent album Sound Grammar, covering what they call the key to understanding the legend&#8217;s &#8220;harmolodic&#8221; music</a>. Also check out <a href=\"http://jazz-quotes.com/artist/ornette-coleman/\">some jazz quotes from Coleman</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 22 Jun 2015 05:34:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Matt: Om on Apple and Google\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45168\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://ma.tt/2015/06/om-on-apple-and-google/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:165:\"<p>Writing for the New Yorker (!) <a href=\"http://www.newyorker.com/business/currency/apple-versus-google\">Om Malik compares and contrasts Apple and Google</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 21 Jun 2015 04:04:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Matt: Funnel Framework\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45166\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"http://ma.tt/2015/06/funnel-framework/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:377:\"<blockquote><p>The Internet has removed scarcity, meaning business models based on controlling distribution are no longer viable. Instead, the key to success is controlling access to the best customers — and that means being the best.</p></blockquote>\n<p>Read all of Ben Thompson&#8217;s <a href=\"https://stratechery.com/2015/the-funnel-framework/\">Funnel Framework</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 20 Jun 2015 05:30:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Post Status: A future API\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=13468\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"https://poststatus.com/a-future-api/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:12305:\"<p>The year is 2020. WordPress powers over 35% of the web now. The REST API has been in WordPress core for a few years; the year after the REST API was merged into core, WordPress gained nearly 5% marketshare.</p>\n<p>Almost all WordPress sites use the REST API in some form or another, and an estimated 15% of all native apps use WordPress purely as a backend. 80% of the top 100 news websites run WordPress with front-ends powered by the REST API. A dozen popular hosted website platforms have custom admins or front-end editors that use the API.</p>\n<p>All of the &#8220;we should get to this eventually&#8221; items have actually been done, unbelievably, and we&#8217;ve entered the Golden Age of the WordPress REST API.</p>\n<p>Many people all across the web are using the API. Here are some of their stories.</p>\n<h3>Jack, A YouTube User</h3>\n<p>Meet Jack. He&#8217;s an avid follower of various different YouTube channels, some of which are 15 years old now. YouTube is still one of the biggest media companies, especially since the number of hamsterkitten videos has skyrocketed since the animal was first crossbred in 2018. Jack runs a fan site that has a few thousand hits a day, which is not a huge site, but roughly in the middle of the long-tail of WordPress sites. He hopes to grow it further though.</p>\n<p>Jack&#8217;s just seen a great new video pop up on the new video feed. After having watched it (and taken extensive notes), he decides to share it with his followers on his WordPress site. Underneath the video, he taps on the &#8220;Share on WordPress&#8221; link.</p>\n<p><img class=\"alignnone size-large wp-image-13470\" src=\"https://poststatus.com/wp-content/uploads/2015/06/api-sharetowp-752x233.png\" alt=\"api-sharetowp\" width=\"752\" height=\"233\" /> Due to the decentralized nature of WordPress sites, YouTube can&#8217;t register with Jack&#8217;s site directly without a lot of effort. Instead, YouTube has registered with WordPress.org as a client beforehand (just like a normal centralized service). WordPress.org acts as a middleman between centralized services and clients, and the millions of WordPress installs out there on the &#8216;net.</p>\n<p>YouTube sends Jack off to WordPress.org to create a post. WordPress.org checks and finds that YouTube is a registered client, and they haven&#8217;t been blacklisted or had their tokens revoked.  Usually, WordPress.org would ask Jack to enter his site, but Jack&#8217;s done this before, so his browser has remembered the sites he&#8217;s entered previously. He picks his site from the list (hamsterkitten.com).</p>\n<p><img class=\"alignnone size-large wp-image-13471\" src=\"https://poststatus.com/wp-content/uploads/2015/06/api-connectto-752x351.png\" alt=\"api-connectto\" width=\"752\" height=\"351\" /></p>\n<p>In the background, WordPress.org asks hamsterkitten.com to issue credentials for YouTube, and tells them how to talk to each other directly. (These are OAuth 1.0a credentials, sent over insecure HTTP, since Jack hasn&#8217;t gotten around to setting up his free SSL certificate yet. One of these days&#8230;)</p>\n<p>hamsterkitten.com checks and finds that Jack has already done this before, so YouTube already has a set of credentials ready to go. He&#8217;s also already approved linking his YouTube account to his user account on his site, so he doesn&#8217;t need to approve his account manually. It passes the credentials back to YouTube, and YouTube sends a request back with the video data.</p>\n<p>Jack doesn&#8217;t see any of these happening in the background. His browser sends him off to hamsterkitten.com&#8217;s WordPress admin, where the video is pre-entered into his editor. He adds some witty comments and publishes the post. YouTube then automatically shares the video on his YouTube account as well for him, and automatically sends a notification to his YouTube followers to keep them up-to-date.</p>\n<p>Jack&#8217;s post turns out to be enormously popular, and starts a new wave of hamsterkitten fandom, earning him millions from the movie tie-ins and branding promotions.</p>\n<p>Despite the decentralised nature of WordPress sites, YouTube was able to work seamlessly with Jack&#8217;s site. It used WordPress.org as a middleman to bridge the gap, without sharing any private data with WordPress.org. It did this all while keeping the connection secure over insecure HTTP.</p>\n<h3>Jill, A Mobile Developer</h3>\n<p>On the other side of the world, Jill&#8217;s a mobile developer working on her first app. She&#8217;s heard all about this hamsterkitten craze, and has seen a business opportunity in creating a mobile app to post photos of them wherever you are in the world.</p>\n<p>Jill wants to be able to post to any WordPress site, but can&#8217;t go around and register her app on every site. Instead, she goes and registers her app on WordPress.org, which gives her access to every site with an extra step or two.</p>\n<p>While waiting for her app request to be approved, she sets up a new WordPress test site, which humorously uses the domain wassupwitd.at. (She knows that domain hacks are <em>so</em> early 2000s, but she still likes them.) She registers her client manually on her test site, which issues her with a client key and secret. She starts writing her client using these directly.</p>\n<p>Her client is a pretty basic wrapper around the Camera app that lets you upload directly to your site, but with some tricks up its sleeve. She adds some special functionality for sites with WooCommerce or EDD (which combined now represent 80% of online e-commerce), letting people create new products to sell their photos on their site, all from her app. She lets people upload multiple hamsterkitten photos at once, with support for creating sliders directly in the app.</p>\n<p>After not too long, her app request gets approved, and she&#8217;s given a key and secret to use with WordPress.org. She switches her app over to using those instead. Her app first talks to WordPress.org using this key and secret (hardcoded into the app), which then issues the app credentials for each site it accesses (stored inside the app).</p>\n<p>She wipes her test site and reinstalls it, now running stock WordPress with no real data in it. She hits the &#8220;Connect&#8221; button in her app, which sends her off to WordPress.org. WordPress.org hasn&#8217;t seen Jill before, so it asks her to enter her site&#8217;s address. She enters &#8220;wassupwitd.at&#8221; (laughing again to herself), then hits the continue button.</p>\n<p>WordPress.org hasn&#8217;t seen this site before, so it runs the auto-discovery process internally to find the site. It double-checks the authentication available there, then after making sure the site has the necessary bits enabled, asks the site to create client credentials for the app. It also redirects Jill off to the site.</p>\n<p>The site double-checks the validity of the client by sending a request to WordPress.org in the background, then creates a new client key and secret for the app. It passes these back to the app, and the two begin communicating directly.</p>\n<p>Jill hasn&#8217;t linked her app to this new test site before, so she sees the classic OAuth &#8220;Authorize This App&#8221; page on her site. After logging into her test site, she links the account to her app, and all is well with the world.</p>\n<p>Satisfied that the linking process is working for her, she gets ready to launch her app. She fills out her app details on WordPress.org to appear in the app directory, complete with a funky logo.</p>\n<p>However, disaster strikes! It turns out she made the mistake of posting her client credentials on a public GitHub repository. After reassurances from her colleagues and pets that everyone has done this at least once, she goes about setting it right.</p>\n<p>Her first step is to log on to WordPress.org and revoke her client key and secret from there. Internally, this does a few things. The first and main thing is that it stops clients from linking with new sites, since WordPress.org stops asking sites to issue new credentials when requested. This immediately stops the bleeding, but it doesn&#8217;t clean up any mess that&#8217;s already there.</p>\n<p>The next thing that happens is that WordPress.org adds the client key to the list of revoked clients. This is pulled down by sites automatically as part of their autoupdate check every day, and those sites revoke any credentials for the clients already on the site. This will make Jill&#8217;s site automatically revoke the previously issued client token in the next day, ensuring that it&#8217;s safe even if it&#8217;s already linked.</p>\n<p>Luckily for Jill, her app was still in testing, so there wasn&#8217;t a huge impact. If there was though, the WordPress security team could have assessed the issue to see how urgent it was. In urgent cases, they could check which sites have linked with the client previously and ping them via a backchannel to have them check the revocation list immediately instead. This would ensure maximum security for sites which are known to be affected.</p>\n<p>Now that she&#8217;s revoked her credentials and reissued new ones, she steadies herself, and launches the app. As it turns out, this app is exactly what the hamsterkitten community needed, and it surges to the top of the various app stores in mere hours. Jill goes to sleep that night confident that if any real security issues do pop up, she&#8217;s well-equipped to handle them, and the WordPress security team has her back.</p>\n<h3>Joe, A Server Administrator</h3>\n<p>Joe&#8217;s your regular sysops admin and developer, currently working with a Big Media organization to get their site up and running. He&#8217;s been paranoid about security ever since he left his laptop open at a conference and his colleagues made it yell his name every hour.</p>\n<p>The Big Media organization he&#8217;s working with wants to lock down the site to just a few applications, including their own custom one. Joe totally understands this, so he turns off the automatic client registration on the site. This stops the site from automatically creating credentials for clients registered on WordPress.org, and instead requires manual admin approval.</p>\n<p>He sets up the clients that the organization wants to use (including Kitstergram, Jill&#8217;s app) by running through the WordPress.org process and approving the clients with his administrator account. He then also manually sets up the client credentials for their custom app.</p>\n<p>He goes to bed that night knowing that the site and client are safe. If any problem pops up with Kitstergram, WordPress.org will handle the security for him, meaning he only needs to take care of the custom app security. Well, and his pet hamsterkitten.</p>\n<h3>Jenny, A Theme Developer</h3>\n<p>Themes have improved immensely in the past few years, with Jenny leading the charge through her theme company BooThemes. (As it turns out, spooky themes have really taken off in the past few years.) She&#8217;s been working on super-fast and immersive themes using the API.</p>\n<p>Some of the features that Jenny&#8217;s really proud of in her themes include live commenting and offline reading support. She also sells premium add-ons for bbPress and BuddyPress, which add tonnes of extra live features using their APIs.</p>\n<p>Despite writing themes that need to work across all the sites she interacts with, Jenny doesn&#8217;t worry about compatibility. Since the API is backwards compatible, she writes code for the latest version of WordPress and has it just work. She&#8217;s confident that any bugs will be fixed in the normal WordPress update process. Plus, having the API as part of WordPress core means she doesn&#8217;t have to worry about having her users run through a complex install process.</p>\n<h3>Ryan, An API Developer</h3>\n<p>After many years of working on the API, Ryan&#8217;s pleased that it&#8217;s finally been merged into core. Although it took a lot of hard work, it was worth all the effort after all. He now spends his time not worrying about which release of WordPress the API is going to be merged into.</p>\n<p>Of course, all these scenarios are just in Ryan&#8217;s head. He can be a little crazy at times. He can dream though, right?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 20 Jun 2015 02:02:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Ryan McCue\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WPTavern: WordPress.tv is Branching Out Into Beginner Tutorial Videos\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45264\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wptavern.com/wordpress-tv-is-branching-out-into-beginner-tutorial-videos\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4299:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/wordpress-tv.png\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/wordpress-tv.png?resize=1025%2C440\" alt=\"wordpress-tv\" class=\"aligncenter size-full wp-image-45425\" /></a></p>\n<p><a href=\"http://wordpress.tv/\" target=\"_blank\">WordPress.tv</a> is expanding its video catalog beyond WordCamp session recordings. As most of the video content on the site centers around topics for developers and established users, the WPTV team is now <a href=\"https://make.wordpress.org/community/2015/06/16/do-you-screencast-or-make-video-tutorials-of-how-to-use-wordpress-wordpress-tv-wants-you/\" target=\"_blank\">actively soliciting submissions</a> for more beginner video tutorials.</p>\n<blockquote><p>Are you a proud member of the WordPress community, who creates (or would like to create) videos that are focused on helping others learn how to use WordPress? If you answered “yes” then we would love your help in submitting your videos to WordPress.tv, so we can share them with the world in our “how to” section.</p></blockquote>\n<p>The current &#8220;<a href=\"http://wordpress.tv/category/how-to/\" target=\"_blank\">how-to</a>&#8221; category on the site contains mostly outdated videos, featuring ancient versions of WordPress. The WPTV team is hoping to add more &#8220;getting started&#8221; content that covers basic WordPress site management, including the following:</p>\n<ul>\n<li>How to configure widgets</li>\n<li>Setting up a custom menu</li>\n<li>Managing comments</li>\n<li>How to insert an image gallery</li>\n</ul>\n<p>The initiative to add more beginner content is not new but failed to gain traction in previous attempts.</p>\n<p>&#8220;Uptake was slow, so we thought it would be a good idea to give it a go again, and put a bit more structure to it,&#8221; WPTV contributor Jerry Bates said.</p>\n<p>One guideline in particular that was a sticking point the last time the group solicited tutorials was the requirement of no self-promotion or logos in the videos. Contributors have to submit their work for sheer love of the community, which makes it more difficult to gather submissions.</p>\n<blockquote><p>While we want you to be able to benefit from your work, WordPress.tv is a non-commercial community-run website; we can’t accept videos with watermarks, logos, or self-promotion of any kind. We do have a place for you to enter your WordPress.org profile name as a producer credit, so you will get noticed!</p></blockquote>\n<p>So far, the WPTV team has not received many submissions, but the demand for beginner content is there. According to Bates, some of the most viewed videos are consistently the beginner tutorials, despite the fact that they are outdated.</p>\n<p>&#8220;This is a popular video type on YouTube and in for-pay training courses, but I think the greatest need is for foundation-level videos,&#8221; Bates said. &#8220;Anything that would help a new user on day one, week one, etc.&#8221;</p>\n<p>&#8220;We need more short and to-the-point tutorials,&#8221; WPTV crew member Michael Wiginton said. &#8220;Most will not want to watch a 45 minute video when trying to find an answer.&#8221;</p>\n<p>The team is also experimenting with a plugin that would bring these tutorial videos into the WordPress dashboard, but the first step is to build a library of suitable beginner content.</p>\n<p>WordCamp recordings provide a never-ending funnel of content down to WordPress.tv, but only a small slice of these videos are useful for beginners. If WordPress is going to continue to grow its marketshare, the project cannot depend on only providing developer-oriented videos and education. A strong beginner tutorials section on WordPress.tv is a worthy project that will help support new users.</p>\n<p>The WPTV crew is a small team, averaging just 5-6 active volunteers. Creating and moderating videos is one unique way to contribute to the WordPress project that doesn&#8217;t require writing code. If you&#8217;re interested to submit some beginner tutorials, check out the <a href=\"https://make.wordpress.org/community/2015/06/16/do-you-screencast-or-make-video-tutorials-of-how-to-use-wordpress-wordpress-tv-wants-you/\" target=\"_blank\">suggestions and guidelines</a> on the WPTV blog.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 19 Jun 2015 21:38:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: WP Pusher Launches Free Git Crash Course for WordPress Developers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45221\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wptavern.com/wp-pusher-launches-free-git-crash-course-for-wordpress-developers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4126:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/01/git-logo.png\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/01/git-logo.png?resize=910%2C380\" alt=\"photo credit: git - the simple guide\" class=\"size-full wp-image-14763\" /></a>photo credit: <a href=\"http://rogerdudler.github.io/git-guide/\" target=\"_blank\">git &#8211; the simple guide</a>\n<p>Peter Suhm of <a href=\"https://wppusher.com/\" target=\"_blank\">WP Pusher</a> recently launched a f<a href=\"https://wppusher.com/wordpress-git-crash-course\" target=\"_blank\">ree email-based Git crash course</a> for WordPress developers who want to gain a basic understanding of managing projects with Git. The five-day drip content course is suitable for both plugin and theme developers and begins with instructions on how to structure your projects for an efficient Git workflow.</p>\n<p>While Git has many advanced features that could be overwhelming for beginners, the WP Git Crash Course only covers the ones that are directly relevant to WordPress development.</p>\n<p>&#8220;Overall, this course has two purposes,&#8221; Suhm said. &#8220;First of all, it is a way for me to establish a connection with visitors of my website who stop by without downloading WP Pusher.</p>\n<p>&#8220;Secondly, some people arrive on my website and like what they see but are not quite ready to start using WP Pusher because they need more knowledge about Git in order to get started. The course should get them up to speed.&#8221;</p>\n<p>As Suhm&#8217;s WP Pusher product manages <a href=\"http://wptavern.com/wp-pusher-aims-to-provide-pain-free-deployment-of-wordpress-themes-and-plugins-from-github\" target=\"_blank\">deployment of WordPress themes and plugins from GitHub</a>, Git educational resources are a natural extension of his work.</p>\n<p>The crash course introduces Suhm&#8217;s recommended workflow but doesn&#8217;t force the user into a rigid method of structuring projects.</p>\n<p>&#8220;I have concluded that maybe it is okay that people do things differently than me (but please do not keep your whole WordPress installation under version control!),&#8221; he said.</p>\n<p>&#8220;When I launched WP Pusher it was very opinionated and only supported my way of keeping WordPress under version control. Today it is much more flexible and works even if you keep multiple plugins or themes in one repository &#8211; something I would have sworn to never support.&#8221;</p>\n<p>Suhm is passionate about development best practices and workflow and often <a href=\"http://blog.wppusher.com/\" target=\"_blank\">blogs on these topics</a>. As a newcomer to the WordPress community, he offers a unique perspective.</p>\n<p>&#8220;In the Laravel community, we see many new arrivals of people from the world of WordPress,&#8221; he said. &#8220;For me it is the opposite. I am reentering the WordPress community after years of working with Laravel and Symfony, and I actually think I can bring something new to the table.&#8221;</p>\n<p>Aside from freelance work he did years ago, WP Pusher is Suhm&#8217;s first real venture into the WordPress world. After just five months, he&#8217;s pleased with how well his plugin has been received.</p>\n<p>&#8220;I have been lucky enough to meet a lot of great people in the WordPress community, both IRL and online,&#8221; he said. &#8220;Some of them have been extremely supportive and generously shared their experiences with me, which has really given me a head start.&#8221;</p>\n<p>Suhm is determined to keep creating educational content for the WordPress community and will be running the Git crash course for as long as people are interested. The course is not a complete, extensive guide to Git, as it just touches the surface. He plans to update it to add more advanced topics once he receives more feedback.</p>\n<p>If you&#8217;re just getting started integrating Git into your workflow for WordPress development, this crash course is a handy, concise resource for getting up to speed. You can sign up for the free course on <a href=\"https://wppusher.com/wordpress-git-crash-course\" target=\"_blank\">WPPusher.com.</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 19 Jun 2015 18:06:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"Matt: Funding Trends\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45163\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"http://ma.tt/2015/06/funding-trends/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:627:\"<p>I really enjoyed this presentation from Andressen Horowitz on how funding has evolved, and the current tech situation vis a vis the bubble around the turn of the millennium. It&#8217;s a pretty strong case for there not being a bubble right now. Go full-screen to be able to read it well.</p>\n<p> \n<div> <strong> <a href=\"https://www.slideshare.net/a16z/state-of-49390473\" title=\"U.S. Technology Funding -- What&#x27;s Going On? \" target=\"_blank\">U.S. Technology Funding &#8212; What&#x27;s Going On? </a> </strong> from <strong><a href=\"http://www.slideshare.net/a16z\" target=\"_blank\">a16z</a></strong> </div>\n<p>&nbsp;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 19 Jun 2015 04:50:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Rijeka Will Host the First WordCamp Croatia in September\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45378\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"http://wptavern.com/rijeka-will-host-the-first-wordcamp-croatia-in-september\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2718:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/rijeka-night.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/rijeka-night.jpg?resize=800%2C394\" alt=\"photo credit: WordCamp Croatia 2015\" class=\"size-full wp-image-45381\" /></a>photo credit: <a href=\"https://croatia.wordcamp.org/2015/welcome-to-wordcamp-croatia/\">WordCamp Croatia 2015</a>\n<p>The very first <a href=\"https://croatia.wordcamp.org/2015/\" target=\"_blank\">WordCamp Croatia</a> will be held in Rijeka the weekend of September 4-6. The WordPress community and the tech industry in general are <a href=\"http://wptavern.com/a-glimpse-into-serbias-rapidly-growing-wordpress-community\" target=\"_blank\">growing in the Balkans</a>. A large contingency of Croatian WordPress enthusiasts were present at neighboring <a href=\"http://wptavern.com/belgrades-first-wordcamp-sells-out-plans-to-double-attendees-next-year\" target=\"_blank\">Serbia&#8217;s first WordCamp in Belgrade</a> earlier this year. The <a href=\"http://wpcroatia.com/\" target=\"_blank\">Croatian WP community</a> has now grown large enough to host its own event.</p>\n<p>WordPress didn&#8217;t start gaining popularity in Croatia until 2013, but the country is now home to four thriving WordPress meetups in Zagreb, Split, Pula, and Rijeka. Local organizers decided to band together to apply for a country-wide WordCamp, instead of dividing it into smaller ones. They plan to rotate the location every year.</p>\n<p><a href=\"https://en.wikipedia.org/wiki/Rijeka\" target=\"_blank\">Rijeka</a>, the first host for WordCamp Croatia, is a multicultural city nestled on the Adriatic coast near Slovenia and Italy. It is well connected to nearby European capitals by air and train. Organizers are hoping to cultivate a &#8220;cozy and family–like atmosphere&#8221; for the event. <a href=\"http://business.croatia.hr/hr-HR/Poslovni-turizam/Kongresni-centri/Mjesto/Rijeka/Kongresni-centar/Hrvatski-kulturni-dom-na-Susaku?bGNcNDc0NjUscFwzODQ%3D\" target=\"_blank\">HKD Sušak</a>, the venue selected, has a capacity for up to 300 attendees.</p>\n<p>WordCamp Croatia will be a three-day event that will include educational workshops and tracks on Friday, the full conference on Saturday, and a Contributor Day on Sunday. The <a href=\"https://croatia.wordcamp.org/2015/call-for-speakers/\" target=\"_blank\">call for speakers</a> is open as of today and the deadline for proposals is July 5. Organizers will be accepting presentations in both English and Croatian. If you&#8217;re in the area and want to be part of the very first WordCamp Croatia, make sure to follow <a href=\"https://twitter.com/wpcroatia\" target=\"_blank\">WP Croatia on Twitter</a> for all the latest updates.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Jun 2015 21:49:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: WordPress for Android Version 4.1 Says Goodbye to the Hamburger Button\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45273\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://wptavern.com/wordpress-for-android-version-4-1-says-goodbye-to-the-hamburger-button\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2480:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/4.1-reader.png\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/4.1-reader.png?resize=281%2C500\" alt=\"4.1-reader\" class=\"alignright size-large wp-image-45359\" /></a>WordPress for Android <a href=\"https://apps.wordpress.org/2015/06/12/wordpress-for-android-version-4-1/\" target=\"_blank\">version 4.1</a> is sporting some major design changes. Navigation in the app has been redesigned to remove the the hamburger button in favor of four simplified tabs spanning the top of the screen.</p>\n<p>The ubiquitous hamburger icon, used on apps and websites for years, is slowly <a href=\"http://techcrunch.com/2014/05/24/before-the-hamburger-button-kills-you/\" target=\"_blank\">falling out of fashion</a> on the web. While the side navigation drawer does a good job of keeping nav items out of sight, <a href=\"https://lmjabreu.com/post/why-and-how-to-avoid-hamburger-menus/\" target=\"_blank\">it comes at the cost of user engagement</a>. Hamburger menus are also inconvenient for one-handed device operation.</p>\n<p>Version 4.1 of WordPress for Android has been redesigned to display a tabbed action bar with quick access to your sites, the reader, user account settings, and notifications. The sites menu will allow you to manage any of your connected sites and includes a short menu for publishing, stats, theme customization, and access to the full dashboard.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/tag-autocompletion.png\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/tag-autocompletion.png?resize=219%2C300\" alt=\"tag-autocompletion\" class=\"alignleft size-medium wp-image-45367\" /></a>Another new feature in 4.1 is tag auto-completion. When adding a tag on the post settings screen, users will now receive suggestions (based on existing tags) while typing.</p>\n<p>Stats have also been improved to provide a noticeably faster viewing experience. The app now takes just a fraction of the time it previously required to load stats data. Interacting with this feature no longer feels like visiting a foreign land.</p>\n<p>Overall the 4.1 release is a big leap forward for WordPress&#8217; usability on Android. The navigation redesign is more intuitive and smaller features are continuing to be refined with each release. The 4.1 update should have already hit devices, so Android users can open up the app to check out everything that&#8217;s new.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Jun 2015 17:23:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Matt: $3 Websites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45159\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://ma.tt/2015/06/3-websites/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:772:\"<blockquote><p>And remember the $5 billion website, 5 billion we spent on a website, and to this day it doesn’t work. A $5 billion dollar website.I have so many websites. I have them all over the place. I hire people, they do a website. It costs me $3.</p></blockquote>\n<p>We were just talking about government websites! The <a href=\"http://www.nydailynews.com/news/politics/transcript-donald-trump-2016-presidential-announcement-article-1.2260117\">transcript of Donald Trump’s 2016 presidential announcement</a> is one of the more interesting things I&#8217;ve read in a while. &#8220;And I promise I will never be in a bicycle race. That I can tell you.&#8221; In the spirit of alway saying something positive, I do agree that La Guardia airport is a hot mess.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Jun 2015 02:09:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WPTavern: BackPress Revival Receives Rocky Reception from WordPress Development Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45296\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"http://wptavern.com/backpress-revival-receives-rocky-reception-from-wordpress-development-community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5366:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/dinocar.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/dinocar.jpg?resize=1025%2C523\" alt=\"photo credit: Ryan McGuire\" class=\"size-full wp-image-45346\" /></a>photo credit: <a href=\"https://stocksnap.io/photo/A0737DFF83\">Ryan McGuire</a>\n<p><a href=\"http://backpress.org/\" target=\"_blank\">BackPress</a> supporters hosted a <a href=\"http://wptavern.com/backpress-is-coming-back-from-the-dead\" target=\"_blank\">preliminary discussion</a> yesterday to flesh out plans for bringing the long-abandoned project back to life. Organizers Roy Sivan and John James Jacoby were surprised by how many developers were interested in the prospect of reviving BackPress. Unfortunately, the live Google Hangout wasn&#8217;t broadcasted publicly and was limited 10 people, which gave the group a rocky, disorganized start on a closed channel.</p>\n<p>WordPress lead developer Andrew Nacin joined the discussion briefly before it started to say that BackPress, which he characterized as &#8220;five year old vaporware,&#8221; is &#8220;terrible and should be thrown away.&#8221; His view reflects many others &#8211; those who may see the value in making WordPress more modular but don&#8217;t believe that investing in BackPress is the way to get there.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/royboy789\">@royboy789</a> <a href=\"https://twitter.com/JJJ\">@JJJ</a> BackPress made sense as an experiement in the era it was born, but now it should just be left to die a peaceful death.</p>\n<p>&mdash; Ryan McCue (@rmccue) <a href=\"https://twitter.com/rmccue/status/610688602121506817\">June 16, 2015</a></p></blockquote>\n<p></p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/royboy789\">@royboy789</a> <a href=\"https://twitter.com/JJJ\">@JJJ</a> It splits the ecosystem with no real appreciable gain. If you don\'t want the core admin, don\'t use it.</p>\n<p>&mdash; Ryan McCue (@rmccue) <a href=\"https://twitter.com/rmccue/status/610689744033320960\">June 16, 2015</a></p></blockquote>\n<p></p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\">Let me save you guys a few thousand hours and headaches. <a href=\"http://t.co/ILp8nMDFL5\">http://t.co/ILp8nMDFL5</a></p>\n<p>&mdash; Brian Krogsgard (@Krogsgard) <a href=\"https://twitter.com/Krogsgard/status/610859720241496064\">June 16, 2015</a></p></blockquote>\n<p></p>\n<p>&#8220;I think that all the objectives here can be accomplished without doing it in a separate project,&#8221; Nacin said.</p>\n<p>&#8220;If you want to make a big difference in WordPress, then go contribute to the REST API. This isn&#8217;t it.&#8221;</p>\n<p>Ryan McCue, one of the lead developers on the WP REST API project, joined the discussion to encourage BackPress supporters to consider making it into a feature plugin, which he believes would be a more productive avenue for radical experimentation.</p>\n<p>Sivan pointed out that the problem with this path is that it still requires the use of a plugin, whereas BackPress is meant for developers who don&#8217;t want to have to install WordPress and plugins in order to experiment with it.</p>\n<p>Responding to commenters on yesterday&#8217;s post, Sivan <a href=\"http://wptavern.com/backpress-is-coming-back-from-the-dead#comment-69416\" target=\"_blank\">summarized</a> his thoughts about pursuing BackPress as a feature plugin:</p>\n<blockquote><p>I think the takeaway from today is to decide what it is the development community wants out of WordPress, and see if feature plugins are the way to go, or if there is some validity in building out this system (whatever it may be called) as what we hope can be re-integrated into core at some point. Whether that means taking backwards compatibility into account or not has yet to be seen.</p></blockquote>\n<p>&#8220;It would probably be better to start from scratch; it’s not even close to up to date with current WP code it was meant to emulate,&#8221; Matt Mullenweg said in response to the idea. &#8220;It’s a fun experiment regardless, especially if people don’t think of it as Official WordPress Policy or Future (which it isn’t).&#8221;</p>\n<p>After nearly three hours of discussion about possible ways forward, those present concluded that it would be best to reconvene next week to identify the problems that BackPress would solve. Most of those in attendance were developers passionate about creating a more flexible, modular WordPress and willing to see if a BackPress revival could be a possibility for addressing that.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\">Our conversation touched on the high level and next steps are coming, and we are planning on meeting next week same day, at 2PM (PST)</p>\n<p>&mdash; Roy Sivan (@royboy789) <a href=\"https://twitter.com/royboy789/status/610943668388802560\">June 16, 2015</a></p></blockquote>\n<p></p>\n<p>Organizers created a<a href=\"https://github.com/royboy789/helium\" target=\"_blank\"> GitHub repository for exploring a new BackPress</a> and will meet every Tuesday at 2PM PST. Anyone interested to join the discussion can participate on the new #backpress Slack channel, hosted at <a href=\"https://advancedwp.slack.com\">https://advancedwp.slack.com</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Jun 2015 00:05:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: WordPress Theme Review Team Launches Code Examples Library on GitHub\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44345\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"http://wptavern.com/wordpress-theme-review-team-launches-code-examples-library-on-github\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3293:\"<p>The WordPress Theme Review Team is now curating a <a href=\"https://github.com/WPTRT/code-examples/\" target=\"_blank\">library of code examples</a> on GitHub for theme developers. The first section is devoted to <a href=\"https://github.com/WPTRT/code-examples/tree/master/customizer\" target=\"_blank\">customizer code</a> with examples for panels, sections, basic controls, and advanced controls.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/trt-code-example-library.png\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/trt-code-example-library.png?resize=1025%2C596\" alt=\"trt-code-example-library\" class=\"aligncenter size-full wp-image-45322\" /></a></p>\n<p>&#8220;We will continue to add to the library, including more examples of custom controls, and more advanced examples, such as postMessage and other JavaScript fun, modifying the style of the Customizer panel, and others as suggested/requested,&#8221; TRT member Chip Bennett said in the <a href=\"https://make.wordpress.org/themes/2015/06/15/customizer-code-examples-on-github/\" target=\"_blank\">announcement</a>.</p>\n<p>In April, the Theme Review Team decided to <a href=\"http://wptavern.com/wordpress-org-now-requires-theme-authors-to-use-the-customizer-to-build-theme-options\" target=\"_blank\">enforce the use of the customizer for building theme options</a>, offering six months for authors to comply with the new guideline before violations would be rejected during updates. This decision immediately necessitated better documentation for building with the customizer, and the code example library fits in with this effort.</p>\n<p>During a TRT meeting last month, Chip Bennett <a href=\"https://wordpress.slack.com/archives/themereview/p1432655488000250\" target=\"_blank\">argued against the promotion of Customizer API frameworks</a>, such as <a href=\"http://wptavern.com/redux-and-kirki-frameworks-join-forces-to-provide-better-support-for-the-wordpress-customizer\" target=\"_blank\">Redux/Kirki</a>, and emphasized the need for educating theme authors on how to implement the API.</p>\n<p>&#8220;Instead of encouraging use of a &#8216;known&#8217; framework, we should take the opportunity to <em>teach</em>,&#8221; he said.</p>\n<p>&#8220;Essentially, I don&#8217;t want the TRT to encourage/facilitate/enable the use of Customizer frameworks at the expense of helping developers actually learn how to implement the Customizer API.&#8221;</p>\n<p>Bennett <a href=\"https://wordpress.slack.com/archives/themereview/p1432665980000935\" target=\"_blank\">suggested</a> that the team focus on teaching basic implementation of the core Customizer API, followed by education on how to implement custom controls.</p>\n<p>&#8220;Rather than creating a list of known frameworks, let&#8217;s focus on building our library of known, good custom controls, and work on tutorials for the core API, proper sanitization, use of custom controls, etc.,&#8221; he said.</p>\n<p>This is where the GitHub-hosted <a href=\"https://github.com/WPTRT/code-examples\" target=\"_blank\">code examples library</a> comes in handy for those who want to build themes that will meet WordPress.org guidelines. The team welcomes suggestions, requests, questions, and pull requests from anyone who wants to contribute to the effort.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 17 Jun 2015 19:03:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"Matt: Open Source Datacenters\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45156\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://ma.tt/2015/06/open-source-datacenters/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:669:\"<p><a href=\"http://www.businessinsider.com/facebook-open-compute-project-history-2015-6\">How Facebook is eating the $140 billion hardware market</a> &#8212; I&#8217;ve always said that open source eventually dominates every market it enters, and with enterprise hardware it&#8217;s in the very, very early stages but this article is chock-full of examples of the economies of scale when companies start collaborating on shared problems. The problem is one company&#8217;s inefficiency and wasted cost is another company&#8217;s revenue. <a href=\"http://ma.tt/2015/06/fastco-usds-profile/\">Cool to look at in the context of yesterday&#8217;s post on government</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 17 Jun 2015 06:05:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: Menu Customizer Officially Approved for Merge Into WordPress 4.3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45298\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://wptavern.com/menu-customizer-officially-approved-for-merge-into-wordpress-4-3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3492:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/menu-customizer-feature.jpg\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/menu-customizer-feature.jpg?resize=848%2C397\" alt=\"menu-customizer-feature\" class=\"aligncenter size-full wp-image-44906\" /></a></p>\n<p>The Menu Customizer plugin was <a href=\"https://core.trac.wordpress.org/changeset/32806\" target=\"_blank\">merged into WordPress trunk</a> today and will be one of the headline features of the 4.3 release.</p>\n<p>Roughly a week ago the feature plugin was <a href=\"http://wptavern.com/menu-customizer-tentatively-approved-for-wordpress-4-3\" target=\"_blank\">tentatively approved for merge</a>, pending an a11y audit and PHP and JS tests. Following an overwhelming amount of negative feedback from the community, core contributors <a href=\"http://wptavern.com/wordpress-core-contributors-call-for-user-testing-on-the-menu-customizer-plugin\" target=\"_blank\">published what was essentially a rallying call to get the plugin ready for merge</a>, reaffirming their commitment to iterating with the customizer.</p>\n<p>Nick Halsey, the plugin&#8217;s developer, published a number of <a href=\"https://make.wordpress.org/flow/2015/06/14/menus-in-the-admin-and-the-customizer-ux-flow-performance-comparisons/\" target=\"_blank\">UX flow and performance comparisons</a> of the admin menus screen vs. menus in the customizer. Ryan Boren and Konstantin Obenland also published <a href=\"https://make.wordpress.org/flow/2015/06/12/menu-customizer-iphone-5-emulated/\" target=\"_blank\">iPhone 5</a> and <a href=\"https://make.wordpress.org/flow/2015/06/04/menu-customizer-iphone-6/\" target=\"_blank\">6</a> emulations of the plugin in action.</p>\n<p>Halsey&#8217;s overall conclusion was that managing menus in the customizer takes less time in most cases than managing menus in the admin:</p>\n<blockquote><p>For the tests, I added links to both Menus UIs to the admin bar (4.3 will have one link here, to the Customizer). I ran into a few areas where the experience could be improved, but in terms of timing, the Customizer version wins in most of these scenarios currently. Note that this is intended to compare the experience for power users.</p></blockquote>\n<p>The Menu Customizer is one of the most controversial new features added to core in WordPress&#8217; recent history. It will be interesting to see how it plays out when users discover it in 4.3. Those who were not in favor of the feature voiced their opposition in comments on the <a href=\"https://make.wordpress.org/core/2015/06/03/feature-plugin-merge-proposal-menu-customizer/\" target=\"_blank\">original proposal</a> and in independent blogs around the web but were ultimately overruled.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\">Decisions not options: duplicate the interfaces, bringing complex things into little panels &amp; containers. We decide for you <a href=\"https://twitter.com/hashtag/WordPress?src=hash\">#WordPress</a> <a href=\"https://twitter.com/hashtag/rant?src=hash\">#rant</a></p>\n<p>&mdash; David Decker (@deckerweb) <a href=\"https://twitter.com/deckerweb/status/610938144628834306\">June 16, 2015</a></p></blockquote>\n<p></p>\n<p>At this juncture, no official timeline has been set for removing the menus screen in the WordPress admin. The existing menus will continue to be maintained for the time being, which should provide an easier transition for users who are surprised by the new feature in 4.3.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 16 Jun 2015 23:43:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: New WP Live Search Plugin Utilizes the WP REST API\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45217\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://wptavern.com/new-wp-live-search-plugin-utilizes-the-wp-rest-api\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3786:\"<p>Yesterday Nick Haskins, creator of <a href=\"http://wptavern.com/tag/aesop-story-engine\" target=\"_blank\">Aesop Story Engine</a>, released a new search plugin for WordPress. <a href=\"https://wordpress.org/plugins/wp-search-live/\" target=\"_blank\">WP Live Search</a> utilizes the new <a href=\"https://github.com/WP-API/WP-API\" target=\"_blank\">WP REST API</a>, in combination with Backbone.js and Underscore.js, to deliver live search results as the user types in a search query. The result is instantaneous searching that doesn&#8217;t require pressing enter or refreshing the page.</p>\n<p>WP Live Search is very much a working prototype but also provides a practical example of the WP REST API in action. I tested the plugin and the short clip below shows an example of searching through thousands of articles. Each result is displayed neatly with its corresponding featured image.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/wp-live-search.gif\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/wp-live-search.gif?resize=1016%2C488\" alt=\"wp-live-search\" class=\"aligncenter size-full wp-image-45268\" /></a></p>\n<p>Haskins created the client-side search plugin to power the new search feature inside <a href=\"http://wptavern.com/lasso-frontend-editing-plugin-for-wordpress-now-available-on-github\" target=\"_blank\">Lasso</a>, his frontend editing plugin. He released the prototype on WordPress.org in order to get usability testing and feedback from a larger group of users. He&#8217;s also building the plugin as part of his day job, so it&#8217;s being developed with several different audiences in mind.</p>\n<p>&#8220;Using the REST API was super important because we&#8217;re searching on &#8216;keyup&#8217; and if that went through admin-ajax.php then shared hosts would likely melt down,&#8221; Haskins said. &#8220;So because it&#8217;s all client-side, it&#8217;s super lightweight and anything can run it.&#8221;</p>\n<p>The feature is already built into Lasso but will not be released until Haskins has the chance to gather more feedback.</p>\n<p>&#8220;I&#8217;m interested to see HOW users search, is the search too fast, is it too slow, etc.,&#8221; he said. &#8220;All of this will lead to a perfect search feature inside of Lasso.&#8221;</p>\n<p>Haskins was previously hesitant to utilize the WP REST API before it has landed in WordPress core but the recent progress and momentum on the project inspired him to go for it.</p>\n<p>&#8220;I was avoiding the REST API, but with a tentative merge this fall, and V2 going out, I think the time is ripe,&#8221; he said. &#8220;In using the REST API, I&#8217;ve learned that it&#8217;s very use case dependent and is really just another tool. There&#8217;s a time and place for it.&#8221;</p>\n<p>WP Live Search is still under active development and may not be suitable for use in production just yet, but is functional and ready for testing. Here&#8217;s how to take it for a spin:</p>\n<ol>\n<li>Install <a href=\"https://wordpress.org/plugins/wp-search-live/\" target=\"_blank\">WP Live Search</a>.</li>\n<li>Install the official <a href=\"https://wordpress.org/plugins/json-rest-api/\" target=\"_blank\">WP REST API</a> plugin.</li>\n<li>Add the shortcode [wp_live_search] to a page.</li>\n</ol>\n<p>The shortcode accepts a few attributes, including type, placeholder, results, and target. More details are available on the plugin&#8217;s description <a href=\"https://wordpress.org/plugins/wp-search-live/\" target=\"_blank\">page</a>.</p>\n<p>Haskins plans to add support for custom post types in the next major update to the plugin. If you&#8217;re interested in contributing, you can find <a href=\"https://github.com/bearded-avenger/wp-live-search\" target=\"_blank\">WP Live Search on GitHub</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 16 Jun 2015 21:39:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WPTavern: BackPress is Coming Back From the Dead\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45232\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wptavern.com/backpress-is-coming-back-from-the-dead\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3607:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/frankenstein.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/frankenstein.jpg?resize=1024%2C520\" alt=\"photo credit: Frankenstein (1931) - (license)\" class=\"size-full wp-image-45254\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/89093669@N00/1544537850\">Frankenstein (1931)</a> &#8211; <a href=\"https://creativecommons.org/licenses/by-sa/2.0/\">(license)</a>\n<p>WordPress developers <a href=\"https://twitter.com/royboy789\" target=\"_blank\">Roy Sivan</a> and <a href=\"https://twitter.com/jjj\" target=\"_blank\">John James Jacoby</a> have taken a keen interest in reviving the <a href=\"http://backpress.org/\" target=\"_blank\">BackPress</a> project. They will be discussing their plans to bring it back to life on a live Google Hangout at 1PM PST (8pm UTC) today, June 16.</p>\n<p>BackPress is a PHP library of core functionality for web applications. It essentially provides the core of bbPress and powers the GlotPress application, which enables WordPress, BuddyPress, and bbPress to be translated into different languages.</p>\n<p>It&#8217;s no secret that bbPress project lead John James Jacoby is an ardent fan of BackPress, but few could have predicted that the project would be making a come back. In Sivan&#8217;s <a href=\"https://www.facebook.com/groups/advancedwp/permalink/970129579715923/\" target=\"_blank\">announcement</a> in the Advanced WordPress Facebook group, he briefly outlined their intentions for BackPress&#8217; future:</p>\n<blockquote><p>After a few conversations at WordCamp Miami, we both want to bring it back. My vision is for it to be up to date with current WP, and for it to be the WP you install when you don&#8217;t want the Dashboard, but to build something from scratch using modules / plugins.</p></blockquote>\n<p>Commenters responded positively to the announcement and Sivan and Jacoby plan to open the project up to contributors in the near future.</p>\n<p>&#8220;The current state of BackPress is a mess,&#8221; Sivan said. &#8220;Unfortunately, it can&#8217;t be just overwritten, so our main goal is to talk action plan, how to get it to a place that is more up to date, then start adding modularity to it.</p>\n<p>&#8220;My vision is you still get the easy installer, but things like wp-admin are just modules, and even modular within that per UI, but that shall be discussed as we move forward.&#8221;</p>\n<p>Once the BackPress code is up to date, the duo hope to turn it into a usable starting point for application development.</p>\n<p>&#8220;This + JSON REST API could be the next evolution of WordPress for developers,&#8221; Sivan said.</p>\n<p>For more details on the history of BackPress, check out Jeff Chandler&#8217;s 2010 <a href=\"http://wptavern.com/interview-with-beau-lebens-talking-backpress\" target=\"_blank\">interview with Beau Lebens</a>. If you&#8217;re interested in the future of the project, make sure to tune in at 1PM PST. The Google Hangouts link will be posted in the comments of the <a href=\"https://www.facebook.com/groups/advancedwp/permalink/970129579715923/\" target=\"_blank\">announcement</a>. Here&#8217;s a link for those who are not part of the group:</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\">BackPress hangout.&#10;Want to join <a href=\"https://t.co/Iua5rbY2ix\">https://t.co/Iua5rbY2ix</a>&#10;Want to lurk? <a href=\"https://t.co/KGdsPizrtt\">https://t.co/KGdsPizrtt</a></p>\n<p>&mdash; John James Jacoby (@JJJ) <a href=\"https://twitter.com/JJJ/status/610902291835523072\">June 16, 2015</a></p></blockquote>\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 16 Jun 2015 05:09:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Matt: FastCo USDS Profile\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45154\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"http://ma.tt/2015/06/fastco-usds-profile/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:695:\"<p>Fast Company has a <a href=\"http://www.fastcompany.com/3046756/obama-and-his-geeks\">great and in-depth look at the United States Digital Service (and similar programs across the government) that is really interesting</a>. They have a number of people involved that I really respect, and I can&#8217;t wait to see the results of it not just in the remainder of Obama&#8217;s term, but the coming decade. It&#8217;s shocking how much is spent on IT at not just the federal level, but the waste at the state and municipal level is even more shocking in many ways because there is so much duplication across the country (and the world). I&#8217;ll be blogging more about this theme this week.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 16 Jun 2015 00:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Postmatic Adds Importer for Subscribe to Comments Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45180\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"http://wptavern.com/postmatic-adds-importer-for-subscribe-to-comments-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3138:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/11/postmatic1.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/11/postmatic1.jpg?resize=810%2C378\" alt=\"postmatic\" class=\"aligncenter size-full wp-image-33866\" /></a></p>\n<p>Over the weekend <a href=\"https://gopostmatic.com/2015/06/subscribe-to-comments/\" target=\"_blank\">Postmatic version 1.2.3</a> was released with a new importer for the Subscribe to Comments plugin. Founder Jason Lemieux and his team launched the <a href=\"http://wptavern.com/postmatic-launches-100-email-based-commenting-for-wordpress\" target=\"_blank\">100% email-based commenting service</a> in April and have been steadily adding importers for users of other various comment subscription plugins. Postmatic launched with importers for Mailpoet, Mailchimp, and <a href=\"http://wptavern.com/postmatic-now-supports-1-click-migration-of-subscribers-from-jetpack\" target=\"_blank\">one-click migration of subscribers from Jetpack</a>.</p>\n<p><a href=\"https://wordpress.org/plugins/subscribe-to-comments/\" target=\"_blank\">Subscribe to Comments</a> is a popular old plugin created by Mark Jaquith and is currently in use on 80,000+ installations. The plugin hasn&#8217;t been updated for more than two years and many users in its <a href=\"https://wordpress.org/support/plugin/subscribe-to-comments\" target=\"_blank\">support forums</a> are eagerly looking for an alternative.</p>\n<p>With over 80,000 sites depending on an older, unmaintained plugin, Lemieux and his team saw a ripe opportunity to create an importer to fill the gap. Subscribe to Comments users can conveniently migrate with one click:</p>\n<blockquote><p>We’ve built a new migration tool into Postmatic 1.2.3 which will allow Subscribe to Comments users to convert their legacy subscribers into shiny new Postmatic subscribers. It all happens with just one click, invisibly, in the background. From then on out notifications of new comments will be sent to old subscribers except this time they’ll be able to continue the conversation by just hitting reply.</p></blockquote>\n<p>The migration tool also works with variations of Subscribe to Comments, including <a href=\"https://wordpress.org/plugins/subscribe-to-comments-reloaded/\" target=\"_blank\">Subscribe to Comments Reloaded</a> and <a href=\"https://wordpress.org/plugins/subscribe-to-double-opt-in-comments/\" target=\"_blank\">Subscribe to Double-Opt-In Comments</a>. The importer is another strategic addition that will likely win Postmatic more new users.</p>\n<p>Postmatic is aiming to become a big player in WordPress comments and is continuing to build out more products centered around enhancing engagement. In addition to expanding the user base of the free Postmatic plugin, the team is also busy beta testing Epoch, its next major release. Epoch is currently <a href=\"https://wordpress.org/plugins/epoch/\" target=\"_blank\">available on WordPress.org</a> and aims to bring 100% realtime chat and commenting to WordPress&#8217; native commenting system. Keep your eyes on the Postmatic team in the coming days, as they ready their next round of innovations.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 15 Jun 2015 22:57:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WPTavern: o2 is Now Available on GitHub\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45188\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wptavern.com/o2-is-now-available-on-github\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3618:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/o2-on-github.png\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/o2-on-github.png?resize=1025%2C536\" alt=\"o2-on-github\" class=\"aligncenter size-full wp-image-45205\" /></a></p>\n<p>This weekend at WordCamp Denver, <a href=\"https://twitter.com/alternatekev\" target=\"_blank\">Kevin Conboy</a> announced that Automattic&#8217;s <a href=\"http://wptavern.com/o2-wordpress-plugin-expected-to-be-available-in-early-2014\" target=\"_blank\">long-awaited O2 project</a> is now publicly <a href=\"https://github.com/Automattic/o2\" target=\"_blank\">available on GitHub</a>. In a recent interview with WP Tavern, Matt Mullenweg confirmed that the o2 development team is <a href=\"http://wptavern.com/o2-development-team-shifts-focus-to-wordpress-coms-core-products\" target=\"_blank\">shifting its focus to WordPress.com&#8217;s core products</a> but that the o2 code would be public for anyone to use.</p>\n<p>o2 was is the successor to <a href=\"https://wordpress.org/themes/p2/\" target=\"_blank\">P2</a>, the innovative group blogging theme created to power communications at Automattic. P2 was <a href=\"http://wptavern.com/p2-officially-on-the-theme-repository\" target=\"_blank\">released in 2009</a> with the tagline &#8220;Blogging at the speed of thought.&#8221; It introduced quick posting from the front page and real-time updates.</p>\n<p>o2 shares P2&#8217;s tagline but, unlike its predecessor, it was created to be a plugin that is not dependent on a specific theme.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/devinsays\">@devinsays</a> <a href=\"https://twitter.com/michaelarestad\">@michaelarestad</a> that\'s the theory!</p>\n<p>&mdash; Kevin Conboy (@alternatekev) <a href=\"https://twitter.com/alternatekev/status/610413606446825473\">June 15, 2015</a></p></blockquote>\n<p></p>\n<p>However, it&#8217;s not guaranteed to work with any theme, so if you want the best experience you should test it out with the <a href=\"https://wpcom-themes.svn.automattic.com/p2-breathe\" target=\"_blank\">p2-breathe theme</a>, as recommended in the GitHub installation instructions. o2 requires the <a href=\"https://wordpress.org/plugins/genericond/\" target=\"_blank\">Genericon&#8217;d</a> plugin and if you want the ability to insert code blocks, it requires the <a href=\"https://wordpress.org/plugins/syntaxhighlighter/\" target=\"_blank\">SyntaxHighlighter Evolved</a> plugin.</p>\n<p>The readme.txt on GitHub cautions that &#8220;multisite self-hosted installs have not yet been tested and may not work.&#8221; Although the plugin was written to shine within a network environment with cross-site search and cross-site posting, the network features are not guaranteed to work for self-hosted users. However, the improved real-time commenting, drag-and-drop media upload, and other enhancements may make using O2 worthwhile on single site WordPress installations.</p>\n<p>A cursory look at the issues queue indicates that some of the features that work on WordPress.com may still be buggy for self-hosted installations, such as <a href=\"https://github.com/Automattic/o2/issues/3\" target=\"_blank\">@mentions in posts in comments</a>. The good news for those who were eagerly awaiting o2&#8217;s release is that the code, while not completely polished and bug-free, is now <a href=\"https://github.com/Automattic/o2\" target=\"_blank\">public on GitHub</a>. Even though Automattic is shifting its focus away from the project, anyone who wants to help improve it can submit a pull request or fork o2 for their own use.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 15 Jun 2015 17:30:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Matt: Priceless Words\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45151\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"http://ma.tt/2015/06/priceless-words/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:405:\"<blockquote><p>“It&#8217;s easy to be very busy but not get anything done that you&#8217;ll look back a year from now and say was worthwhile.”</p>\n<p>“You&#8217;ll get a lot of contradictory advice, and often neither side is wrong.”</p></blockquote>\n<p>Entrepreneur.com <a href=\"http://www.entrepreneur.com/article/246745\">collected a few quotes from me and blogged some context for each</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 15 Jun 2015 01:25:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"Matt: How Tesla Will Change The World\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45149\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://ma.tt/2015/06/how-tesla-will-change-the-world/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:149:\"<p><a href=\"http://waitbutwhy.com/2015/06/how-tesla-will-change-your-life.html\">How Tesla Will Change The World</a> from the great Wait But Why.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 13 Jun 2015 23:25:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Matt: Munchery Eating the World\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45143\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://ma.tt/2015/06/munchery-eating-the-world/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:380:\"<p>Shervin has an amazing write-up on <a href=\"https://medium.com/@shervin/how-munchery-is-literally-eating-the-world-218c6520dc99\">how Munchery is literally eating the world</a>, and Sherpa&#8217;s continuing investment there. If you haven&#8217;t tried <a href=\"https://munchery.com/\">Munchery</a> yet they&#8217;re now in San Francisco, Los Angeles, Seattle, and New York.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 13 Jun 2015 03:31:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Post Status: What is Code?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=13013\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"https://poststatus.com/what-is-code/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:16332:\"<p>Today I read perhaps the single best article I&#8217;ve ever read on programming.</p>\n<p><a href=\"http://www.bloomberg.com/graphics/2015-paul-ford-what-is-code/\">Paul Ford has written the definitive guide</a> for explaining a profession that employs 11 million people and occupies 7 million more hobbyists&#8217; time by answering the question, &#8220;What is code?&#8221;</p>\n<p>He wrote the article for everyone, he says, but specifically he wrote it for the editor of Bloomberg. Whether you&#8217;re a programmer already, in a business where you work with programmers, or just want to learn a bit more about the thousands of frameworks for 0s and 1s that run our world, I think the article is for you.</p>\n<p>It&#8217;s not fair to attempt a summary of the many points Paul makes, but I&#8217;ll highlight some of my favorite passages and also summarize some of the topics he covers. However, I can not offer each point the justice they deserve, so honestly if you really want the best experience, read the original and not this.</p>\n<p>The <em>only</em> benefit of my article is that at just over 2,000 words it&#8217;s 5% of the length of the original. I&#8217;d encourage everyone to read the entire article. I&#8217;m sure I&#8217;ll share it individually hundreds of times in my future.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\">Here is MY three-word summary of my article for busy people: Reevaluate your life.</p>\n<p>&mdash; Paul Ford (@ftrain) <a href=\"https://twitter.com/ftrain/status/609374405727268864\">June 12, 2015</a></p></blockquote>\n<p></p>\n<p>Are you still not convinced to commit to it? Okay, fine. Here are my favorite parts:</p>\n<h3>Where is code?</h3>\n<p>While the entire article answers, &#8220;What is code?&#8221;, he starts by answering, &#8220;Where is code?&#8221; Code is much broader than the web. It&#8217;s pervasive. Everywhere.</p>\n<blockquote><p>Most programmers aren’t working on building a widely recognized application like Microsoft Word. Software is everywhere. It’s gone from a craft of fragile, built-from-scratch custom projects to an industry of standardized parts, where coders absorb and improve upon the labors of their forebears (even if those forebears are one cubicle over). Software is there when you switch channels and your cable box shows you what else is on. You get money from an ATM—software. An elevator takes you up five stories—the same. Facebook releases software every day to something like a billion people, and that software runs inside Web browsers and mobile applications. Facebook looks like it’s just pictures of your mom’s crocuses or your son’s school play—but no, it’s software.</p></blockquote>\n<h3>Computers are dumb</h3>\n<p><a href=\"http://waitbutwhy.com/2015/01/artificial-intelligence-revolution-1.html\">Until they&#8217;re not</a>. But today, computers really don&#8217;t know anything; they return things based on what we put in them, and they can do so many things faster than we can.</p>\n<blockquote><p>Every character truly, truly matters. Every single stupid misplaced semicolon, space where you meant tab, bracket instead of a parenthesis—mistakes can leave the computer in a state of panic. The trees don’t know where to put their leaves. Their roots decay. The boxes don’t stack neatly. For not only are computers as dumb as a billion marbles, they’re also positively Stradivarian in their delicacy.</p></blockquote>\n<h3>Programming languages</h3>\n<p>Paul spends a ton of time talking about various programming languages, their origins, their styles, their adoptions, their usefulness, and how they&#8217;ve evolved.</p>\n<p>He primarily focuses on C (and how it&#8217;s fast but not object oriented) and Java (and how it&#8217;s object oriented but not fast, relatively). Amazingly, he manages to talk about many, many languages, their attributes, and yet explain them in a way that nearly anyone can understand.</p>\n<p>I have to admit something: I am so far from a classically trained developer that I found this focus of the article to be incredibly educational. I learned the wrong way, from the tip of the pyramid down. If you consider markup and styles the very tip, and then WordPress is a bit below that as a framework for PHP &#8212; and you are still only part way down the pyramid. PHP is built with C and C compiles to machine code. His article helped me understand the pyramid from the other direction much better.</p>\n<h3>Programmer culture</h3>\n<p>An important piece of the article was around culture. He spends time both on programmer attitudes and broader programming culture, such as conferences.</p>\n<blockquote><p>Languages have agendas. People glom onto them. Blunt talk is seen as a good quality in a developer, a sign of an “engineering mindset”—spit out every opinion as quickly as possible, the sooner to reach a technical consensus. Expect to be told you’re wrong; expect to tell other people they’re wrong. (Masculine anger, bluntly expressed, is part of the industry.)</p>\n<p>Coding is a culture of blurters. This can yield fast decisions, but it penalizes people who need to quietly compose their thoughts, rewarding fast-twitch thinkers who harrumph efficiently. Programmer job interviews, which often include abstract and meaningless questions that must be answered immediately on a whiteboard, typify this culture. Regular meetings can become sniping matches about things that don’t matter. The shorthand term for that is “bikeshedding.” (Who cares what color the bike shed is painted? Well …)</p>\n<p>Code culture is very, very broad, but the geographic and cultural core is the Silicon Valley engine of progress. The Valley mythologizes young geniuses with vast sums. To its credit, this culture works; to its shame, it doesn’t work for everyone.</p>\n<p>At any moment some new thing could catch fire and disrupt the tribal ebb and flow. Instagram was written in Python and sold for $2 billion, so Python had a moment of glory. The next mind-blowing app could show up, written in some new language—and start everyone taking that more seriously. Within 18 months your skills could be, if not quite valueless, suspect.</p>\n<p>I was in a meeting once where someone said, “How long will it take to fix that?” One person, who’d been at the company for years, said, “Three months.” A new person, who’d just come from a world of rapidly provisioned cloud microservices, said, “Three minutes.” They were both correct. That’s how change enters into this world. Slowly at first, then on the front page of Hacker News.</p>\n<p>Programmers carve out a sliver of cognitive territory for themselves and go to conferences, and yet they know their position is vulnerable. They get defensive when they hear someone suggest that Python is better than Ruby, because [insert 500-comment message thread here]. Is the next great wave swelling somewhere, and will it wash away Java when it comes? Will Go conquer Python? Do I need to learn JavaScript to remain profitable? Programmers are often angry because they’re often scared. We are, most of us, stumbling around with only a few candles to guide the way. We can’t always see the whole system, so we need to puzzle it out, bit by bit, in the dark.</p></blockquote>\n<p>And his passage on the decreasing percentages of female coders is pure perfection:</p>\n<blockquote><p>The average programmer is moderately diligent, capable of basic mathematics, has a working knowledge of one or more programming languages, and can communicate what he or she is doing to management and his or her peers. Given that a significant number of women work as journalists and editors, perform surgery, run companies, manage small businesses, and use spreadsheets, that a few even serve on the Supreme Court, and that we are no longer surprised to find women working as accountants, professors, statisticians, or project managers, it’s hard to imagine that they can’t write JavaScript. Programming, despite the hype and the self-serving fantasies of programmers the world over, isn’t the most intellectually demanding task imaginable.</p>\n<p>Which leads one to the inescapable conclusion: The problem with women in technology isn’t the women.</p></blockquote>\n<h3>PHP and (sorta) WordPress</h3>\n<p>Of everything discussed in the article, the one thing I really could tell he didn&#8217;t appreciate much was PHP.</p>\n<blockquote><p>You can get a site up and running in PHP in a few minutes, and that’s the problem. It used to be the terrible choice you made when you needed to get something done on the Web, but increasingly JavaScript has replaced it as the default terrible choice.</p>\n<p>PHP stands for Personal Home Page/Forms Interpreter. The idea was that when you loaded your Web pages, the PHP code would run before the page went out to the Internet. And PHP could, say, check whether you were logged in. If you were, it could show you your top secret account details; and if you weren’t, it could say, “Please log in.”</p>\n<p>I know a lot of people who program in PHP, and they are smart, good people. PHP powers Etsy and Facebook. It powers Wikipedia, for God’s sake. WordPress. Out of all the Web’s pages, an enormous percentage is created with PHP.</p>\n<p>Coding in PHP for a living is not a death sentence. Lots of people have gotten rich off PHP. It just means a lot of cutting and pasting, and a lot of trips to Google to figure out why things aren’t working.</p>\n<p>Poor, sad, misbegotten, incredibly effective, massively successful PHP. Reading PHP code is like reading poetry, the poetry you wrote freshman year of college.</p>\n<p>I spent so many hundreds, maybe thousands, of hours programming in PHP, back when I didn’t know what I was doing and neither did PHP. Reloading Web pages until my fingers were sore. (I can hear your sympathetic sobs.) Everything was always broken, and people were always hacking into my sites.</p>\n<p>PHP. I don’t wish it any harm. I’m glad to see how well it’s done for itself. We had some good times together. I just don’t ever want to go back there.</p></blockquote>\n<p>He also uses WordPress as the punching bag for the story in the story. The fictional story within the article is of a company that&#8217;s replacing their current website with a new website. It&#8217;s a big corporate environment and they&#8217;re, &#8220;at the limits with WordPress.&#8221; Of course, <a href=\"http://ma.tt/2015/06/paul-ford-what-is-code-bloomberg/\">Matt Mullenweg took issue</a> with that one aspect on his own blog.</p>\n<h3>Debugging, testing, and version control</h3>\n<p>Paul gives some of the best layman&#8217;s descriptions for debugging, testing, and version control I&#8217;ve ever read. He closes the section with this:</p>\n<blockquote><p>See, tests and version control are now the trigger for actually shipping code. If you can follow a process like this, you can release software several times a day—which in the days of shrink-wrapped software would have been folly. (Often builds were done nightly, by big “build servers,” and one would come in the next morning to get the score.) But now that software can be released via the Web or an app store, why wait? Why not continually release software, every day, whenever you have something that’s ready to go?</p></blockquote>\n<h3>Actually picking a language</h3>\n<p>It&#8217;s hard to limit this one and it was one of my favorite parts, so I&#8217;m just going to toss it in in bulk.</p>\n<blockquote><p>Beware of arguments related to programming speed. All things being equal, faster is better. But all things are never equal. Do you need the kind of speed that lets you get a website up and running quickly? Or the kind that allows you to rotate a few thousand polygons in 3D in real time? Do you need to convert 10,000 PDFs into text per hour? Or 10 million PDFs into text once? These are different problems. What do we need to do, how many times do we need to do it, and what existing code can we use to help us do it that many times? Ask those questions.</p>\n<p>It’s possible to spend productive months preparing for a project without deciding on a language. It may be the sign of a fine manager, someone who assumes his people can learn new things, someone who’s built an agile team capable of experimenting with new technologies and getting ideas into production. It could also be that this person is totally useless. You’ll find out!</p>\n<p>Let’s say your programmers are developing a huge website that serves 5 million people who each visit five times a month. Do you use Python, which is slower, or Go, which is fast, or Node.js, which is something in-between? Trick question! Twenty-five million Web page visits isn’t that big a deal, unless they involve some deep wizardry or complex database queries that are very different for each page (good example: Facebook).</p>\n<p>Now, that number isn’t trivial; if it takes a minute to make a page, you’d need 48 years to make that many, which is way too slow. If it takes a second to make a page, that’s still too slow—there are only 2.6 million seconds in a month. So you need to figure out how to serve about 10 pages per second. You’ll probably want more than one computer, a little redundancy, some good server setup. It will take some doing and planning. But it can be done in any language.</p>\n<p>What if you are going to serve only a few hundred thousand pages a month? Then you’ve got tremendous breathing room. You don’t need too many engineers to create the system architecture. You still need to plan, but in general you can read some blog posts and follow along with what others have done. You can be pretty sloppy, to be honest. Again, any language will do.</p>\n<p>What if you want to include a live, person-to-person chat on those pages, and you expect thousands of people to use that chat at once, all speaking to each other? Now you’re dipping your hand into that godforsaken river. But that is exactly the problem that Go was designed to solve. It’s a language for creating highly available servers that use as much of the computer’s processor as possible. It has other features as well, but this is where Go shines. Actually, Node.js works pretty well for that sort of server, too, and Clojure certainly has the capacity. Oh, right, Java works, too. If you really needed to, you could even do it in PHP.</p>\n<p>This is why the choice is so hard. Everything can do everything, and people will tell you that you should use everything to do everything. So you need to figure out for yourself what kind of team you have, what kind of frameworks you like using, where people can be most productive, so they will stick around through the completion of the project. This is hard. Most places can’t do this. So they go with the lowest common denominator—Java, PHP—because they know that when people leave, they’ll be able to get more of them.</p>\n<p>And that’s OK. The vast majority of technology projects don’t require original research, nor do they require amazing technological discoveries. All the languages under discussion work just fine. There are great coders in all of them.</p></blockquote>\n<h3>Should you learn to code?</h3>\n<p>I&#8217;ve only highlighted some of my favorite parts. I will likely re-read this article many times.</p>\n<p>You can also check out a <a href=\"https://github.com/BloombergMedia/whatiscode/\">GitHub repo for the article</a>, which is super cool. You can also catch a <a href=\"http://gawker.com/what-is-code-a-q-a-with-writer-and-programmer-paul-fo-1710884170\">Q&amp;A with Paul Ford</a>, about the article and process, on Gawker. Oh, and <a href=\"http://paulford.kinja.com/for-the-love-of-content-management-1593678966\">his test last year of the Kinja CMS</a> &#8212; a debacle that is reminiscent of the Bloomberg article more than a little bit &#8212; is hilarious.</p>\n<p>In the end, he poses the question: &#8220;should you learn to code?&#8221; You&#8217;ll have to <a href=\"http://www.bloomberg.com/graphics/2015-paul-ford-what-is-code/\">read to the end to find out</a>.</p>\n<p>Seriously, thank you <a href=\"https://twitter.com/ftrain\">Paul Ford</a> for this piece, and Bloomberg for funding it.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 12 Jun 2015 20:46:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: WP Featherlight: A New Lightbox Plugin for WordPress Images and Galleries\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44795\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://wptavern.com/wp-featherlight-a-new-lightbox-plugin-for-wordpress-images-and-galleries\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3942:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/featherlight.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/featherlight.jpg?resize=1020%2C505\" alt=\"photo credit: neverland... - (license)\" class=\"size-full wp-image-45148\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/91565478@N00/3292572871\">neverland&#8230;</a> &#8211; <a href=\"https://creativecommons.org/licenses/by/2.0/\">(license)</a>\n<p>WP Site Care recently launched its new <a href=\"https://wordpress.org/plugins/wp-featherlight/\" target=\"_blank\">WP Featherlight</a> plugin on WordPress.org. While there are already hundreds of lightbox plugins available for WordPress, this one may prove to be the &#8220;lightest&#8221; of them all.</p>\n<p>The plugin is essentially a wrapper for the <a href=\"http://noelboss.github.io/featherlight/\" target=\"_blank\">Featherlight jQuery lightbox script</a> created by Noel Bossart. Featherlight.js was designed to be very lightweight and is just 400 lines of JavaScript, 100 of CSS, and less than 6kB combined. It works on IE8+, all modern browsers, and on mobile platforms. The script is responsive and supports images, ajax, and iframes out of the box.</p>\n<p>WP Featherlight solves a number of problems that WordPress users often encounter with lightbox plugins, many of which contain a load of heavy-handed styling that is difficult to override.</p>\n<p>&#8220;We were having a really hard time finding a lightbox plugin that was simple to customize, but that was also lightweight, flexible, and didn’t add a bunch of bloat to our website,&#8221; WP Site Care founder Ryan Sullivan said in his <a href=\"http://www.wpsitecare.com/wp-featherlight/\" target=\"_blank\">post</a> introducing the plugin.</p>\n<p>The WP Site Care team opted to build their own solution on top of Featherlight.js. The resulting plugin provides a fast, minimalist style popup for images and galleries.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/wp-featherlight-screenshot.png\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/wp-featherlight-screenshot.png?resize=1025%2C786\" alt=\"wp-featherlight-screenshot\" class=\"aligncenter size-full wp-image-45168\" /></a></p>\n<p>The plugin includes built-in support for native WordPress galleries and <a href=\"http://jetpack.me/support/tiled-galleries/\" target=\"_blank\">Jetpack galleries</a>. When you install it, there are no options to configure. It will automatically display all images and galleries in a lightbox. If you <a href=\"https://github.com/noelboss/featherlight/#usage\" target=\"_blank\">add some extra data attributes to your content</a>, it&#8217;s also possible to display videos, iframes, and ajax content with WP Featherlight.</p>\n<p>The demo video below shows how the plugin works with galleries to click from one image to the next while in the lightbox.</p>\n<p><span class=\"embed-youtube\"></span></p>\n<p>One common problem with WordPress lightbox plugins is that they usually load their scripts and styles on every page, whether you need the lightbox there or not. WP Featherlight gives you the option in the post editor to disable the lightbox. It&#8217;s a handy option to have in case you don&#8217;t want to load a larger version of your images on that particular post/page, but I&#8217;m not sure why you wouldn&#8217;t just conditionally load the scripts on pages that have images.</p>\n<p>I tested WP Featherlight on a demo site and found that it works as advertised. You would be hard pressed to find a leaner lightbox plugin for WordPress. The style is super minimal and the fact that there are no options to configure makes it a pleasure to use. Many thanks to <a href=\"https://profiles.wordpress.org/fatmedia/\" target=\"_blank\">Robert Neu</a> and the folks at WP Site Care for making it freely <a href=\"https://wordpress.org/plugins/wp-featherlight/\" target=\"_blank\">available on WordPress.org</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 12 Jun 2015 19:36:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: WordPress Plugin Developers Need to Communicate Better in Change Logs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45107\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://wptavern.com/wordpress-plugin-developers-need-to-communicate-better-in-change-logs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4839:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/01/CommunicationFeaturedImage.jpg\"><img class=\"size-full wp-image-15569\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/01/CommunicationFeaturedImage.jpg?resize=637%2C200\" alt=\"Communication Featured Image\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/elycefeliz/3224486233/\">elycefeliz</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a>\n<p>One of the habits I developed when I started using WordPress is to <strong>always</strong> read a plugin&#8217;s changelog before updating. The changelog is a communication channel that bridges the gap between me and the developer.</p>\n<p>It tells me what&#8217;s changed, what to expect, and any other information the developer thinks I should know. The most important information a developer can tell me is that a security vulnerability has been addressed.</p>\n<p>Security vulnerabilities in WordPress plugins generally receive a decent amount of media coverage. If I read a story that mentions a plugin I use containing a vulnerability, the first thing I do is visit that plugin&#8217;s changelog on the WordPress plugin directory to see if it&#8217;s fixed. However, some plugin authors don&#8217;t do a very good job of informing users that a security patch has been applied.</p>\n<h2>WooCommerce and VaultPress</h2>\n<p>WooCommerce recently <a href=\"http://wptavern.com/woocommerce-2-3-11-patches-object-injection-vulnerability\">released an update</a> to fix an object injection vulnerability. If you look at the changelog for 2.3.11 which has the patch, there is no mention of a security vulnerability being fixed.</p>\n<h4>2.3.11 &#8211; 10/06/2015</h4>\n<ul>\n<li>Fix &#8211; Check if rating is enabled before check if rating is required to a review.</li>\n<li>Fix &#8211; get_discounted_price needs to check if taxes are enabled.</li>\n<li>Fix &#8211; Fixed filetype check for digital downloads.</li>\n<li>Fix &#8211; Newfoundland and Labrador state rename.</li>\n<li>Fix &#8211; Escaped js in widget layered nav when use the dropdown option.</li>\n<li>Fix &#8211; Switch the permissions check for json_search_products to use the read_product capability.</li>\n<li>Fix &#8211; Fixed the addition of variable products using the Order API.</li>\n<li>Fix &#8211; Sale item exclusion logic for variations.</li>\n<li>Fix &#8211; Clear correct variation stock transients when setting stock.</li>\n<li>Fix &#8211; Switch to JSON to avoid unserializing untrusted data when handling responses from PayPal.</li>\n<li>Fix &#8211; API &#8211; Fixed the sanitization for downloadable files on products endpoint.</li>\n<li>Tweak &#8211; woocommerce_downloadable_file_exists filter.</li>\n</ul>\n<p>To the untrained eye, 2.3.11 is just a regular maintenance release. Security fixes should be front and center and command attention.</p>\n<p><a href=\"https://wordpress.org/plugins/vaultpress/changelog/\">VaultPress</a>, a security monitoring plugin by Automattic, also fails to provide clear information in its changelog. Determining security patches with VaultPress is confusing because security hotfixes are labeled as though they are patches for the plugin itself. Instead, security hotfixes are patches to protect from known security vulnerabilities.</p>\n<h4>1.7.5 &#8211; 11 Jun 2015</h4>\n<ul>\n<li>Security: Add a new security hotfix.</li>\n</ul>\n<h4>1.7.4 &#8211; 28 Apr 2015</h4>\n<ul>\n<li>Bugfix: Don&#8217;t allow openssl signing unless the public key exists.</li>\n</ul>\n<h4>1.7.3 &#8211; 27 Apr 2015</h4>\n<ul>\n<li>Security: Add a new security hotfix.</li>\n</ul>\n<p>To add to the confusion, there&#8217;s no explanation as to what the hotfixes protect against. You have to read the <a href=\"https://plugins.trac.wordpress.org/changeset/1178685/vaultpress\">inline comment on GitHub</a> to know what the latest hotfix does.</p>\n<blockquote><p>// Protect WooCommerce from object injection via PayPal IPN notifications. Affects 2.0.20 -&gt; 2.3.10</p></blockquote>\n<p>If VaultPress developers added the comment from GitHub to the changelog on WordPress.org, it would have made things a lot clearer.</p>\n<h2>Users Read Change Logs</h2>\n<p>When we <a href=\"http://wptavern.com/poll-how-often-do-you-read-a-wordpress-plugins-changelog-before-updating\">asked readers</a> how often do they read a plugin&#8217;s changelog before updating, 705 out of 1,152 voters said they <strong>always</strong> read it while 338 people said they <strong>sometimes</strong> read it. Whether they understand the changes or not, users read change logs.</p>\n<p>If you&#8217;re a plugin developer, please consider adding context and clear explanations to your change logs. Clearly state what is a security patch, bug fix, or tweak. I don&#8217;t need to know the fine details, just enough information to make a good decision.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 12 Jun 2015 19:12:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: HHVM Demonstrated to be 18.7% Faster Than PHP 7 on a WordPress Workload\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45062\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://wptavern.com/hhvm-demonstrated-to-be-18-7-faster-than-php-7-on-a-wordpress-workload\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4072:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/hhvmhack.png\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/hhvmhack.png?resize=700%2C175\" alt=\"hhvmhack\" class=\"aligncenter size-full wp-image-22751\" /></a></p>\n<p>This week HHVM developers shared the results of their first ever <a href=\"http://hhvm.com/blog/9293/lockdown-results-and-hhvm-performance\" target=\"_blank\">open source performance lockdown</a>. HHVM is Facebook&#8217;s <a href=\"https://github.com/facebook/hhvm\" target=\"_blank\">open source</a> PHP execution engine, originally created to help make its infrastructure more efficient. WordPress managed hosts, including <a href=\"http://wptavern.com/wp-engine-partners-with-10up-to-launch-enterprise-hhvm-wordpress-hosting-platform\" target=\"_blank\">WP Engine</a>, <a href=\"https://pagely.com/blog/2014/06/run-hhvm-pagely/\" target=\"_blank\">Pagely</a>, and <a href=\"https://www.siteground.com/blog/hhvm/\" target=\"_blank\">SiteGround</a>, have added HHVM hosting options within the last year to cater to customers who require better PHP performance.</p>\n<p>During the HHVM team&#8217;s two week lockdown, developers focused on optimizing builtin functions, dynamic properties, string concatenation, and the file cache. The goal was to maximize requests per second (RPS) with WordPress, Drupal 7, and MediaWiki, using their <a href=\"https://github.com/hhvm/oss-performance\" target=\"_blank\">oss-performance</a> benchmarking tool.</p>\n<p>&#8220;During lockdown we achieved a 19.4% RPS improvement for MediaWiki workloads, and a 1.8% RPS improvement for WordPress,&#8221; Facebook developer Paul Bissonnette reported. &#8220;We demonstrated that HHVM is 55.5% faster than PHP 7 on a MediaWiki workload, <strong>18.7% faster on a WordPress workload</strong>, and 10.2% faster on a Drupal 7 workload.&#8221;</p>\n<p>These results were based on configuring each framework with a sample dataset designed to approximate an average installation. In order to create the WordPress workload, the HHVM team used URLs from the hhvm.com access logs to extract data.</p>\n<p>The <a href=\"http://hhvm.com/blog/9293/lockdown-results-and-hhvm-performance\" target=\"_blank\">report</a> contains a walkthrough of how the benchmarking tool works to approximate the maximum possible RPS of a server under a high load. Some of the most notable performance differences were summarized in the results of the engine comparison chart, which demonstrates the difference between PHP 5, PHP 7, and HHVM.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/engine-comparison.png\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/engine-comparison.png?resize=1025%2C429\" alt=\"engine-comparison\" class=\"aligncenter size-full wp-image-45141\" /></a></p>\n<p>During the lockdown, the team also experimented with introducing asynchronous query execution to WordPress, the results of which the team plans to write about in the near future.</p>\n<blockquote><p>As an exercise, we evaluated the benefits of <a href=\"https://github.com/facebook/hhvm/tree/master/hphp/runtime/ext/async_mysql\" target=\"_blank\">async MySQL</a> in the WordPress environment. By modifying portions of WordPress to take advantage of the async capabilities offered by Hack and HHVM, we were able to examine the potential for performance gains through async execution. In our test environment we separated the MySQL and PHP hosting to separate machines within the same datacenter to approximate a realistic WordPress stack. The introduction of asynchronous query execution can demonstrate performance gains in both RPS and response time.</p></blockquote>\n<p>It will be interesting to see a more detailed report of the benefits they found from introducing async capabilities to WordPress. Overall, the lockdown provided an opportunity for collaboration across open source projects, resulting in a host of optimizations that will help OS frameworks perform better with HHVM in the future. The HHVM team plans to ship these improvements with the next release.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 12 Jun 2015 17:47:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Matt: Paul Ford: What is Code? | Bloomberg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45145\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://ma.tt/2015/06/paul-ford-what-is-code-bloomberg/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:376:\"<blockquote><p>We are here because the editor of this magazine asked me, “Can you tell me what code is?”</p></blockquote>\n<p><a href=\"http://www.bloomberg.com/graphics/2015-paul-ford-what-is-code/\">Paul Ford&#8217;s amazing What is Code? for Bloomberg</a>. I only spotted one mistake, of course from the Taupe Blazer guy: you&#8217;re never at the limits of WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 12 Jun 2015 00:29:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: StackExchange is Testing a Proposed Q&amp;A Site for WooCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44683\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wptavern.com/stackexchange-is-testing-a-proposed-qa-site-for-woocommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4111:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/woocommerce-qa-staging-site.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/woocommerce-qa-staging-site.jpg?resize=1025%2C428\" alt=\"woocommerce-qa-staging-site\" class=\"aligncenter size-full wp-image-45118\" /></a></p>\n<p>StackExchange community members have <a href=\"http://area51.stackexchange.com/proposals/80132/woocommerce\" target=\"_blank\">proposed</a> a new Q&amp;A site for users and developers of <a href=\"http://www.woothemes.com/woocommerce/\" target=\"_blank\">WooCommerce</a>. The proposal is currently in the <a href=\"http://area51.stackexchange.com/faq\" target=\"_blank\">&#8220;Definition&#8221; phase</a>, which means that participants are working to design the community by proposing hypothetical questions that embody the topic&#8217;s scope.</p>\n<p>So far for WooCommerce, popular hypothetical questions include:</p>\n<ul>\n<li>How do I handle the EU VATMOSS regulations in Woocommerce?</li>\n<li>How do I create an Order using WC REST API in my application?</li>\n<li>How to hide “add to cart” on free products?</li>\n<li>How to implement multiple versions of one digital product with different buyers&#8217; customizations?</li>\n</ul>\n<p>In order to move on to the next milestone, the site must have at least 40 questions that have a score of at least ten net votes (up minus down). The WooCommerce staging site needs the following:</p>\n<ul>\n<li>5 more followers</li>\n<li>33 more questions with a score of 10 or more</li>\n<li>People to max out upvoting quality questions already in the proposal (users can only vote 5 times)</li>\n</ul>\n<p>The <a href=\"http://wordpress.stackexchange.com/\" target=\"_blank\">StackExchange for general WordPress Development</a> is thriving with <a href=\"http://wptavern.com/wordpress-stackexchange-thrives-in-2014-with-17-million-page-views-and-14k-new-questions\" target=\"_blank\">17 million page views and 14K new questions</a> in 2014. However, questions regarding third party plugins are considered off-topic and will be closed by moderators, hence the need for a separate WooCommerce Q&amp;A site.</p>\n<p>Alex Miller, one of the supporters of the WooCommerce StackExchange proposal, believes that the WooCommerce community needs a place where developers can quickly get answers to questions.</p>\n<p>&#8220;The WooCommerce Community Forums seemed like a decent place but was shut down months ago for unknown reasons,&#8221; he said. &#8220;My experience with the Woo Community Forums is that it was too broad and the upvote downvote system was poorly handled &#8211; good questions got buried too quickly with the large influx of new questions.&#8221;</p>\n<p>In contrast, the StackExchange model pushes questions that have activity (edits, comments, answers) to the top of the frontpage and lower quality questions (downvoted, flagged) receive less attention.</p>\n<p>&#8220;Having a WooCommerce StackExchange site is also a great place for people with a great understanding of WooCommerce to document their knowledge for search engines to easily find,&#8221; Miller said. You can see an example of this by <a href=\"http://wordpress.stackexchange.com/questions?sort=votes\" target=\"_blank\">sorting the WPSE questions by votes</a> and reading the first few questions and answers.</p>\n<p>&#8220;I can only hope that with <a href=\"http://wptavern.com/automattic-acquires-woocommerce\" target=\"_blank\">Automattic&#8217;s acquisition of WooCommerce</a>, the forums will be reopened (WooCommunity forums have been shutdown for a few months now),&#8221; Miller said. &#8220;But either way I don&#8217;t think there is a much better platform than what the StackExchange offers.&#8221;</p>\n<p>As StackExchange Q&amp;A sites are entirely community driven, WooCommerce community members who are interested in seeing it succeed are encouraged to <a href=\"http://area51.stackexchange.com/users/login?returnurl=%2fproposals%2f80132%2fwoocommerce%3ftab%3dvotes\" target=\"_blank\">log into StackExchange</a> and create/upvote quality questions that represent the community&#8217;s interests.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Jun 2015 21:23:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WPTavern: Customizer Typography: A Proof-of-Concept Plugin for WordPress Theme Authors\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45017\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"http://wptavern.com/customizer-typography-a-proof-of-concept-plugin-for-wordpress-theme-authors\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3644:\"<p>One option that users often appreciate in themes is the ability to control typography without having to modify any code. Justin Tadlock has been experimenting with <a href=\"http://justintadlock.com/archives/2015/06/08/customizer-typography-project\" target=\"_blank\">adding a typography control class for the WordPress customizer</a>.</p>\n<p>Instead of writing a lengthy tutorial, he opted to create a a proof-of-concept plugin that demonstrates how theme authors might accomplish this. <a href=\"https://github.com/justintadlock/customizer-typography\" target=\"_blank\">Customizer Typography</a> is currently being developed on GitHub and Tadlock said it is &#8220;only meant for development purposes and to show one method of executing the idea.&#8221;</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/customize-typography-screen.png\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/customize-typography-screen.png?resize=1025%2C568\" alt=\"customize-typography-screen\" class=\"aligncenter size-full wp-image-45019\" /></a></p>\n<p>The plugin was created to provide testing for two things:</p>\n<ul>\n<li>Testing a customizer control class to handle typography</li>\n<li>Tying multiple customize settings to a single control</li>\n</ul>\n<p>&#8220;The most important was not having to add tons of code while still providing the developer complete control over each setting,&#8221; Tadlock said. &#8220;Fortunately, the Customization API in WordPress is pretty powerful and allows you to tie multiple settings to a single control.&#8221;</p>\n<p>The plugin currently provides controls for live previewing both paragraph and headings with various font family, font weight, font style, font size, and line height options. <a href=\"https://github.com/justintadlock/customizer-typography/blob/master/customize/control-typography.php#L207\" target=\"_blank\">Integrating Google Fonts</a> is on Tadlock&#8217;s to-do list, but at the moment he&#8217;s not working to build out the plugin as the ultimate solution.</p>\n<p>&#8220;Just to be clear, this is a proof of concept that I put together in an afternoon, not a polished solution,&#8221; he said. &#8220;The idea, for me at least, would be to eventually extract it and put it into themes.&#8221;</p>\n<p>I installed the plugin to play around with Twenty Fifteen and found that the experience of live previewing typography changes is very satisfying from a user standpoint. Although many custom theme options panels include basic typography controls, you often have to refresh the page to see how your changes applied. This kind of control is a prime candidate for integrating into the customizer.</p>\n<p>Tadlock&#8217;s example typography control class gives you a glimpse of what&#8217;s possible for theme authors who elect to build their options using the customizer. It&#8217;s these kinds of controls that truly solve a frustration and make it easier to personalize themes. The Customizer Typography plugin exemplifies the purpose of the customizer.</p>\n<p>You can <a href=\"https://github.com/justintadlock/customizer-typography\" target=\"_blank\">check out the plugin on GitHub</a> and install it to see the live previews in action. If you&#8217;re interested to learn more about building with the <a href=\"https://developer.wordpress.org/themes/advanced-topics/customizer-api/\" target=\"_blank\">Customizer API</a>, Tadlock published a post on the Make.WordPress.org/Themes blog that contains a long list of <a href=\"https://make.wordpress.org/themes/2015/05/07/customizer-tutorials-and-documentation/\" target=\"_blank\">customizer tutorials and documentation</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Jun 2015 18:00:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: WooCommerce 2.3.11 Patches Object Injection Vulnerability\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45099\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wptavern.com/woocommerce-2-3-11-patches-object-injection-vulnerability\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:884:\"<p><a href=\"http://develop.woothemes.com/woocommerce/2015/06/woocommerce-2-3-11-security-and-maintenance-release/\">WooCommerce 2.3.11</a> patches an object injection vulnerability <a href=\"https://blog.sucuri.net/2015/06/security-advisory-object-injection-vulnerability-in-woocommerce.html\">discovered by Sucuri</a>. According to the security research company, the vulnerability is only present when the <strong>PayPal Identity Token </strong>option is set in WooCommerce.</p>\n<p>Researchers used a combination of WordPress and WooCommerce components with a known PHP bug and were able to download critical files, including wp-config.php which has sensitive information. Versions <strong>2.0.20 &#8211; 2.3.10</strong> are considered vulnerable.</p>\n<p>In addition to the patch, the release also has a number of bug fixes. If you haven&#8217;t already, update as soon as possible.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Jun 2015 17:14:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WPTavern: WPWeekly Episode 195 – Recap of WordCamp Orange County 2015\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=45094&preview_id=45094\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wptavern.com/wpweekly-episode-195-recap-of-wordcamp-orange-county-2015\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2775:\"<p>In this episode, <a href=\"http://marcuscouch.com/\">Marcus Couch</a> and I recap <a href=\"https://oc.wordcamp.org/2015/\">WordCamp Orange County 2015</a> held in Costa Mesa, CA. We share our favorite sessions, highlights of the weekend, and I explain why I spent day two of the conference in my hotel room. During the second half of the show, we cover the news of the week, including the controversy surrounding the menu customizer plugin.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://wptavern.com/wordcamp-us-2015-now-accepting-applications-for-host-city\">WordCamp US 2015 Now Accepting Applications for Host City</a><br />\n<a href=\"https://make.wordpress.org/community/2015/06/10/ive-been-approached-by-a-couple-of-people/\">Clarification on WordCamp US Applications</a><br />\n<a href=\"http://wptavern.com/wordpress-core-contributors-call-for-user-testing-on-the-menu-customizer-plugin\">WordPress Core Contributors Call for User Testing on the Menu Customizer Plugin</a><br />\n<a href=\"https://apps.wordpress.org/2015/06/09/wordpress-for-ios-version-5-2/\">WordPress Mobile 5.2 Update Drops with added media capabilities</a><br />\n<a href=\"http://wptavern.com/woothemes-fixes-xss-vulnerability-in-products-using-the-prettyphoto-library\">WooThemes Fixes XSS Vulnerability in Products Using the prettyPhoto Library</a><br />\n<a href=\"http://develop.woothemes.com/woocommerce/2015/06/woocommerce-2-3-11-security-and-maintenance-release/\">WooCommerce 2.3.11 Security and Maintenance Release</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"https://wordpress.org/plugins/daily-logo/\">Daily Logo</a> is a simple and flexible plugin which allow users to display a different header or logo on their site every day.</p>\n<p><a href=\"https://wordpress.org/plugins/scheduled-stickiness/\">Scheduled Stickiness</a> sets and unsets the sticky flag on specified dates for a certain post based on meta fields.</p>\n<p><a href=\"https://wordpress.org/plugins/learnpress/\">LearnPress</a> is a comprehensive learning management system plugin for WordPress. It can be used to easily create and sell courses online.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, June 24th 9:30 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #195:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Jun 2015 15:56:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"WPTavern: WooThemes Fixes XSS Vulnerability in Products Using the prettyPhoto Library\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45080\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"http://wptavern.com/woothemes-fixes-xss-vulnerability-in-products-using-the-prettyphoto-library\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2531:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/WooThemesFeaturedImage2.png\"><img class=\"aligncenter size-full wp-image-45083\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/WooThemesFeaturedImage2.png?resize=648%2C196\" alt=\"WooThemesFeaturedImage2\" /></a>Jeff Ikus of WooThemes, <a href=\"http://develop.woothemes.com/themes/2015/06/09/prettyphoto-xss-theme-updates/\">announced</a> on the company&#8217;s themes development blog, that it has pushed out updates to all of its products that use the <a href=\"http://www.no-margin-for-errors.com/projects/prettyphoto-jquery-lightbox-clone/\">prettyPhoto library</a>. The update fixes a <a href=\"https://github.com/scaron/prettyphoto/issues/149\">DOM based cross-site scripting vulnerability </a>discovered in 2014.</p>\n<p><a href=\"http://www.no-margin-for-errors.com/projects/prettyphoto-jquery-lightbox-clone/\">prettyPhoto</a> is a jQuery lightbox clone used in a potentially large number of WordPress products. If you use a WordPress plugin or theme that relies on prettyPhoto, please get in touch with the author to make sure they&#8217;re aware of this security vulnerability. If you use the <a href=\"https://wordpress.org/plugins/prettyphoto/\">prettyPhoto WordPress plugin</a>, make sure it&#8217;s running version 1.2 as it contains the patched library.</p>\n<h2>Risky Business</h2>\n<p>In 2011, <a title=\"http://www.binarymoon.co.uk/2011/08/timthumb-2/\" href=\"http://www.binarymoon.co.uk/2011/08/timthumb-2/\">TimThumb made headlines</a> when a major security vulnerability was discovered and used to hack into several websites. At the time, Ben Gillbanks, the library&#8217;s maintainer, estimated 95% of all commercial WordPress themes supported TimThumb.</p>\n<p>At the end of 2014, a <a href=\"http://wptavern.com/100000-wordpress-sites-compromised-using-the-slider-revolution-security-vulnerability\">security vulnerability was discovered</a> in the Slider Revolution plugin that allowed more than 100k websites to be compromised.</p>\n<p>Using third-party scripts and libraries is not a bad thing. The practice however, comes with a set of risks. It&#8217;s up to developers to be vigilant and accept the responsibilities that come with relying on a third-party. It&#8217;s also imperative that developers do everything they can to update their products and users when a security vulnerability is discovered.</p>\n<p>If you&#8217;re a developer, let us know the criteria in determining which third-party scripts, libraries, and tools you use.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 10 Jun 2015 20:31:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"Post Status: Quick tip: Disconnect Jetpack from the WordPress.com side\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=12963\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"https://poststatus.com/quick-tip-disconnect-jetpack-from-the-wordpress-com-side/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2528:\"<p>About sixteen months ago, I wrote a post noting that it is <a href=\"https://poststatus.com/managing-jetpack-enabled-blogs-wordpress-com/\">really annoying to disconnect a WordPress.com account from a Jetpack install</a>. More annoying yet, is that you could not get rid of nonexistent Jetpack enabled websites from the WordPress.com &#8220;My Sites&#8221; section at all without contacting support.</p>\n<p>Over the years I collected quite a few Jetpack enabled websites connected to my WordPress.com username. Whether I was connecting a staging site or was too lazy to get a friend to setup their own account on WordPress.com, I ended up with a couple of dozen websites connected to my account that were not in my control.</p>\n<p>The traditional way to disconnect Jetpack from WordPress.com was via the site admin in the Jetpack settings. But over time, many of the sites I managed have went stagnant or completely offline, and there was no way to disconnect them anymore. But finally, you can disconnect Jetpack from the WordPress.com side.</p>\n<p>You can disconnect sites from the main &#8220;My Site&#8221; link (shown above) or the individual site (pictured below). Errored sites show up with a red warning side, and when you click the icon, the ability to permanently disconnect the site appears.</p>\n<p><img class=\"alignnone size-large wp-image-12965\" src=\"https://poststatus.com/wp-content/uploads/2015/06/wp-com-disconnect-solo-752x385.png\" alt=\"wp-com-disconnect-solo\" width=\"752\" height=\"385\" /></p>\n<p>This has been a near daily annoyance of mine for years. I&#8217;m happy to see it finally get resolution. Special thanks to Automattician <a href=\"https://twitter.com/jeherve/status/606369302216728576\">Jeremy Herve</a> for never forgetting about me.</p>\n<p>One more tip: if you go to your WordPress.com homepage often, and it doesn&#8217;t open up the page you want to be default for stats, you can set your default site under your <a href=\"https://wordpress.com/me/account\">account settings</a>. This is another annoyance of mine that I didn&#8217;t know had a solution until just now.</p>\n<p><img class=\"alignnone size-large wp-image-12966\" src=\"https://poststatus.com/wp-content/uploads/2015/06/wp-com-account-752x377.jpg\" alt=\"wp-com-account\" width=\"752\" height=\"377\" /></p>\n<p>I know creating really effective user interfaces and account management tools is really hard. But attention to small details is awesome. I&#8217;m glad the WordPress.com team took care of this one, even if it took a while.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 10 Jun 2015 18:18:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Matt: Peter Thiel on MBAs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45140\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"http://ma.tt/2015/06/peter-thiel-on-mbas/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:877:\"<blockquote><p>I think one challenge a lot of the business schools have is they end up attracting students who are very extroverted and have very low conviction, and they put them in this hot house environment for a few years — at the end of which, a large number of people go into whatever was the last trendy thing to do. They’ve done studies at Harvard Business School where they’ve found that the largest cohort always went into the wrong field. So in 1989, they all went to work for Michael Milken, a year or two before he went to jail. They were never interested in Silicon Valley except for 1999, 2000. The last decade their interest was housing and private equity.</p></blockquote>\n<p><a href=\"http://www.washingtonpost.com/blogs/on-leadership/wp/2014/10/10/peter-thiel-on-what-works-at-work/\">This entire interview with Peter Thiel is pretty interesting</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 10 Jun 2015 17:18:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WPTavern: WordPress Core Contributors Call for User Testing on the Menu Customizer Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=45034\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"http://wptavern.com/wordpress-core-contributors-call-for-user-testing-on-the-menu-customizer-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7228:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/menu-customizer-feature1.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/menu-customizer-feature1.jpg?resize=670%2C318\" alt=\"menu-customizer-feature\" class=\"aligncenter size-full wp-image-45053\" /></a></p>\n<p>Ryan Boren published a post to the Make/WordPress Core blog this afternoon, titled <a href=\"https://make.wordpress.org/core/2015/06/09/trust-live-preview-and-menus-in-the-customizer/\" target=\"_blank\">Trust, Live Preview, and Menus in the Customizer</a>. In it he clarified the reasons why he and several other core contributors are committed to iterating the customizer and identified the feature as a means of building user trust through live previews.</p>\n<blockquote><p>Being able to make non-destructive changes and preview them is an important component of building that trust. This is perhaps most noticeable in the “save and surprise” approach of the widgets admin screen – every time you add a new widget, modify its settings, or move one around, the changes are saved and appear live on your site, even if you’re not ready yet. The customizer is our framework for live previewing changes. We are committed to providing live preview for all aspects of site customization and making it usable on all devices from phones to large screens.</p></blockquote>\n<p>Boren briefly summarized the history of the customizer and alluded to a few possibilities the framework may offer in the future:</p>\n<blockquote><p>The customizer has come a long way, but it still lacks some features and needs time to mature. We have many improvements planned and in progress, including transactions, partial refresh, theme installation, speedier loading, scaling to large screens, and possibly even integration with front end editing. Our live preview framework offers many possibilities.</p></blockquote>\n<p>The Menu Customizer plugin was <a href=\"http://wptavern.com/menu-customizer-tentatively-approved-for-wordpress-4-3\" target=\"_blank\">tentatively approved for merge</a> during last week&#8217;s core development meeting. In order for the it to be officially approved for merge on June 17th, the plugin will need to meet the <a href=\"https://make.wordpress.org/core/handbook/how-the-release-cycle-works/features-as-plugins/\" target=\"_blank\">feature plugin criteria</a> outlined in the core handbook.</p>\n<p>&#8220;We have eight days to get the Menu Customizer plugin ready for merge,&#8221; Boren said. During this time the <a href=\"https://make.wordpress.org/flow/\" target=\"_blank\">flow team</a> will be testing and documenting the flow and visuals for the menu customizer.</p>\n<p>Boren invited anyone who wants to contribute to this effort to create flow comparisons of the existing flow through Appearance > Menus versus flow through the customizer. This essentially involves walking through the experience of setting up menus, taking screenshots of the flow, and publishing them as a captioned gallery.</p>\n<p>&#8220;Please help us capture the flows through Appearance > Menus used by you and your clients,&#8221; he said. &#8220;We need this information to ensure our new interfaces are mindful and aware of how WordPress is actually used.&#8221;</p>\n<p>Anyone can contribute to WordPress in this way, as it doesn&#8217;t require any coding. The core team is looking for people to capture real user scenarios to help in making the final decision.</p>\n<h3>There is No Timeline for Removing the Appearance > Menus Screen</h3>\n<p>In the original <a href=\"https://make.wordpress.org/core/2015/06/03/feature-plugin-merge-proposal-menu-customizer/\" target=\"_blank\">merge proposal</a> for the Menu Customizer the plugin&#8217;s author, Nick Halsey, outlined what he called a &#8220;fairly aggressive&#8221; plan for the removal of the old menus admin screen. As contributor resources are scarce when it comes to the Menus component, Halsey favored focusing all new development on the UI in the customizer.</p>\n<p>The timeline he outlined was for WordPress 4.3 to point the Menus link in the admin bar to Menus in the customizer and later releases (WordPress 4.5 or 4.6) would remove all core links to the Menus admin screen.</p>\n<p>WordPress users reacted strongly to this aggressive timeline for removing the old menus screen, but the timeline was merely a suggestion as part of the proposal. Halsey was not keen on merging the plugin without a definitive timeline for removing the old menus, a factor which he considered a &#8220;<a href=\"https://wordpress.slack.com/archives/core/p1433384682001602\" target=\"_blank\">dealbreaker</a>&#8221; for merge.</p>\n<p>However, WordPress 4.3 release lead Konstantin Obenland confirmed that no official timeline has been set.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/pollyplummer\">@pollyplummer</a> There is no timeline either way.</p>\n<p>&mdash; Konstantin Obenland (@obenland) <a href=\"https://twitter.com/obenland/status/608377778933743616\">June 9, 2015</a></p></blockquote>\n<p></p>\n<p>Ryan Boren also confirmed that WordPress will continue to maintain the Appearance > Menus screen should the plugin be officially approved for merge in the coming days:</p>\n<blockquote><p>Meanwhile, the Appearance screens will remain and will be maintained. Appearance > Menus recently received some attention in the form of a few fixes. More attention is needed and will be given. There are still differences in the flows each approach best enables, whether it’s new site/theme setup, small maintenance tasks, or dedicated content managers for heavy usage of widgets, menus, or other pieces of content that benefit from having a preview mechanism. We should gather quantifiable metrics when it comes to performance and time to completion for a given flow, as well as evaluating the less-objectively-quantifiable perceived performance. <strong>There may come a time where the worlds converge; however, that time is not now.</strong></p></blockquote>\n<p>This confirmation should assuage those whose opposition to the Menu Customizer was solely based on the aggressive timeline proposed for removing the old menus screen.</p>\n<p>The great divide on the Menu Customizer revolves around one aspect of improvement that Boren mentioned in his paragraph about the future of the customizer: <strong>scaling to large screens</strong>. The vast majority of WordPress users and developers who are following this debate are those who would be more likely to configure a menu in a desktop environment and not via mobile (where the customizer is currently designed to shine).</p>\n<p>Many who oppose the merge of the plugin have identified the cramped UI as the primary reason that it does not provide a better experience for users. You would be hard pressed to find anyone who is opposed to live previews or better usability on mobile devices.</p>\n<p>Those who manage WordPress sites via desktop are not willing to sacrifice the old menus screen for a new UI that currently caters primarily to smaller devices. Until the Menu Customizer can adequately provide a UI that fully adapts to all screen sizes, resistance to the feature is likely to continue.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Jun 2015 22:34:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Matt: Trust but Preview\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45138\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"http://ma.tt/2015/06/trust-but-preview/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:273:\"<p>If you&#8217;re following along with the customizer and menu work for the next version of WordPress, check out <a href=\"https://make.wordpress.org/core/2015/06/09/trust-live-preview-and-menus-in-the-customizer/\">Trust, Live Preview, and Menus in the Customizer</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Jun 2015 20:00:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"WPTavern: Introducing the WP Tavern Wapuu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44960\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wptavern.com/introducing-the-wp-tavern-wapuu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6761:\"<p>The <a href=\"http://wapuu.jp/\">Wapuu craze</a> has spread far and wide. From its <a href=\"http://wptavern.com/community-translation-and-wapuu-how-japan-is-shaping-wordpress-history\">origin in Japan</a>, to <a href=\"http://wptavern.com/scott-evans-on-designing-the-punk-wapuu-for-wordcamp-london-2015\">WordCamp London</a>, and across the US, Wapuu has become quite the traveler. While the mascot has mostly represented WordCamps, site owners are creating a custom version of the mascot to represent their sites.</p>\n<p><a href=\"http://www.mynameismichelle.com/\">Michelle Schulp</a>, a graphic designer who runs <a href=\"http://marktimemedia.com/\">Marktimemedia, </a>has created a number of Wapuu&#8217;s for WordCamps and websites. She was gracious enough to create one specifically for the Tavern.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/wapuu-wptavern.png\"><img class=\"size-large wp-image-45028\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/wapuu-wptavern.png?resize=418%2C500\" alt=\"WP Tavern Wapuu\" /></a>WP Tavern Wapuu\n<p>Schulp created the mascot with Adobe Illustrator using the original .svg files provided on the original <a href=\"https://github.com/jawordpressorg/wapuu\">Wapuu Github repository</a>. She doesn&#8217;t plan on writing tutorials to modify the base Wapuu. Instead, she is creating <a href=\"https://github.com/marktimemedia/my-wapuu\">a base Wapuu</a> that will have separated pieces so its easier to modify.</p>\n<p>She often sketches and re-draws Wapuus that are not in their normal position.</p>\n<p>&#8220;Actually, most of the Wapuus are slightly modified to make it easier for them to hold or interact with their elements. I thought of him like a cartoon character (fluid) more so than a logo or icon (rigid),&#8221; Schulp told the Tavern.</p>\n<p>Schulp has always had an interest in sketching cartoons. For WordCamp Miami 2015, she created a variety of custom-made My Little Pony stickers.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/MyLittlePonyStickers.jpg\"><img class=\"wp-image-44978 size-large\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/MyLittlePonyStickers.jpg?resize=309%2C500\" alt=\"My Little Pony Stickers\" /></a>My Little Pony Stickers\n<p>She also uses her skills to create <a href=\"https://speakerdeck.com/marktimemedia/developer-collaboration\">unique slide decks</a> filled with colorful illustrations.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/CustomSlideDeck.png\"><img class=\"wp-image-44983 size-large\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/CustomSlideDeck.png?resize=500%2C415\" alt=\"Custom Slide Deck\" /></a>Custom Slide Deck\n<h2>From WordCamps to Websites and Eventually Companies</h2>\n<p>Wapuu is considered the official mascot character of WordPress and was designed by Kazuko Kaneuchi in 2011. It’s <a href=\"https://github.com/jawordpressorg/wapuu\" target=\"_blank\">distributed under the GPLv2 or later</a> and can be modified by anyone. The character is used to represent different cultures and regions of the world.</p>\n<p>Now that Wapuu is showing up as a mascot for sites that focus on WordPress, the question is, when will it be used to represent companies in the WordPress ecosystem?</p>\n<p>Shortly after <a href=\"http://wptavern.com/automattic-acquires-woocommerce\">Automattic acquired WooThemes</a>, Nick Hamze was criticized on the Advanced WordPress Facebook group for creating a <a href=\"http://blog.nickhamze.com/2015/05/19/hiro-wapuu-bffs/\">Wapuu dressed up like a ninja</a>.</p>\n<blockquote><p>If the graphic was created by WooThemes and independently of the acquisition I&#8217;d think oh cute, WooTheme&#8217;s mascot is teaching WordPress&#8217; mascot how to be a ninja, best friends forever for sure.</p>\n<p>Instead, it came from an Automattician and in the context of Automattic acquiring WooThemes, to me it reads that Automattic is using Wapuu, which just bugs me.</p></blockquote>\n<p>At WordCamp Miami 2015, Rocketgenius came under fire for creating swag that features Wapuu wearing a space suit with a rocket patch on its arm.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/carlhancock\">@carlhancock</a> Wapuu is for promoting WordPress. It promotes a open source project and not a company.</p>\n<p>&mdash; Marko Heijnen (@markoheijnen) <a href=\"https://twitter.com/markoheijnen/status/605072873586356224\">May 31, 2015</a></p></blockquote>\n<p></p>\n<p>This is what the swag looks like. The logo is subtle in nature and if you didn&#8217;t already know it represents Rocketgenius, it would fit naturally into the design.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/SpaceWapuu.jpg\"><img class=\"wp-image-44989 size-large\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/06/SpaceWapuu.jpg?resize=375%2C500\" alt=\"Space Wapuu With Rocket Patch\" /></a>Space Wapuu With Rocket Patch\n<p>It&#8217;s important to note that there are no rules in how Wapuu can be used. The only guideline is maintaining Kaneuchi&#8217;s copyright. The mascot has appeared on physical products such as nails, cakes, and stuffed animals.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wapuu-everywhere.jpg\"><img class=\"size-full wp-image-43945\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2015/05/wapuu-everywhere.jpg?resize=1025%2C703\" alt=\"photo credit:  Naoko Takano - Learnings from Growing Local WordPress Communities\" /></a>photo credit:<br />Naoko Takano &#8211; <a href=\"http://www.slideshare.net/naokomc/wordcamp-europe2013/47\">Learnings from Growing Local WordPress Communities</a>\n<p>Schulp says she plans to create more Wapuus when the inspiration strikes. &#8220;I like to imagine Wapuu in a ton of different circumstances and my plan is to create more <em>slice of life</em> Wapuus as the inspiration strikes, maybe similar to how you can express things with Facebook stickers.&#8221;</p>\n<p>&#8220;Though Wapuu is open source and we can all use him and I&#8217;ve got good intentions, he isn&#8217;t mine so I&#8217;ll always defer to and respect the community that created it.&#8221;</p>\n<h2>Community Protection</h2>\n<p>The use of Wapuu is open for interpretation but I don&#8217;t see a problem with companies participating in the craze and creating one of their own. Unlike the WordPress logo, which is trademarked, Wapuu is free of such restrictions meaning anyone can use it for anything, including commercial endeavors.</p>\n<p>The community needs to protect Wapuu from enterprises that want to claim it as their own. We must respect its origins and give credit where credit is due. Other than that, the more Wapuus the better!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Jun 2015 18:31:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"WPTavern: Prescription for a Stalled WordPress Agency: Mario Peshev’s Advice for Growing Development Services\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44596\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:117:\"http://wptavern.com/prescription-for-a-stalled-wordpress-agency-mario-peshevs-advice-for-growing-development-services\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2629:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/clients.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/clients.jpg?resize=1025%2C504\" alt=\"photo credit: Alejandro Escamilla\" class=\"size-full wp-image-45014\" /></a>photo credit: <a href=\"https://stocksnap.io/photo/96E1A8F1CB\">Alejandro Escamilla</a>\n<p>WordPress agencies provide a critical connection point between users and the software by building custom solutions and guiding some of the more complex implementations. Yet client work is challenging, and many developers who work in it are concurrently planning their escape into product businesses.</p>\n<p>Growing an agency reliably is one of the more difficult business endeavors one can embark upon in the WordPress ecosystem. That&#8217;s why many attempts linger at one or two person shops, and very few grow to become the powerhouse agencies that can accommodate enterprise level clients.</p>\n<p><a href=\"http://devwp.eu/\" target=\"_blank\">Mario Peshev</a>, an agency owner specializing in SaaS solutions, wrote an excellent piece on <a href=\"http://devwp.eu/outsourcing-and-hiring-remote-talent/\" target=\"_blank\">Outsourcing and Hiring Remote Talent</a>. As strategic hiring is the lifeblood of any agency, it&#8217;s a skill that owners are eager to refine.</p>\n<p>&#8220;Small businesses are not easy to run,&#8221; he said. &#8220;Growing from a one man show to two people is really hard.&#8221; Peshev&#8217;s article includes a wealth of advice from the trenches on topics that every WordPress agency owner has struggled with, especially in the beginning. He covers the following topics in depth:</p>\n<ul>\n<li>Tips on hiring technical people remotely</li>\n<li>Strategies for hiring experts, junior developers, and trainees</li>\n<li>Scaling a business and growing a team via outsourcing</li>\n<li>When and why you might hire a consultant</li>\n<li>The benefits of leasing employees</li>\n<li>Outsourcing to another agency</li>\n<li>When it makes sense to hire a freelancer</li>\n<li>How to find WordPress talent</li>\n</ul>\n<p>Peshev blogs regularly on WordPress development and business topics, and this <a href=\"http://devwp.eu/outsourcing-and-hiring-remote-talent/\" target=\"_blank\">post</a> is a must read for any business owner who is struggling to grow a stalled agency. There&#8217;s no simple recipe for success when you&#8217;re in the business of helping clients harness the power of WordPress. Peshev&#8217;s post doesn&#8217;t offer a single magic formula for growing your agency but instead outlines various strategies and scenarios where they might be beneficial.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Jun 2015 15:06:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Matt: Online Privacy Lie\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45136\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://ma.tt/2015/06/online-privacy-lie/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:469:\"<p>Techcrunch has a really great essay by Natasha Lomas that I think got missed, <a href=\"http://techcrunch.com/2015/06/06/the-online-privacy-lie-is-unraveling/\">The Online Privacy Lie Is Unraveling</a>.</p>\n<blockquote><p>Americans believe it is futile to manage what companies can learn about them. Our study reveals that more than half do not want to lose control over their information but also believe this loss of control has already happened.</p></blockquote>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Jun 2015 04:57:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: Brighton, UK to Host Europe’s First BuddyCamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44932\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wptavern.com/brighton-uk-to-host-europes-first-buddycamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3385:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/buddycamp-brighton.jpg\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2015/06/buddycamp-brighton.jpg?resize=670%2C318\" alt=\"buddycamp-brighton\" class=\"aligncenter size-full wp-image-44976\" /></a></p>\n<p>BuddyPress fans, mark your calendars! <a href=\"http://brighton.buddycamp.org/2015/\" target=\"_blank\">BuddyCamp Brighton</a>, Europe’s very first BuddyPress conference, is just two months away. The event will be held at Clearleft’s 68 Middle Street venue on August 8, 2015. This venue has a maximum capacity of 60 people, so tickets are likely to sell out fast.</p>\n<p>BuddyPress lead developer <a href=\"https://twitter.com/pgibbs\" target=\"_blank\">Paul Gibbs</a> and contributor <a href=\"https://twitter.com/karmatosed\" target=\"_blank\">Tammie Lister</a> are teaming up to organize the event and put out the <a href=\"http://brighton.buddycamp.org/2015/call-for-speakers/\" target=\"_blank\">call for speakers</a> and <a href=\"http://brighton.buddycamp.org/2015/call-for-sponsors/\" target=\"_blank\">sponsors</a> today.</p>\n<p>&#8220;The really exciting thing is that this is going to be the first BuddyCamp outside North America/Canada &#8211; the first in Europe,&#8221; Gibbs said. &#8220;From my role in the BuddyPress project, I know we have many fans across the continent, and it&#8217;s those people we want to come to BuddyCamp, so we&#8217;re going to focus on making the event as accessible as possible for all those visitors.&#8221;</p>\n<p>Brighton has a thriving <a href=\"http://www.meetup.com/WordUp-Brighton/\" target=\"_blank\">local WordPress community</a> and BuddyPress interest runs deep throughout the UK, making it a strategic location for hosting Europe&#8217;s first BuddyCamp.</p>\n<p>&#8220;Brighton itself has a great tech community, as does London obviously (which is just over an hour away on train), so there&#8217;s a lot of potential,&#8221; Gibbs said.</p>\n<p>Organizers are hoping to receive a wide range of presentation subjects from potential speakers, including both beginner and technical topics.</p>\n<p>&#8220;We&#8217;re pretty keen on beginners content, mixed with a range of showcases and great examples of the potential of BuddyPress,&#8221; he said.</p>\n<p>Gibbs confirmed that peripheral bbPress topics are also welcome among speaker submissions, even though the event will focus primarily on BuddyPress.</p>\n<p>&#8220;I think there&#8217;s a lot of overlap, especially around community management and development,&#8221; he said. &#8220;We&#8217;d be happy to receive talk proposals in these areas.&#8221;</p>\n<p>BuddyCamp Brighton is a historic event for the European BuddyPress community and will be formatted as an intimate gathering where attendees of all skill levels are welcome. BuddyPress enthusiasts will learn more about the varied uses of the plugin and will also have the opportunity to get connected to core contributors in the region.</p>\n<p>&#8220;If people go home happy and inspired to use BuddyPress to help them grow a community, then I&#8217;ll be very happy,&#8221; Gibbs said.</p>\n<p>Those interested to attend can <a href=\"http://brighton.buddycamp.org/\" target=\"_blank\">subscribe to email updates</a> or follow <a href=\"https://twitter.com/BuddyCampUK\" target=\"_blank\">@BuddyCampUK</a> on Twitter to be notified when tickets go on sale.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 08 Jun 2015 22:06:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"WPTavern: WordPress Theme Review Team Seeks Feedback on the Review Process, Themes, and the Directory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44912\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"http://wptavern.com/wordpress-theme-review-team-seeks-feedback-on-the-review-process-themes-and-the-directory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5390:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/survey.jpg\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2015/06/survey.jpg?resize=1025%2C507\" alt=\"photo credit: Lukasz Kowalewski\" class=\"size-full wp-image-44957\" /></a>photo credit: <a href=\"https://stocksnap.io/photo/FI3UYVGNFD\">Lukasz Kowalewski</a>\n<p>The WordPress Theme Review Team (TRT) is currently seeking feedback via three separate surveys on the <a href=\"https://make.wordpress.org/themes/2015/06/05/theme-review-process-survey/\" target=\"_blank\">review process</a>, <a href=\"https://make.wordpress.org/themes/2015/06/05/theme-usability-survey/\" target=\"_blank\">themes</a>, and the <a href=\"https://make.wordpress.org/themes/2015/06/05/theme-directory-survey/\" target=\"_blank\">directory</a>. After weathering several months of increasingly negative community feedback, the team is now looking to users and theme authors to help shape its <a href=\"https://make.wordpress.org/themes/2015/06/05/suggested-roadmap/\" target=\"_blank\">roadmap</a> for the future.</p>\n<p>The team&#8217;s controversial decision to <a href=\"http://wptavern.com/wordpress-org-now-requires-theme-authors-to-use-the-customizer-to-build-theme-options\" target=\"_blank\">require theme authors to use the customizer for building theme options</a> ignited a heated debate, which continued as more guidelines came up for consideration. Community members expressed concern that more rules and regulations might limit the future of WordPress themes. The conversation surrounding violations of the &#8220;<a href=\"http://wptavern.com/wordpress-theme-review-team-is-cracking-down-on-violations-of-the-presentation-vs-functionality-guideline\" target=\"_blank\">Presentation vs. Functionality</a>&#8221; guideline contributed to the team&#8217;s decision to reevaluate the general direction of the official directory and the process of getting a theme approved.</p>\n<p>Following a brainstorming session with Matt Mullenweg on May 28th, the TRT decided to step back and look at the process and the directory in a new way. This opened up many new avenues for the team to explore, and the three user surveys are a response to the new direction.</p>\n<p>TRT member Tammie Lister opened up the feedback channels with an <a href=\"https://make.wordpress.org/themes/2015/06/05/theme-directory-survey/\" target=\"_blank\">overview</a> of the purpose behind the surveys:</p>\n<blockquote><p>As a part of our <a href=\"https://make.wordpress.org/themes/2015/06/05/suggested-roadmap/\" target=\"_blank\">Theme Directory Roadmap</a>, we are going to be taking a good look at every aspect of the theme submission, review, and browsing experience on WordPress.org.</p>\n<p>To kick off the research phase of our roadmap, we’re issuing a series of surveys targeting theme authors, theme reviewers, and WordPress users. In addition to surveying users, we’ll also be analyzing other theme directories on the web, and reviewing other theme submission processes to see what we can bring back to WordPress.</p></blockquote>\n<p>The <a href=\"https://make.wordpress.org/themes/2015/06/05/theme-usability-survey/\" target=\"_blank\">Usability survey</a> is an opportunity for anyone who has ever used a WordPress.org-hosted theme to voice an opinion on that experience. The survey briefly touches on whether the user views a demo before downloading the theme. The quality of theme demos is currently a hot topic of discussion, as many believe that the current demos are woefully inadequate at showing a theme&#8217;s potential.</p>\n<p>The <a href=\"https://make.wordpress.org/themes/2015/06/05/theme-review-process-survey/\" target=\"_blank\">Theme Review Process survey</a> is specifically for theme authors and includes open-ended questions regarding the process and obstacles to getting a theme launched.</p>\n<p>The <a href=\"http://13233232.polldaddy.com/s/what-is-it-like-to-have-your-theme-reviewed\" target=\"_blank\">Finding a WordPress Theme</a> survey concerns the directory, but it is the most limited in scope. The survey includes just one question about where users look for a theme when starting a new site.</p>\n<p>One WordPress theme developer <a href=\"https://make.wordpress.org/themes/2015/06/05/theme-directory-survey/#comment-41962\" target=\"_blank\">commented on the survey</a>, suggesting a few more detailed questions that could be helpful, but Lister indicated that the TRT is examining the first round of responses before moving on to further research.</p>\n<blockquote><p>At this stage we should not get into too much detail as we want to get an over-view. We also have some stats we can use in conjunction. This is not something we’re going to change format wise this time around.</p></blockquote>\n<p>The three surveys are a unique opportunity for users to voice their opinions on the experience of using WordPress.org themes, and take just minutes to complete. Hopefully, when the next stage of research is launched they will survey users on more specific concerns.</p>\n<p>The TRT&#8217;s request for feedback marks the beginning of a radical shift in the direction of the team. Instead of instituting more guidelines, TRT is looking at better ways to encourage creativity among theme authors and improve the process of submitting themes. The directory should also be receiving some useful improvements in the near future as the result of user feedback.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 08 Jun 2015 19:02:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Akismet: Akismet WordPress Plugin 3.1.2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1849\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://blog.akismet.com/2015/06/08/akismet-3-1-2-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1209:\"<p>Version 3.1.2 of <a href=\"http://wordpress.org/plugins/akismet/\">the Akismet plugin for WordPress</a> is now available.</p>\n<p>This update includes seventeen fixes and enhancements; they&#8217;re summarized in the <a href=\"https://wordpress.org/plugins/akismet/changelog/\">changelog</a> (or for all of the details, the <a href=\"https://plugins.trac.wordpress.org/log/akismet/trunk\">revision log</a>), but notably, Akismet will be easier to set up, use less space in your database, and be better protected against security holes &#8212; specifically ones in other plugins.</p>\n<p>To upgrade, visit the Updates page of your WordPress dashboard and follow the instructions. If you need to download the plugin zip file directly, links to all versions are available in <a href=\"http://wordpress.org/plugins/akismet/\">the WordPress plugins directory</a>.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1849/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1849/\" /></a> <img alt=\"\" border=\"0\" src=\"http://pixel.wp.com/b.gif?host=blog.akismet.com&blog=116920&post=1849&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 08 Jun 2015 02:50:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Christopher Finke\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"Matt: The Agency – NYTimes.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://ma.tt/2015/06/the-agency-nytimes-com/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:372:\"<blockquote><p>From a nondescript office building in St. Petersburg, Russia, an army of well-paid “trolls” has tried to wreak havoc all around the Internet — and in real-life American communities.</p></blockquote>\n<p>This story of Adrian Chen in Russian <a href=\"http://www.nytimes.com/2015/06/07/magazine/the-agency.html\">definitely turns weird at the end</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 07 Jun 2015 14:52:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"Matt: Aca-Awesome : Kay Cannon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45130\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://ma.tt/2015/06/aca-awesome-kay-cannon/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:380:\"<p>Pitch Perfect and its sequel, which I saw a few weekends ago, are the best geeky kind of fun (though I thought there were some jokes that fell flat in the latest). Longreads has an interview with Kay Cannon, the Pitch Perfect screenwriter, <a href=\"http://blog.longreads.com/2015/05/27/how-to-be-aca-awesome/\">How to Be Aca-Awesome and the changing definition of cool</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 07 Jun 2015 05:21:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Matt: Favorite Rappers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=45120\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"http://ma.tt/2015/06/favorite-rappers/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:239:\"<p>Someone asked me the other day who my favorite rappers were, here they are in no particular order:</p>\n<p>Pre-2000: Big Pun, Jay Z, Nas, Ludacris, Method Man.</p>\n<p>Post-2000: Kendrick Lamar, Kanye, Childish Gambino, J Cole, Drake.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 06 Jun 2015 04:02:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WPTavern: A Primer on Writing Good Documentation\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44807\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wptavern.com/a-primer-on-writing-good-documentation\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8612:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2015/06/JeffMatsonThumbnail.jpg\"><img class=\"alignright size-thumbnail wp-image-44911\" src=\"http://wptavern.com/wp-content/uploads/2015/06/JeffMatsonThumbnail-150x150.jpg\" alt=\"JeffMatsonThumbnail\" width=\"150\" height=\"150\" /></a>This post was contributed by guest author <a href=\"http://jeffmatson.net/\">Jeff Matson</a>. Jeff is the head of documentation for <a href=\"http://www.gravityforms.com/\">GravityForms</a>. He is the creator of the <a href=\"https://wordpress.org/plugins/heartbeat-control/\">Heartbeat Control</a> WordPress plugin and is a fan of the 90s.</p>\n<hr />\n<p>Often times, documentation is the most underrated piece of the development process. When we look at rockstars in the WordPress community, we typically look at developers, designers, and marketers. Little is known about the documentation writers out there who shed their blood, sweat, and tears to ensure everything runs smoothly.</p>\n<p>This post is about those who day in, and day out stare at endless lines of code to decipher what the developer was thinking, and the true meaning behind the code that exists.</p>\n<h2>Good Documentation is More Than Words</h2>\n<a href=\"http://wptavern.com/wp-content/uploads/2015/06/DocumentationWords.png\"><img class=\"size-full wp-image-44914\" src=\"http://wptavern.com/wp-content/uploads/2015/06/DocumentationWords.png\" alt=\"Documentation Words\" width=\"730\" height=\"295\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/80719942@N00/4733367729\">Variatie &#8211; Tekst</a> &#8211; <a href=\"https://creativecommons.org/licenses/by/2.0/\">(license)</a>\n<p>Good documentation writers provide more than an instruction manual, they provide an experience. I have known excellent documenters, coached beginners, and the largest difference between them is understanding the brain of those reading it. Just like a novel, documentation has a flow that keeps the reader interested and ingesting more information than they realize.</p>\n<p>Quality documentation targets the users that are most likely to read it. It also provides a point of reference for those who are more unlikely to read it. For example, if documenting a particular hook, it’s typically assumed that a developer will be reading it, but what about those who have little development experience?</p>\n<p>A good documentation writer will provide a point of reference for those who need more of a push in the right direction, without the need to contact support to spell it out for them.</p>\n<h2>Documentation Has a Larger Impact Than You Think</h2>\n<a href=\"http://wptavern.com/wp-content/uploads/2015/06/ImpactImage.png\"><img class=\"size-full wp-image-44916\" src=\"http://wptavern.com/wp-content/uploads/2015/06/ImpactImage.png\" alt=\"Impact Image\" width=\"585\" height=\"298\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/24113168@N03/3891599149\">Eruption</a> &#8211; <a href=\"https://creativecommons.org/licenses/by/2.0/\">(license)</a>\n<p>Most simply ignore documentation, pushing it off into the endless abyss until they can’t take it anymore. I’m guilty of the same thing in some cases. What those people don’t realize, is that every moment their plugin or theme is left undocumented, user experience suffers.</p>\n<p>Let’s take a look at your most common support ticket. If you better documented that issue, would those tickets go away entirely? Probably not. Would you get fewer tickets regarding the issue as well as increase you or your support agent&#8217;s productivity? I guarantee it. I think we could all use fewer support tickets.</p>\n<p>As I mentioned previously, documentation makes a dramatic impact on user experience. If the user is able to locate the information easily and efficiently, they have saved their own time as well as yours. The average world life expectancy is 66.57 years and your users would rather be doing something else with their lives than fiddling around with poorly written documentation.</p>\n<p>If a customer sees that you have put quite a bit of time and effort into your documentation, they will, whether consciously or not, better appreciate you. Good documentation shows you care about them after the initial sale.</p>\n<p>Have you ever been left high and dry after spending hard-earned money and soon regretted the purchase? I think we all have. With proper documentation, you can avoid passing that feeling off to your customers.</p>\n<h2>How Can You Write Better Documentation?</h2>\n<p>The first step is to stop avoiding it. Once you&#8217;re good at it, writing documentation is more of a pleasurable experience than you think. In fact, it will become second nature. Just like everything else in the world, practice makes perfect.</p>\n<p>One of the first steps you want to take when deciding to take your documentation to the next level is to determine your pain points. What are you being contacted about? If you start blindly writing about things, you may find that what you’re writing about isn’t making as much of an impact you would like it to.</p>\n<p>One of the best techniques I have discovered is to track the number of tickets that are documented vs. those that are not, and break those that are not into categories. This way, you can better target your pain points, and revise the parts that may not be as helpful as they should be.</p>\n<p>After you have determined what documentation you should write, you should determine your target audience, and break it down into developers, users, and power users. This helps you cater to that particular audience. We’ll go over how to target those users a bit later.</p>\n<p>Next, you want to break down the document. For developers, you’ll want to break it down into raw information (accepted arguments, return values, etc.), specific examples and use-cases. For users, the best course of action is a walkthrough. Every step they will need to take, regardless of how trivial it may seem, is critical.</p>\n<p>Spell it out to them every step of the way. Documenting for power users is very similar to a user scenario, but more structured and scannable. Be clear, but allow them to easily jump to where they need to go without reading the previous step first.</p>\n<h2>The Art of Writing Better Documentation</h2>\n<a href=\"http://wptavern.com/wp-content/uploads/2015/06/DocumentationArt.png\"><img class=\"size-full wp-image-44917\" src=\"http://wptavern.com/wp-content/uploads/2015/06/DocumentationArt.png\" alt=\"Documentation Art\" width=\"497\" height=\"249\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/41455403@N00/458033123\">Space invader. Paris. Gare de lyon</a> &#8211; <a href=\"https://creativecommons.org/licenses/by-sa/2.0/\">(license)</a>\n<p>When it comes to the art of writing your documentation, write in a way that best targets your audience, but also use simple language that you know they will understand. One of the best reasons for this is due to translations. While Google translate does an excellent job, it’s much easier to translate the simple vocabulary of a 5th grader than that contained within a post-grad thesis.</p>\n<p>Within your content, don’t be afraid to link to relevant content. This will allow you to avoid repeating yourself through multiple documents, as well as allow the reader to back-track if they need more information about a particular subject. After all, your main goals are to make the user happy, and save yourself time.</p>\n<p>The documentation process doesn’t stop after you press the <strong>publish</strong> button. Go back and revise every document as needed. Almost immediately after the document is published, go back and see if the support tickets you tracked have declined, and traffic to that particular article has increased. Usually, if you’re getting more traffic to an article, it’s helping. If you’re getting more traffic but the same number of support tickets, you may want to look into that article to see why.</p>\n<h2>What We Have Learned</h2>\n<p>First, I hope that after making it this far, you have a better appreciation for those in the trenches writing the documentation that most of us take for granted. It truly is an art form that many of us who write documentation for a living truly enjoy and put many, many hours into.</p>\n<p>I also hope that you come away from this article thinking more about your existing documentation and how it can be improved. Proper documentation can be extremely rewarding and once in practice, can actually be quite fun to write.</p>\n<p>Document early, document often. A great product is more than great code, it’s also beautifully documented.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 05 Jun 2015 21:26:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WPTavern: Menu Customizer Tentatively Approved for WordPress 4.3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44894\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://wptavern.com/menu-customizer-tentatively-approved-for-wordpress-4-3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2520:\"<p>WordPress 4.3 release lead Konstantin Obenland posted <a href=\"https://make.wordpress.org/core/2015/06/05/dev-chat-summary-june-3/\" target=\"_blank\">notes</a> from this week&#8217;s core development chat, confirming that the <a href=\"http://wptavern.com/menu-customizer-officially-proposed-for-merge-into-wordpress-4-3\" target=\"_blank\">Menu Customizer</a> plugin has been conditionally approved to merge. The approval is pending a few conditions that will be required before officially merging it:</p>\n<ul>\n<li>Complete a11y audit.</li>\n<li>Address possible blockers.</li>\n<li>Merge php tests.</li>\n<li>Add JS tests.</li>\n</ul>\n<p>One of the most controversial aspects of the <a href=\"https://make.wordpress.org/core/2015/06/03/feature-plugin-merge-proposal-menu-customizer/\" target=\"_blank\">proposal</a> submitted by project leader Nick Halsey was the timeline he outlined for removing all core links to the old Menus admin screen in future releases. Commenters on the proposal reacted strongly to this approach as well as this particular use of the customizer.</p>\n<p>Discussion continued following the meeting, as Halsey wanted to address the critical issue of the timeline for removing removing the menus screen from the admin. He <a href=\"https://wordpress.slack.com/archives/core/p1433388261001615\" target=\"_blank\">attributes</a> the resistance to the customizer to a lack of education on the feature and strongly <a href=\"https://wordpress.slack.com/archives/core/p1433384388001601\" target=\"_blank\">advocates</a> &#8220;focusing on the new UI as the primary (and in terms of development, only) menus admin interface.&#8221;</p>\n<blockquote><p>For Menu Customizer, this idea has been part of the project from the very beginning. My GSoC proposal (3/20/14) states &#8216;If the Menu Customizer provides all of the features of the existing menu management screen, while clearly demonstrating that it is a better solution than the existing screen in user tests, it could potentially replace the existing screen entirely for users that can access the Customizer,&#8217; and there has never been indication that this isn&#8217;t the direction we should move in, other than the general and ongoing resistance to the Customizer as a whole that we&#8217;ve seen from many community members (which I think is more of an educational issue).</p></blockquote>\n<p>Discussion continues on the matter and work will move forward on the plugin to ensure that it meets the conditions outlined for its merge into WordPress 4.3.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 05 Jun 2015 13:35:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: BuddyDrive 1.3 Utilizes the New BP Attachments API\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44417\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://wptavern.com/buddydrive-1-3-utilizes-the-new-bp-attachments-api\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3160:\"<a href=\"http://wptavern.com/wp-content/uploads/2015/06/paperclips.jpg\"><img src=\"http://wptavern.com/wp-content/uploads/2015/06/paperclips.jpg\" alt=\"photo credit: Paperclips - (license)\" width=\"1024\" height=\"515\" class=\"size-full wp-image-44887\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/45953381@N05/5539562805\">Paperclips</a> &#8211; <a href=\"https://creativecommons.org/licenses/by/2.0/\">(license)</a>\n<p>One of the most exciting features added in <a href=\"http://wptavern.com/buddypress-2-3-livio-released-features-the-new-bp-attachments-api\" target=\"_blank\">BuddyPress 2.3</a> is the new <a href=\"https://codex.buddypress.org/plugindev/bp_attachment/\" target=\"_blank\">BP Attachments API</a>. It provides a BP core-supported method of managing user-submitted files and opens up a world of possibilities for plugin developers.</p>\n<p>The API powers the new avatar uploads UI, but it can also be used to extend BuddyPress to add media sharing capabilities. If you want to see a good example of this in the wild, check out BuddyDrive version <a href=\"https://github.com/imath/buddydrive/tree/1.3\" target=\"_blank\">1.3.0</a>. The plugin was created by BP core developer <a href=\"http://imathi.eu/\" target=\"_blank\">Mathieu Viet</a>, who led the effort to get the BP Attachments API into the latest release.</p>\n<p><a href=\"https://wordpress.org/plugins/buddydrive/\" target=\"_blank\">BuddyDrive</a> allows members to share a file or a list of files with the community and includes various settings for restricting access. It&#8217;s essentially like a Dropbox clone for BuddyPress, designed to enhance collaboration between members. The plugin was a prime candidate for adapting the BP Attachments API to power community file sharing in a simpler, more elegant way.</p>\n<p>You can see it active in the new &#8220;BuddyDrive Editor&#8221; included in version 1.3, demonstrated in the video below:</p>\n<p></p>\n<p>Viet posted an <a href=\"https://github.com/imath/buddydrive/wiki/The-BuddyDrive-Editor\" target=\"_blank\">example function</a> in the plugin&#8217;s wiki to show how the BuddyDrive Editor can be placed anywhere. The feature is a good example of how easy it is for developers to leverage the API to manage user-generated media from the frontend.</p>\n<p>BuddyDrive 1.3 is currently in beta and on track to be released soon. If you&#8217;d like to help test the beta or inspect the code to see how it works, you can download a zip file from Viet&#8217;s <a href=\"http://imathi.eu/2015/06/02/buddydrive-1-3-0/\" target=\"_blank\">preview post</a>. The unreleased <a href=\"https://github.com/imath/buddydrive/tree/1.3\" target=\"_blank\">version 1.3</a> is also available on GitHub.</p>\n<p>If you want to learn more about using the new BP Attachments API, check out Viet&#8217;s comprehensive <a href=\"https://codex.buddypress.org/plugindev/bp_attachment/\" target=\"_blank\">BP codex article</a>. It walks you through extending the <code>BP_Attachment</code> class to validate and store files in a subdirectory of wp-content/uploads. The documentation also includes a sample plugin to demonstrate how you might add attachments to private messages.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 05 Jun 2015 04:20:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: How to Add a Default Image to Jetpack’s Related Posts Module\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44865\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wptavern.com/how-to-add-a-default-image-to-jetpacks-related-posts-module\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2712:\"<p>Jetpack&#8217;s related posts module is a great way to show related content without using the same server resources used to host a site. When activated, the module displays three related posts. One of two options available is to use a large and visually striking layout.</p>\n<a href=\"http://wptavern.com/wp-content/uploads/2015/06/JetpackRelatedPostsConfiguration.png\"><img class=\"size-full wp-image-44867\" src=\"http://wptavern.com/wp-content/uploads/2015/06/JetpackRelatedPostsConfiguration.png\" alt=\"Jetpack Related Posts Configuration\" width=\"1105\" height=\"402\" /></a>Jetpack Related Posts Configuration\n<p>When enabled, the module looks for a large image that&#8217;s at least 350x200px in posts and uses it when displaying related posts.</p>\n<p>The downside to using this option is that related posts that don&#8217;t use images will display as a post excerpt instead. This can cause an undesirable look, especially if one or two related posts have images.</p>\n<a href=\"http://wptavern.com/wp-content/uploads/2015/06/RelatedPostsUsingText.png\"><img class=\"size-full wp-image-44869\" src=\"http://wptavern.com/wp-content/uploads/2015/06/RelatedPostsUsingText.png\" alt=\"Related Posts Displaying a Post Excerpt\" width=\"990\" height=\"333\" /></a>Related Posts Displaying a Post Excerpt\n<p>Jeremy Herve who works on the Jetpack team <a href=\"http://jeremy.hu/jetpack-missing-images-related-posts/\">published a tutorial</a> that explains how to show a default image if one is not detected. Both of his solutions require the user to add code which is a barrier for many users.</p>\n<p>Brian Krogsgard of <a href=\"https://poststatus.com/\">PostStatus.com</a> recommends that a conditional option be added that allows users who use a large and visually striking layout to easily configure a default image.</p>\n<blockquote><p>Currently, the user can click a checkbox to enable images for related posts output. I propose that an image upload option conditionally appear upon the image option being selected.</p>\n<p>That keeps the option out of sight for folks that don&#8217;t use images for related posts but makes it easier for normal folks to upload a default image for what I imagine would be an incredibly well adopted feature.</p></blockquote>\n<p>It&#8217;s a great suggestion and removes the need to edit or modify code. Although one of WordPress&#8217; philosophies is <a href=\"https://wordpress.org/about/philosophy/\">decisions not options</a>, this is a scenario where I think it makes sense. If this is an option you&#8217;d like to see added or have a different suggestion, you&#8217;re encouraged to <a href=\"https://github.com/Automattic/jetpack/issues/2220\">participate in the discussion</a> on GitHub.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Jun 2015 23:03:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: All Official Easy Digital Downloads Themes are Now 100% Free\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=44831\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wptavern.com/all-official-easy-digital-downloads-themes-are-now-100-free\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4235:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2015/03/EasyDigitalDownloadsFeaturedImage-e1429138648237.png\"><img src=\"http://wptavern.com/wp-content/uploads/2015/03/EasyDigitalDownloadsFeaturedImage-e1429138648237.png\" alt=\"EasyDigitalDownloadsFeaturedImage\" width=\"620\" height=\"220\" class=\"aligncenter size-full wp-image-40496\" /></a></p>\n<p>Easy Digital Downloads <a href=\"https://easydigitaldownloads.com/blog/easy-digital-downloads-themes/\" target=\"_blank\">announced</a> a major change to its <a href=\"https://easydigitaldownloads.com/themes/\" target=\"_blank\">themes marketplace</a> today. All official EDD themes (those that are built by the EDD core team) are now 100% free. This includes half a dozen themes that are guaranteed to be fully compatible with EDD, including the new <a href=\"https://easydigitaldownloads.com/downloads/vendd/\" target=\"_blank\">Vendd</a> theme launching today.</p>\n<p>EDD support manager Sean Davis clarified how the free themes will be supported:</p>\n<blockquote><p>Official EDD themes are available to you at absolutely no cost. They will still be licensed so that you can receive theme updates directly from your WordPress dashboard and we will also provide support. The only thing changing is the price.</p></blockquote>\n<p>Responding to <a href=\"https://twitter.com/nphaskins/status/606478597851746304\" target=\"_blank\">criticism</a> on Twitter saying that the change contributes to the <a href=\"https://philiparthurmoore.com/ruining-wordpress/\" target=\"_blank\">undervaluation of WordPress themes</a>, EDD founder <a href=\"https://pippinsplugins.com/\" target=\"_blank\">Pippin Williamson</a> said, &#8220;For us it&#8217;s not about the themes. It&#8217;s about the entire package. By making it easy for users to have a good shop up and running in minutes, we significantly increase the potential value to that customer and of that customer. We also dramatically reduce the cost of support by having more users on more reliable themes that are built for EDD.&#8221;</p>\n<p>Making half a dozen themes free might seem like it would significantly increase EDD&#8217;s support burden, but Williamson expects that the move will pay off in other ways. Like many other WordPress business owners who have made some of their best work free, Williamson has a strategy for how it will work.</p>\n<p>&#8220;The change lowers the barrier to entry,&#8221; Williamson said. &#8220;When the barrier is lowered, the user base grows. When the user base grows, the customer base grows. From a business side, we will have far more success converting free users to paid customers after they&#8217;ve already been given a great experience with a theme.&#8221;</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/nphaskins\">@nphaskins</a> Not sugar coating it at all. We\'ll make 5x more by giving them away than we did selling them <a href=\"https://twitter.com/SDavisMedia\">@sdavismedia</a> <a href=\"https://twitter.com/NateWr\">@natewr</a></p>\n<p>&mdash; Pippinsplugins (@pippinsplugins) <a href=\"https://twitter.com/pippinsplugins/status/606480064448995329\">June 4, 2015</a></p></blockquote>\n<p></p>\n<p>This major change is in line with EDD&#8217;s basic freemium business model, which has been in place from the start. The core product(s) are free and satisfied users go on to make purchases from the <a href=\"https://easydigitaldownloads.com/downloads/\" target=\"_blank\">add-ons marketplace</a>.</p>\n<p>&#8220;By setting them up with a good theme from the get go, the likelihood that they become a paying customer is substantially higher,&#8221; Williamson said.</p>\n<p>So far, the freemium model has worked well for the company and making six theme products free makes sense when the business primarily revolves around plugins. After just <a href=\"http://wptavern.com/easy-digital-downloads-turns-3-years-old\" target=\"_blank\">three years in business</a>, EDD pulled in roughly half a million dollars in <a href=\"https://pippinsplugins.com/2014-review/\" target=\"_blank\">revenue in 2014</a>. As themes were not a significant portion of the revenue, Williamson is re-assigning them to be free products in order to continue to build a customer base for his plugins.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Jun 2015 19:13:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 22 Jun 2015 07:03:24 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"190216\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Mon, 22 Jun 2015 06:45:15 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20130911040210\";}", "no");
INSERT INTO `wp_options` VALUES("527", "_transient_timeout_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1434999811", "no");
INSERT INTO `wp_options` VALUES("528", "_transient_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1434956611", "no");
INSERT INTO `wp_options` VALUES("529", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1434999812", "no");
INSERT INTO `wp_options` VALUES("530", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:117:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"WordPress Plugins » View: Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"WordPress Plugins » View: Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 22 Jun 2015 06:32:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:30:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"15@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet Web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2141@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"8321@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using Yoast&#039;s WordPress SEO plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"29832@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"Wordfence Security is a free enterprise class security and performance plugin that makes your site up to 50 times faster and more secure.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"29860@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"753@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your WordPress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"23862@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Your WordPress, Streamlined.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"Google Analytics Dashboard for WP\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"https://wordpress.org/plugins/google-analytics-dashboard-for-wp/#post-50539\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 10 Mar 2013 17:07:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"50539@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Displays Google Analytics reports and real-time statistics in your WordPress Dashboard. Inserts the latest tracking code in every page of your site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Alin Marcu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"18101@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Meta Slider\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/ml-slider/#post-49521\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 14 Feb 2013 16:56:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"49521@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:145:\"Easy to use WordPress slider plugin. Create SEO optimised responsive slideshows with Nivo Slider, Flex Slider, Coin Slider and Responsive Slides.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Matcha Labs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"EWWW Image Optimizer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://wordpress.org/plugins/ewww-image-optimizer/#post-38780\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 06 Jun 2012 19:30:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"38780@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:144:\"Reduce file sizes for images in WordPress including NextGEN, GRAND FlAGallery and more using lossless/lossy methods and image format conversion.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"nosilver4u\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Broken Link Checker\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/broken-link-checker/#post-2441\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 08 Oct 2007 21:35:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2441@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"This plugin will check your posts, comments and other content for broken links and missing images, and notify you if any are found.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Janis Elsts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Responsive Lightbox by dFactory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/plugins/responsive-lightbox/#post-55352\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Jul 2013 10:58:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"55352@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:141:\"Responsive Lightbox allows users to view larger versions of images and galleries in a lightbox (overlay) effect optimized for mobile devices.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"dFactory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"The Events Calendar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/plugins/the-events-calendar/#post-14790\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Dec 2009 21:58:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"14790@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:128:\"The Events Calendar is a carefully crafted, extensible plugin that lets you easily share your events. Beautiful. Solid. Awesome.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Peter Chester\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Photo Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/photo-gallery/#post-63299\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Jan 2014 15:58:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"63299@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:143:\"Photo Gallery is an advanced plugin with a list of tools and options for adding and editing images for different views. It is fully responsive.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"webdorado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"UpdraftPlus Backup and Restoration\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/updraftplus/#post-38058\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 May 2012 15:14:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"38058@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Backup and restoration made easy. Complete backups; manual or scheduled (backup to S3, Dropbox, Google Drive, Rackspace, FTP, SFTP, email + others).\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Anderson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"Sucuri Security - Auditing, Malware Scanner and Security Hardening\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/plugins/sucuri-scanner/#post-32221\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Nov 2011 14:03:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"32221@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:135:\"The Sucuri WordPress Security plugin is a security toolset for security integrity monitoring, malware detection and security hardening.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Daniel Cid\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"BuddyPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://wordpress.org/plugins/buddypress/#post-10314\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Apr 2009 17:48:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"10314@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:144:\"BuddyPress helps you run any kind of social network on your WordPress, with member profiles, activity streams, user groups, messaging, and more.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Andy Peatling\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"1169@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 12 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Advanced Custom Fields\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/plugins/advanced-custom-fields/#post-25254\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Mar 2011 04:07:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"25254@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"Customise WordPress with powerful, professional and intuitive fields\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"elliotcondon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"TinyMCE Advanced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://wordpress.org/plugins/tinymce-advanced/#post-2082\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Jun 2007 15:00:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2082@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Enables the advanced features of TinyMCE, the WordPress WYSIWYG editor.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WP Super Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/wp-super-cache/#post-2572\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Nov 2007 11:40:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2572@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"A very fast caching engine for WordPress that produces static html files.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Donncha O Caoimh\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"132@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Arne Brachhold\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"AddThis Sharing Buttons\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://wordpress.org/plugins/addthis/#post-8124\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 17 Dec 2008 16:03:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"8124@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"AddThis provides the best sharing tools to help you make your website smarter.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"_mjk_\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Google Analytics by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wordpress.org/plugins/google-analytics-for-wordpress/#post-2316\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 14 Sep 2007 12:15:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2316@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"Track your WordPress site easily with the latest tracking codes and lots added data for search result pages and error pages.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Black Studio TinyMCE Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/plugins/black-studio-tinymce-widget/#post-31973\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 10 Nov 2011 15:06:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"31973@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"The visual editor widget for Wordpress.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Marco Chiesi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Page Builder by SiteOrigin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/siteorigin-panels/#post-51888\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Apr 2013 10:36:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"51888@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"Build responsive page layouts using the widgets you know and love using this simple drag and drop page builder.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Greg Priday\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"WPtouch Mobile Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://wordpress.org/plugins/wptouch/#post-5468\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 May 2008 04:58:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"5468@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"Make your WordPress website mobile-friendly with just a few clicks.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"BraveNewCode Inc.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Custom Post Type UI\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/plugins/custom-post-type-ui/#post-16184\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 24 Feb 2010 15:57:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"16184@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"Admin UI for creating custom post types and custom taxonomies in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Brad Williams\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Breadcrumb NavXT\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://wordpress.org/plugins/breadcrumb-navxt/#post-2634\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 01 Dec 2007 00:15:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"2634@https://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"Adds breadcrumb navigation showing the visitor&#039;s path to their current location.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"John Havlik\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:46:\"https://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:12:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 22 Jun 2015 07:03:26 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:25:\"strict-transport-security\";s:11:\"max-age=360\";s:7:\"expires\";s:29:\"Mon, 22 Jun 2015 07:07:27 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Mon, 22 Jun 2015 06:32:27 +0000\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130911040210\";}", "no");
INSERT INTO `wp_options` VALUES("531", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1434999812", "no");
INSERT INTO `wp_options` VALUES("532", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1434956612", "no");
INSERT INTO `wp_options` VALUES("533", "_transient_timeout_plugin_slugs", "1435043608", "no");
INSERT INTO `wp_options` VALUES("534", "_transient_plugin_slugs", "a:15:{i:0;s:19:\"akismet/akismet.php\";i:1;s:51:\"all-in-one-wp-migration/all-in-one-wp-migration.php\";i:2;s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";i:3;s:36:\"contact-form-7/wp-contact-form-7.php\";i:4;s:25:\"duplicator/duplicator.php\";i:5;s:50:\"google-analytics-for-wordpress/googleanalytics.php\";i:6;s:36:\"google-sitemap-generator/sitemap.php\";i:7;s:9:\"hello.php\";i:8;s:19:\"jetpack/jetpack.php\";i:9;s:23:\"ml-slider/ml-slider.php\";i:10;s:27:\"simple-tags/simple-tags.php\";i:11;s:27:\"theme-check/theme-check.php\";i:12;s:17:\"unyson/unyson.php\";i:13;s:29:\"wp-mail-smtp/wp_mail_smtp.php\";i:14;s:19:\"wptouch/wptouch.php\";}", "no");
INSERT INTO `wp_options` VALUES("535", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1434999812", "no");
INSERT INTO `wp_options` VALUES("536", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2015/05/wordpress-4-2-2/\'>WordPress 4.2.2 Security and Maintenance Release</a> <span class=\"rss-date\">05/07/2015</span><div class=\"rssSummary\">WordPress 4.2.2 is now available. This is a critical security release for all previous versions and we strongly encourage you to update your sites immediately. Version 4.2.2 addresses two security issues: The Genericons icon font package, which is used in a number of popular themes and plugins, contained an HTML file vulnerable to a cross-site [&hellip;]</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://ma.tt/2015/06/ornette-colemans-sound-grammar/\'>Matt: Ornette Coleman’s Sound Grammar</a></li><li><a class=\'rsswidget\' href=\'http://ma.tt/2015/06/om-on-apple-and-google/\'>Matt: Om on Apple and Google</a></li><li><a class=\'rsswidget\' href=\'http://ma.tt/2015/06/funnel-framework/\'>Matt: Funnel Framework</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\'dashboard-news-plugin\'><span>Popularna wtyczka:</span> <a href=\'https://wordpress.org/plugins/google-analytics-dashboard-for-wp/\' class=\'dashboard-news-plugin-link\'>Google Analytics Dashboard for WP</a>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=google-analytics-dashboard-for-wp&amp;_wpnonce=df4695f9c6&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Google Analytics Dashboard for WP\'>Zainstaluj</a>)</span></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("544", "_transient_is_multi_author", "0", "yes");
INSERT INTO `wp_options` VALUES("545", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1434967933", "yes");
INSERT INTO `wp_options` VALUES("546", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "a:40:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";s:4:\"5223\";}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"Post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";s:4:\"3269\";}s:6:\"plugin\";a:3:{s:4:\"name\";s:6:\"plugin\";s:4:\"slug\";s:6:\"plugin\";s:5:\"count\";s:4:\"3204\";}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";s:4:\"2734\";}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";s:4:\"2503\";}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";s:4:\"2001\";}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";s:4:\"1906\";}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";s:4:\"1836\";}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";s:4:\"1787\";}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";s:4:\"1769\";}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";s:4:\"1738\";}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";s:4:\"1728\";}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";s:4:\"1621\";}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"Facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";s:4:\"1419\";}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";s:4:\"1357\";}s:9:\"wordpress\";a:3:{s:4:\"name\";s:9:\"wordpress\";s:4:\"slug\";s:9:\"wordpress\";s:5:\"count\";s:4:\"1299\";}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";s:4:\"1207\";}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";s:4:\"1165\";}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";s:4:\"1150\";}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";s:4:\"1021\";}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";s:3:\"975\";}s:11:\"woocommerce\";a:3:{s:4:\"name\";s:11:\"woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:5:\"count\";s:3:\"942\";}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";s:3:\"932\";}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";s:3:\"896\";}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";s:3:\"865\";}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";s:3:\"853\";}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";s:3:\"806\";}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"AJAX\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";s:3:\"791\";}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";s:3:\"767\";}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";s:3:\"743\";}s:9:\"ecommerce\";a:3:{s:4:\"name\";s:9:\"ecommerce\";s:4:\"slug\";s:9:\"ecommerce\";s:5:\"count\";s:3:\"738\";}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";s:3:\"736\";}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";s:3:\"695\";}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";s:3:\"687\";}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";s:3:\"682\";}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";s:3:\"669\";}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";s:3:\"649\";}s:8:\"security\";a:3:{s:4:\"name\";s:8:\"security\";s:4:\"slug\";s:8:\"security\";s:5:\"count\";s:3:\"645\";}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";s:3:\"640\";}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";s:3:\"639\";}}", "yes");
INSERT INTO `wp_options` VALUES("550", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1434957206;s:7:\"checked\";a:15:{s:19:\"akismet/akismet.php\";s:3:\"3.1\";s:51:\"all-in-one-wp-migration/all-in-one-wp-migration.php\";s:5:\"2.0.4\";s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";s:7:\"2.2.5.1\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:3:\"4.1\";s:25:\"duplicator/duplicator.php\";s:6:\"0.5.22\";s:50:\"google-analytics-for-wordpress/googleanalytics.php\";s:5:\"5.3.2\";s:36:\"google-sitemap-generator/sitemap.php\";s:5:\"4.0.8\";s:9:\"hello.php\";s:3:\"1.6\";s:19:\"jetpack/jetpack.php\";s:5:\"3.3.2\";s:23:\"ml-slider/ml-slider.php\";s:5:\"3.3.3\";s:27:\"simple-tags/simple-tags.php\";s:3:\"2.4\";s:27:\"theme-check/theme-check.php\";s:10:\"20141222.1\";s:17:\"unyson/unyson.php\";s:5:\"2.3.2\";s:29:\"wp-mail-smtp/wp_mail_smtp.php\";s:5:\"0.9.5\";s:19:\"wptouch/wptouch.php\";s:5:\"3.7.3\";}s:8:\"response\";a:8:{s:19:\"akismet/akismet.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:2:\"15\";s:4:\"slug\";s:7:\"akismet\";s:6:\"plugin\";s:19:\"akismet/akismet.php\";s:11:\"new_version\";s:5:\"3.1.2\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/akismet/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/akismet.3.1.2.zip\";}s:51:\"all-in-one-wp-migration/all-in-one-wp-migration.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"46859\";s:4:\"slug\";s:23:\"all-in-one-wp-migration\";s:6:\"plugin\";s:51:\"all-in-one-wp-migration/all-in-one-wp-migration.php\";s:11:\"new_version\";s:3:\"3.3\";s:3:\"url\";s:54:\"https://wordpress.org/plugins/all-in-one-wp-migration/\";s:7:\"package\";s:70:\"https://downloads.wordpress.org/plugin/all-in-one-wp-migration.3.3.zip\";}s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:3:\"520\";s:4:\"slug\";s:19:\"all-in-one-seo-pack\";s:6:\"plugin\";s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";s:11:\"new_version\";s:5:\"2.2.7\";s:3:\"url\";s:50:\"https://wordpress.org/plugins/all-in-one-seo-pack/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/all-in-one-seo-pack.zip\";}s:36:\"contact-form-7/wp-contact-form-7.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:3:\"790\";s:4:\"slug\";s:14:\"contact-form-7\";s:6:\"plugin\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:11:\"new_version\";s:3:\"4.2\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/contact-form-7/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/contact-form-7.4.2.zip\";}s:50:\"google-analytics-for-wordpress/googleanalytics.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:3:\"965\";s:4:\"slug\";s:30:\"google-analytics-for-wordpress\";s:6:\"plugin\";s:50:\"google-analytics-for-wordpress/googleanalytics.php\";s:11:\"new_version\";s:5:\"5.4.2\";s:3:\"url\";s:61:\"https://wordpress.org/plugins/google-analytics-for-wordpress/\";s:7:\"package\";s:79:\"https://downloads.wordpress.org/plugin/google-analytics-for-wordpress.5.4.2.zip\";}s:19:\"jetpack/jetpack.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"20101\";s:4:\"slug\";s:7:\"jetpack\";s:6:\"plugin\";s:19:\"jetpack/jetpack.php\";s:11:\"new_version\";s:5:\"3.5.3\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/jetpack/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/jetpack.3.5.3.zip\";}s:17:\"unyson/unyson.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"55635\";s:4:\"slug\";s:6:\"unyson\";s:6:\"plugin\";s:17:\"unyson/unyson.php\";s:11:\"new_version\";s:5:\"2.3.3\";s:3:\"url\";s:37:\"https://wordpress.org/plugins/unyson/\";s:7:\"package\";s:55:\"https://downloads.wordpress.org/plugin/unyson.2.3.3.zip\";}s:19:\"wptouch/wptouch.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:4:\"3265\";s:4:\"slug\";s:7:\"wptouch\";s:6:\"plugin\";s:19:\"wptouch/wptouch.php\";s:11:\"new_version\";s:7:\"3.7.9.1\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/wptouch/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/wptouch.3.7.9.1.zip\";}}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:7:{s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"22600\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:6:\"0.5.22\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/duplicator.0.5.22.zip\";}s:36:\"google-sitemap-generator/sitemap.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:3:\"132\";s:4:\"slug\";s:24:\"google-sitemap-generator\";s:6:\"plugin\";s:36:\"google-sitemap-generator/sitemap.php\";s:11:\"new_version\";s:5:\"4.0.8\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/google-sitemap-generator/\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/plugin/google-sitemap-generator.4.0.8.zip\";}s:9:\"hello.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:4:\"3564\";s:4:\"slug\";s:11:\"hello-dolly\";s:6:\"plugin\";s:9:\"hello.php\";s:11:\"new_version\";s:3:\"1.6\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/hello-dolly/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/hello-dolly.1.6.zip\";}s:23:\"ml-slider/ml-slider.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"38583\";s:4:\"slug\";s:9:\"ml-slider\";s:6:\"plugin\";s:23:\"ml-slider/ml-slider.php\";s:11:\"new_version\";s:5:\"3.3.3\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/ml-slider/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/ml-slider.3.3.3.zip\";}s:27:\"simple-tags/simple-tags.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:4:\"1112\";s:4:\"slug\";s:11:\"simple-tags\";s:6:\"plugin\";s:27:\"simple-tags/simple-tags.php\";s:11:\"new_version\";s:3:\"2.4\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/simple-tags/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/simple-tags.2.4.1.zip\";}s:27:\"theme-check/theme-check.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"18487\";s:4:\"slug\";s:11:\"theme-check\";s:6:\"plugin\";s:27:\"theme-check/theme-check.php\";s:11:\"new_version\";s:10:\"20141222.1\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/theme-check/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/theme-check.20141222.1.zip\";}s:29:\"wp-mail-smtp/wp_mail_smtp.php\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"951\";s:4:\"slug\";s:12:\"wp-mail-smtp\";s:6:\"plugin\";s:29:\"wp-mail-smtp/wp_mail_smtp.php\";s:11:\"new_version\";s:5:\"0.9.5\";s:3:\"url\";s:43:\"https://wordpress.org/plugins/wp-mail-smtp/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/wp-mail-smtp.0.9.5.zip\";s:14:\"upgrade_notice\";s:38:\"Minor security fix, hat tip JD Grimes.\";}}}", "yes");
INSERT INTO `wp_options` VALUES("551", "duplicator_settings", "a:10:{s:7:\"version\";s:6:\"0.5.22\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:0;s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";b:0;s:20:\"storage_htaccess_off\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("552", "duplicator_version_plugin", "0.5.22", "yes");
INSERT INTO `wp_options` VALUES("553", "duplicator_ui_view_state", "a:4:{s:14:\"dup-wpnotice01\";b:1;s:22:\"dup-pack-storage-panel\";s:1:\"0\";s:22:\"dup-pack-archive-panel\";s:1:\"0\";s:24:\"dup-pack-installer-panel\";s:1:\"1\";}", "yes");
INSERT INTO `wp_options` VALUES("554", "duplicator_package_active", "O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:8:\"strefawp\";s:4:\"Hash\";s:29:\"5587b59fef5a99674150622071335\";s:8:\"NameHash\";s:38:\"strefawp_5587b59fef5a99674150622071335\";s:7:\"Version\";s:6:\"0.5.22\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:67:\"C:/Bitnami/wordpress-4.2.2-0/apps/wordpress/htdocs/wp-snapshots/tmp\";s:8:\"StoreURL\";s:45:\"http://localhost:8080/wordpress/wp-snapshots/\";s:8:\"ScanFile\";s:48:\"strefawp_5587b59fef5a99674150622071335_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":17:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:50:\"C:/Bitnami/wordpress-4.2.2-0/apps/wordpress/htdocs\";s:4:\"Size\";i:0;s:12:\"WarnFileSize\";a:0:{}s:12:\"WarnFileName\";a:0:{}s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:5:\"Links\";a:0:{}s:8:\"OmitDirs\";a:0:{}s:9:\"OmitFiles\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:8:\"strefawp\";s:4:\"Hash\";s:29:\"5587b59fef5a99674150622071335\";s:8:\"NameHash\";s:38:\"strefawp_5587b59fef5a99674150622071335\";s:7:\"Version\";s:6:\"0.5.22\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:67:\"C:/Bitnami/wordpress-4.2.2-0/apps/wordpress/htdocs/wp-snapshots/tmp\";s:8:\"StoreURL\";s:45:\"http://localhost:8080/wordpress/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";r:15;s:9:\"Installer\";O:13:\"DUP_Installer\":12:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:30;}s:8:\"Database\";O:12:\"DUP_Database\":11:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:30;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";r:45;s:8:\"Database\";r:58;}", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("2", "2", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("3", "2", "_wp_trash_meta_time", "1433859035");
INSERT INTO `wp_postmeta` VALUES("4", "5", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("5", "5", "_edit_lock", "1433935375:1");
INSERT INTO `wp_postmeta` VALUES("6", "7", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("7", "7", "_edit_lock", "1433858932:1");
INSERT INTO `wp_postmeta` VALUES("15", "5", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2:\"[]\";s:14:\"corrected_json\";s:2:\"[]\";s:18:\"shortcode_notation\";s:0:\"\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("16", "5", "fw-shortcode-default-values", "{\"section\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"}}");
INSERT INTO `wp_postmeta` VALUES("17", "5", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("18", "12", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:223:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"To jest strona Start\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>To jest blok tekstu<\\/p>\"}}]\";s:14:\"corrected_json\";s:498:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"To jest strona Start\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>To jest blok tekstu<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:486:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"To jest strona Start\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;To jest blok tekstu&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("19", "13", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:684:\"[{\"type\":\"section\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"To jest strona Start\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>To jest blok tekstu<\\/p>\"}},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-arrow-circle-up\",\"title\":\"Box 1\",\"content\":\"Zawarto\\u015b\\u0107\"}}],\"width\":\"1_2\"},{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"ZOBACZ\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"blue\"}}]}],\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"}}]\";s:14:\"corrected_json\";s:895:\"[{\"type\":\"section\",\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"To jest strona Start\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>To jest blok tekstu<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-arrow-circle-up\",\"title\":\"Box 1\",\"content\":\"Zawarto\\u015b\\u0107\"}}],\"width\":\"1_2\"},{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"ZOBACZ\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"blue\"}}]}],\"type\":\"row\"}],\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":false,\"first_in_builder\":true}}]\";s:18:\"shortcode_notation\";s:855:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" first_in_builder=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"To jest strona Start\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;To jest blok tekstu&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-arrow-circle-up\" title=\"Box 1\" content=\"Zawartość\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_2\" _made_with_builder=\"true\"][button label=\"ZOBACZ\" link=\"#\" target=\"_self\" color=\"blue\" _made_with_builder=\"true\"][/button][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("20", "14", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2:\"[]\";s:14:\"corrected_json\";s:2:\"[]\";s:18:\"shortcode_notation\";s:0:\"\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("21", "15", "fw-shortcode-default-values", "{\"section\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"}}");
INSERT INTO `wp_postmeta` VALUES("22", "15", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("23", "15", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("24", "15", "_edit_lock", "1434956833:1");
INSERT INTO `wp_postmeta` VALUES("25", "16", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("26", "15", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:957:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Dlaczego warto nas wybra\\u0107\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-plus-circle\",\"title\":\"Rozwojowy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-user\",\"title\":\"Responsywny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]}]\";s:14:\"corrected_json\";s:1189:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Dlaczego warto nas wybra\\u0107\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-plus-circle\",\"title\":\"Rozwojowy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-user\",\"title\":\"Responsywny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:1156:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Dlaczego warto nas wybrać\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-plus-circle\" title=\"Rozwojowy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-user\" title=\"Responsywny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("27", "17", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:948:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Dlaczego warto nas wybra\\u0107\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}],\"width\":\"1_3\"},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]}]\";s:14:\"corrected_json\";s:1180:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Dlaczego warto nas wybra\\u0107\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}],\"width\":\"1_3\"},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:1147:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Dlaczego warto nas wybrać\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("28", "18", "fw-shortcode-default-values", "{\"section\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"}}");
INSERT INTO `wp_postmeta` VALUES("29", "18", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("30", "18", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("31", "18", "_edit_lock", "1434956726:1");
INSERT INTO `wp_postmeta` VALUES("32", "19", "_wp_attached_file", "2015/06/tablet.png");
INSERT INTO `wp_postmeta` VALUES("33", "19", "_wp_attachment_metadata", "a:6:{s:5:\"width\";i:500;s:6:\"height\";i:387;s:4:\"file\";s:18:\"2015/06/tablet.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"tablet-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"tablet-300x232.png\";s:5:\"width\";i:300;s:6:\"height\";i:232;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}s:7:\"resizes\";a:1:{s:7:\"500x387\";s:27:\"/2015/06/tablet-500x387.png\";}}");
INSERT INTO `wp_postmeta` VALUES("34", "19", "_wp_attachment_image_alt", "tablet");
INSERT INTO `wp_postmeta` VALUES("35", "20", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("36", "18", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1530:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zalety naszego produktu\",\"subtitle\":\"Jasze wi\\u0119cej jeszcze lepszych rzeczy za naprawde jeszcze ma\\u0142\\u0105 cen\\u0119\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"30\"}}}},{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"},\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"19\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png\"},\"width\":\"500\",\"height\":\"387\",\"link\":\"\",\"target\":\"_self\"}}]},{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-road\",\"title\":\"Animacje oraz skrypty\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-camera\",\"title\":\"Material Design\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}}]}]}]\";s:14:\"corrected_json\";s:1854:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zalety naszego produktu\",\"subtitle\":\"Jasze wi\\u0119cej jeszcze lepszych rzeczy za naprawde jeszcze ma\\u0142\\u0105 cen\\u0119\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"30\"}}}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}},{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":false},\"_items\":[{\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"19\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png\"},\"width\":\"500\",\"height\":\"387\",\"link\":\"\",\"target\":\"_self\"}}]},{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-road\",\"title\":\"Animacje oraz skrypty\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-camera\",\"title\":\"Material Design\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}}]}],\"type\":\"row\"}]}]\";s:18:\"shortcode_notation\";s:2162:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Zalety naszego produktu\" subtitle=\"Jasze więcej jeszcze lepszych rzeczy za naprawde jeszcze małą cenę\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;30&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][/column][/row][/section][section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;19&quot;,&quot;url&quot;:&quot;\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png&quot;}\" width=\"500\" height=\"387\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-road\" title=\"Animacje oraz skrypty\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-camera\" title=\"Material Design\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("37", "21", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1536:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zalety naszego produktu\",\"subtitle\":\"Jasze wi\\u0119cej jeszcze lepszych rzeczy za naprawde jeszcze ma\\u0142\\u0105 cen\\u0119\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"30\"}}}},{\"type\":\"section\",\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"19\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png\"},\"width\":\"500\",\"height\":\"387\",\"link\":\"\",\"target\":\"_self\"}}],\"width\":\"1_2\"},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}}],\"width\":\"1_2\"}],\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"}}]\";s:14:\"corrected_json\";s:1860:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zalety naszego produktu\",\"subtitle\":\"Jasze wi\\u0119cej jeszcze lepszych rzeczy za naprawde jeszcze ma\\u0142\\u0105 cen\\u0119\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"30\"}}}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}},{\"type\":\"section\",\"_items\":[{\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"19\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png\"},\"width\":\"500\",\"height\":\"387\",\"link\":\"\",\"target\":\"_self\"}}],\"width\":\"1_2\"},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}}],\"width\":\"1_2\"}],\"type\":\"row\"}],\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":false}}]\";s:18:\"shortcode_notation\";s:2168:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Zalety naszego produktu\" subtitle=\"Jasze więcej jeszcze lepszych rzeczy za naprawde jeszcze małą cenę\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;30&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][/column][/row][/section][section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;19&quot;,&quot;url&quot;:&quot;\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png&quot;}\" width=\"500\" height=\"387\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("38", "22", "fw-shortcode-default-values", "{\"section\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"}}");
INSERT INTO `wp_postmeta` VALUES("39", "22", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("40", "22", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("41", "22", "_edit_lock", "1433942755:1");
INSERT INTO `wp_postmeta` VALUES("42", "23", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("43", "22", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1326:\"[{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"},\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zobacz wi\\u0119cej jeszcze lepszych rzeczy o naszym produkcie \",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Zobacz to\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"\"}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Wybierz nas\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}]},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"25\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet_2.png\"},\"width\":\"500\",\"height\":\"260\",\"link\":\"\",\"target\":\"_self\"}}],\"width\":\"1_2\"}]}]\";s:14:\"corrected_json\";s:1399:\"[{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":false,\"first_in_builder\":true},\"_items\":[{\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zobacz wi\\u0119cej jeszcze lepszych rzeczy o naszym produkcie \",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Zobacz to\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"\"}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Wybierz nas\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}]},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"25\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet_2.png\"},\"width\":\"500\",\"height\":\"260\",\"link\":\"\",\"target\":\"_self\"}}],\"width\":\"1_2\"}],\"type\":\"row\"}]}]\";s:18:\"shortcode_notation\";s:1645:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" first_in_builder=\"1\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][special_heading title=\"Zobacz więcej jeszcze lepszych rzeczy o naszym produkcie \" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][text_block text=\"&lt;p&gt;Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][button label=\"Zobacz to\" link=\"#\" target=\"_self\" color=\"\" _made_with_builder=\"true\"][/button][button label=\"Wybierz nas\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;25&quot;,&quot;url&quot;:&quot;\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet_2.png&quot;}\" width=\"500\" height=\"260\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("44", "24", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1060:\"[{\"type\":\"section\",\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zobacz wi\\u0119cej jeszcze lepszych rzeczy o naszym produkcie \",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Zobacz to\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"\"}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Wybierz nas\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}],\"width\":\"1_2\"}],\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"}}]\";s:14:\"corrected_json\";s:1133:\"[{\"type\":\"section\",\"_items\":[{\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zobacz wi\\u0119cej jeszcze lepszych rzeczy o naszym produkcie \",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Zobacz to\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"\"}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Wybierz nas\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}],\"width\":\"1_2\"}],\"type\":\"row\"}],\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":false,\"first_in_builder\":true}}]\";s:18:\"shortcode_notation\";s:1283:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" first_in_builder=\"1\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][special_heading title=\"Zobacz więcej jeszcze lepszych rzeczy o naszym produkcie \" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][text_block text=\"&lt;p&gt;Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][button label=\"Zobacz to\" link=\"#\" target=\"_self\" color=\"\" _made_with_builder=\"true\"][/button][button label=\"Wybierz nas\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("45", "25", "_wp_attached_file", "2015/06/tablet_2.png");
INSERT INTO `wp_postmeta` VALUES("46", "25", "_wp_attachment_metadata", "a:6:{s:5:\"width\";i:500;s:6:\"height\";i:260;s:4:\"file\";s:20:\"2015/06/tablet_2.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:20:\"tablet_2-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:20:\"tablet_2-300x156.png\";s:5:\"width\";i:300;s:6:\"height\";i:156;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}s:7:\"resizes\";a:1:{s:7:\"500x260\";s:29:\"/2015/06/tablet_2-500x260.png\";}}");
INSERT INTO `wp_postmeta` VALUES("47", "25", "_wp_attachment_image_alt", "table_2");
INSERT INTO `wp_postmeta` VALUES("48", "26", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1326:\"[{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"},\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zobacz wi\\u0119cej jeszcze lepszych rzeczy o naszym produkcie \",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Zobacz to\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"\"}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Wybierz nas\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}]},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"25\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet_2.png\"},\"width\":\"500\",\"height\":\"260\",\"link\":\"\",\"target\":\"_self\"}}],\"width\":\"1_2\"}]}]\";s:14:\"corrected_json\";s:1399:\"[{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":false,\"first_in_builder\":true},\"_items\":[{\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zobacz wi\\u0119cej jeszcze lepszych rzeczy o naszym produkcie \",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"12\"}}}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Zobacz to\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"\"}},{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Wybierz nas\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}]},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"25\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet_2.png\"},\"width\":\"500\",\"height\":\"260\",\"link\":\"\",\"target\":\"_self\"}}],\"width\":\"1_2\"}],\"type\":\"row\"}]}]\";s:18:\"shortcode_notation\";s:1645:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" first_in_builder=\"1\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][special_heading title=\"Zobacz więcej jeszcze lepszych rzeczy o naszym produkcie \" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][text_block text=\"&lt;p&gt;Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][button label=\"Zobacz to\" link=\"#\" target=\"_self\" color=\"\" _made_with_builder=\"true\"][/button][button label=\"Wybierz nas\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;25&quot;,&quot;url&quot;:&quot;\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet_2.png&quot;}\" width=\"500\" height=\"260\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("49", "27", "fw-shortcode-default-values", "[]");
INSERT INTO `wp_postmeta` VALUES("50", "27", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("51", "27", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("52", "27", "_edit_lock", "1433944036:1");
INSERT INTO `wp_postmeta` VALUES("53", "28", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("54", "27", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:355:\"[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zarejestruj si\\u0119 ju\\u017c dzi\\u015b!\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"width\":\"2_3\"},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Rejestracja\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}],\"width\":\"1_3\"}]\";s:14:\"corrected_json\";s:518:\"[{\"_items\":[{\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zarejestruj si\\u0119 ju\\u017c dzi\\u015b!\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"width\":\"2_3\"},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Rejestracja\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}],\"width\":\"1_3\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:486:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"2_3\" _made_with_builder=\"true\"][special_heading title=\"Zarejestruj się już dziś!\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][column width=\"1_3\" _made_with_builder=\"true\"][button label=\"Rejestracja\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("55", "29", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:355:\"[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zarejestruj si\\u0119 ju\\u017c dzi\\u015b!\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"width\":\"2_3\"},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Rejestracja\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}],\"width\":\"1_3\"}]\";s:14:\"corrected_json\";s:518:\"[{\"_items\":[{\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zarejestruj si\\u0119 ju\\u017c dzi\\u015b!\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"width\":\"2_3\"},{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"button\",\"atts\":{\"label\":\"Rejestracja\",\"link\":\"#\",\"target\":\"_self\",\"color\":\"black\"}}],\"width\":\"1_3\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:486:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"2_3\" _made_with_builder=\"true\"][special_heading title=\"Zarejestruj się już dziś!\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][column width=\"1_3\" _made_with_builder=\"true\"][button label=\"Rejestracja\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("56", "30", "fw-shortcode-default-values", "[]");
INSERT INTO `wp_postmeta` VALUES("57", "30", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("58", "30", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("59", "30", "_edit_lock", "1434530325:1");
INSERT INTO `wp_postmeta` VALUES("60", "31", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("61", "30", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2:\"[]\";s:14:\"corrected_json\";s:2:\"[]\";s:18:\"shortcode_notation\";s:0:\"\";s:14:\"builder_active\";b:0;}}");
INSERT INTO `wp_postmeta` VALUES("62", "32", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("63", "32", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("64", "32", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("65", "32", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("66", "32", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("67", "32", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("68", "32", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("69", "32", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("70", "32", "_menu_item_orphaned", "1433945285");
INSERT INTO `wp_postmeta` VALUES("71", "33", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("72", "33", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("73", "33", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("74", "33", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("75", "33", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("76", "33", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("77", "33", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("78", "33", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("79", "33", "_menu_item_orphaned", "1433945285");
INSERT INTO `wp_postmeta` VALUES("80", "34", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("81", "34", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("82", "34", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("83", "34", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("84", "34", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("85", "34", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("86", "34", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("87", "34", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("88", "34", "_menu_item_orphaned", "1433945285");
INSERT INTO `wp_postmeta` VALUES("89", "35", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("90", "35", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("91", "35", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("92", "35", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("93", "35", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("94", "35", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("95", "35", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("96", "35", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("97", "35", "_menu_item_orphaned", "1433945285");
INSERT INTO `wp_postmeta` VALUES("98", "36", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("99", "36", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("100", "36", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("101", "36", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("102", "36", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("103", "36", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("104", "36", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("105", "36", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("106", "36", "_menu_item_orphaned", "1433945285");
INSERT INTO `wp_postmeta` VALUES("107", "37", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("108", "37", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("109", "37", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("110", "37", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("111", "37", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("112", "37", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("113", "37", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("114", "37", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("115", "37", "_menu_item_orphaned", "1433945285");
INSERT INTO `wp_postmeta` VALUES("116", "38", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("117", "38", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("118", "38", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("119", "38", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("120", "38", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("121", "38", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("122", "38", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("123", "38", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("124", "38", "_menu_item_orphaned", "1433945285");
INSERT INTO `wp_postmeta` VALUES("125", "39", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("126", "39", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("127", "39", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("128", "39", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("129", "39", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("130", "39", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("131", "39", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("132", "39", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("133", "39", "_menu_item_orphaned", "1433945285");
INSERT INTO `wp_postmeta` VALUES("134", "40", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("135", "40", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("136", "40", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("137", "40", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("138", "40", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("139", "40", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("140", "40", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("141", "40", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("142", "40", "_menu_item_orphaned", "1433945897");
INSERT INTO `wp_postmeta` VALUES("143", "41", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("144", "41", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("145", "41", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("146", "41", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("147", "41", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("148", "41", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("149", "41", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("150", "41", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("151", "41", "_menu_item_orphaned", "1433945897");
INSERT INTO `wp_postmeta` VALUES("152", "42", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("153", "42", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("154", "42", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("155", "42", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("156", "42", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("157", "42", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("158", "42", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("159", "42", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("160", "42", "_menu_item_orphaned", "1433945897");
INSERT INTO `wp_postmeta` VALUES("161", "43", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("162", "43", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("163", "43", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("164", "43", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("165", "43", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("166", "43", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("167", "43", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("168", "43", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("169", "43", "_menu_item_orphaned", "1433945897");
INSERT INTO `wp_postmeta` VALUES("170", "44", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("171", "44", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("172", "44", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("173", "44", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("174", "44", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("175", "44", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("176", "44", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("177", "44", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("178", "44", "_menu_item_orphaned", "1433945897");
INSERT INTO `wp_postmeta` VALUES("179", "45", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("180", "45", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("181", "45", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("182", "45", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("183", "45", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("184", "45", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("185", "45", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("186", "45", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("187", "45", "_menu_item_orphaned", "1433945897");
INSERT INTO `wp_postmeta` VALUES("188", "46", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("189", "46", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("190", "46", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("191", "46", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("192", "46", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("193", "46", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("194", "46", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("195", "46", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("196", "46", "_menu_item_orphaned", "1433945897");
INSERT INTO `wp_postmeta` VALUES("197", "47", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("198", "47", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("199", "47", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("200", "47", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("201", "47", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("202", "47", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("203", "47", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("204", "47", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("205", "47", "_menu_item_orphaned", "1433945897");
INSERT INTO `wp_postmeta` VALUES("206", "48", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("207", "48", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("208", "48", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("209", "48", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("210", "48", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("211", "48", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("212", "48", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("213", "48", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("214", "48", "_menu_item_orphaned", "1433945945");
INSERT INTO `wp_postmeta` VALUES("215", "49", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("216", "49", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("217", "49", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("218", "49", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("219", "49", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("220", "49", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("221", "49", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("222", "49", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("223", "49", "_menu_item_orphaned", "1433945945");
INSERT INTO `wp_postmeta` VALUES("224", "50", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("225", "50", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("226", "50", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("227", "50", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("228", "50", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("229", "50", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("230", "50", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("231", "50", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("232", "50", "_menu_item_orphaned", "1433945945");
INSERT INTO `wp_postmeta` VALUES("233", "51", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("234", "51", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("235", "51", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("236", "51", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("237", "51", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("238", "51", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("239", "51", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("240", "51", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("241", "51", "_menu_item_orphaned", "1433945946");
INSERT INTO `wp_postmeta` VALUES("278", "56", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("279", "56", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("280", "56", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("281", "56", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("282", "56", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("283", "56", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("284", "56", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("285", "56", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("286", "56", "_menu_item_orphaned", "1433945969");
INSERT INTO `wp_postmeta` VALUES("287", "57", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("288", "57", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("289", "57", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("290", "57", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("291", "57", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("292", "57", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("293", "57", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("294", "57", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("295", "57", "_menu_item_orphaned", "1433945969");
INSERT INTO `wp_postmeta` VALUES("296", "58", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("297", "58", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("298", "58", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("299", "58", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("300", "58", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("301", "58", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("302", "58", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("303", "58", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("304", "58", "_menu_item_orphaned", "1433945969");
INSERT INTO `wp_postmeta` VALUES("305", "59", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("306", "59", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("307", "59", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("308", "59", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("309", "59", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("310", "59", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("311", "59", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("312", "59", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("313", "59", "_menu_item_orphaned", "1433945969");
INSERT INTO `wp_postmeta` VALUES("314", "60", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("315", "60", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("316", "60", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("317", "60", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("318", "60", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("319", "60", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("320", "60", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("321", "60", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("322", "60", "_menu_item_orphaned", "1433945969");
INSERT INTO `wp_postmeta` VALUES("323", "61", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("324", "61", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("325", "61", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("326", "61", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("327", "61", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("328", "61", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("329", "61", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("330", "61", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("331", "61", "_menu_item_orphaned", "1433945969");
INSERT INTO `wp_postmeta` VALUES("332", "62", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("333", "62", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("334", "62", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("335", "62", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("336", "62", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("337", "62", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("338", "62", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("339", "62", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("340", "62", "_menu_item_orphaned", "1433945969");
INSERT INTO `wp_postmeta` VALUES("341", "63", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("342", "63", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("343", "63", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("344", "63", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("345", "63", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("346", "63", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("347", "63", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("348", "63", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("349", "63", "_menu_item_orphaned", "1433945969");
INSERT INTO `wp_postmeta` VALUES("350", "64", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("351", "64", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("352", "64", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("353", "64", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("354", "64", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("355", "64", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("356", "64", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("357", "64", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("358", "64", "_menu_item_orphaned", "1433945979");
INSERT INTO `wp_postmeta` VALUES("359", "65", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("360", "65", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("361", "65", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("362", "65", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("363", "65", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("364", "65", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("365", "65", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("366", "65", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("367", "65", "_menu_item_orphaned", "1433945979");
INSERT INTO `wp_postmeta` VALUES("368", "66", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("369", "66", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("370", "66", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("371", "66", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("372", "66", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("373", "66", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("374", "66", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("375", "66", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("376", "66", "_menu_item_orphaned", "1433945979");
INSERT INTO `wp_postmeta` VALUES("377", "67", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("378", "67", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("379", "67", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("380", "67", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("381", "67", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("382", "67", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("383", "67", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("384", "67", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("385", "67", "_menu_item_orphaned", "1433945979");
INSERT INTO `wp_postmeta` VALUES("386", "68", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("387", "68", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("388", "68", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("389", "68", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("390", "68", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("391", "68", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("392", "68", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("393", "68", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("394", "68", "_menu_item_orphaned", "1433945979");
INSERT INTO `wp_postmeta` VALUES("395", "69", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("396", "69", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("397", "69", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("398", "69", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("399", "69", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("400", "69", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("401", "69", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("402", "69", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("403", "69", "_menu_item_orphaned", "1433945979");
INSERT INTO `wp_postmeta` VALUES("404", "70", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("405", "70", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("406", "70", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("407", "70", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("408", "70", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("409", "70", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("410", "70", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("411", "70", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("412", "70", "_menu_item_orphaned", "1433945979");
INSERT INTO `wp_postmeta` VALUES("413", "71", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("414", "71", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("415", "71", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("416", "71", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("417", "71", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("418", "71", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("419", "71", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("420", "71", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("421", "71", "_menu_item_orphaned", "1433945979");
INSERT INTO `wp_postmeta` VALUES("422", "72", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("423", "72", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("424", "72", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("425", "72", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("426", "72", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("427", "72", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("428", "72", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("429", "72", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("430", "72", "_menu_item_orphaned", "1433946008");
INSERT INTO `wp_postmeta` VALUES("431", "73", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("432", "73", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("433", "73", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("434", "73", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("435", "73", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("436", "73", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("437", "73", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("438", "73", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("439", "73", "_menu_item_orphaned", "1433946008");
INSERT INTO `wp_postmeta` VALUES("440", "74", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("441", "74", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("442", "74", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("443", "74", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("444", "74", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("445", "74", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("446", "74", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("447", "74", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("448", "74", "_menu_item_orphaned", "1433946008");
INSERT INTO `wp_postmeta` VALUES("449", "75", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("450", "75", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("451", "75", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("452", "75", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("453", "75", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("454", "75", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("455", "75", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("456", "75", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("457", "75", "_menu_item_orphaned", "1433946008");
INSERT INTO `wp_postmeta` VALUES("458", "76", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("459", "76", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("460", "76", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("461", "76", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("462", "76", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("463", "76", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("464", "76", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("465", "76", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("466", "76", "_menu_item_orphaned", "1433946008");
INSERT INTO `wp_postmeta` VALUES("467", "77", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("468", "77", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("469", "77", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("470", "77", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("471", "77", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("472", "77", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("473", "77", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("474", "77", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("475", "77", "_menu_item_orphaned", "1433946008");
INSERT INTO `wp_postmeta` VALUES("476", "78", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("477", "78", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("478", "78", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("479", "78", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("480", "78", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("481", "78", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("482", "78", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("483", "78", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("484", "78", "_menu_item_orphaned", "1433946008");
INSERT INTO `wp_postmeta` VALUES("485", "79", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("486", "79", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("487", "79", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("488", "79", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("489", "79", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("490", "79", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("491", "79", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("492", "79", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("493", "79", "_menu_item_orphaned", "1433946008");
INSERT INTO `wp_postmeta` VALUES("494", "80", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("495", "80", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("496", "80", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("497", "80", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("498", "80", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("499", "80", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("500", "80", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("501", "80", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("502", "80", "_menu_item_orphaned", "1433946021");
INSERT INTO `wp_postmeta` VALUES("503", "81", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("504", "81", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("505", "81", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("506", "81", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("507", "81", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("508", "81", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("509", "81", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("510", "81", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("511", "81", "_menu_item_orphaned", "1433946021");
INSERT INTO `wp_postmeta` VALUES("512", "82", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("513", "82", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("514", "82", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("515", "82", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("516", "82", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("517", "82", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("518", "82", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("519", "82", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("520", "82", "_menu_item_orphaned", "1433946021");
INSERT INTO `wp_postmeta` VALUES("521", "83", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("522", "83", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("523", "83", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("524", "83", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("525", "83", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("526", "83", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("527", "83", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("528", "83", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("529", "83", "_menu_item_orphaned", "1433946021");
INSERT INTO `wp_postmeta` VALUES("530", "84", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("531", "84", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("532", "84", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("533", "84", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("534", "84", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("535", "84", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("536", "84", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("537", "84", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("538", "84", "_menu_item_orphaned", "1433946021");
INSERT INTO `wp_postmeta` VALUES("539", "85", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("540", "85", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("541", "85", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("542", "85", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("543", "85", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("544", "85", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("545", "85", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("546", "85", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("547", "85", "_menu_item_orphaned", "1433946021");
INSERT INTO `wp_postmeta` VALUES("548", "86", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("549", "86", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("550", "86", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("551", "86", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("552", "86", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("553", "86", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("554", "86", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("555", "86", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("556", "86", "_menu_item_orphaned", "1433946021");
INSERT INTO `wp_postmeta` VALUES("557", "87", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("558", "87", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("559", "87", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("560", "87", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("561", "87", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("562", "87", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("563", "87", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("564", "87", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("565", "87", "_menu_item_orphaned", "1433946021");
INSERT INTO `wp_postmeta` VALUES("566", "88", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("567", "88", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("568", "88", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("569", "88", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("570", "88", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("571", "88", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("572", "88", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("573", "88", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("574", "88", "_menu_item_orphaned", "1433946071");
INSERT INTO `wp_postmeta` VALUES("575", "89", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("576", "89", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("577", "89", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("578", "89", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("579", "89", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("580", "89", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("581", "89", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("582", "89", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("583", "89", "_menu_item_orphaned", "1433946071");
INSERT INTO `wp_postmeta` VALUES("584", "90", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("585", "90", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("586", "90", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("587", "90", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("588", "90", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("589", "90", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("590", "90", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("591", "90", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("592", "90", "_menu_item_orphaned", "1433946071");
INSERT INTO `wp_postmeta` VALUES("593", "91", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("594", "91", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("595", "91", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("596", "91", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("597", "91", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("598", "91", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("599", "91", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("600", "91", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("601", "91", "_menu_item_orphaned", "1433946071");
INSERT INTO `wp_postmeta` VALUES("602", "92", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("603", "92", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("604", "92", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("605", "92", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("606", "92", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("607", "92", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("608", "92", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("609", "92", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("610", "92", "_menu_item_orphaned", "1433946071");
INSERT INTO `wp_postmeta` VALUES("611", "93", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("612", "93", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("613", "93", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("614", "93", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("615", "93", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("616", "93", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("617", "93", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("618", "93", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("619", "93", "_menu_item_orphaned", "1433946071");
INSERT INTO `wp_postmeta` VALUES("620", "94", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("621", "94", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("622", "94", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("623", "94", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("624", "94", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("625", "94", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("626", "94", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("627", "94", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("628", "94", "_menu_item_orphaned", "1433946071");
INSERT INTO `wp_postmeta` VALUES("629", "95", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("630", "95", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("631", "95", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("632", "95", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("633", "95", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("634", "95", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("635", "95", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("636", "95", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("637", "95", "_menu_item_orphaned", "1433946071");
INSERT INTO `wp_postmeta` VALUES("638", "96", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("639", "96", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("640", "96", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("641", "96", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("642", "96", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("643", "96", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("644", "96", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("645", "96", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("646", "96", "_menu_item_orphaned", "1433946113");
INSERT INTO `wp_postmeta` VALUES("647", "97", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("648", "97", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("649", "97", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("650", "97", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("651", "97", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("652", "97", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("653", "97", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("654", "97", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("655", "97", "_menu_item_orphaned", "1433946113");
INSERT INTO `wp_postmeta` VALUES("656", "98", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("657", "98", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("658", "98", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("659", "98", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("660", "98", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("661", "98", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("662", "98", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("663", "98", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("664", "98", "_menu_item_orphaned", "1433946113");
INSERT INTO `wp_postmeta` VALUES("665", "99", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("666", "99", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("667", "99", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("668", "99", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("669", "99", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("670", "99", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("671", "99", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("672", "99", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("673", "99", "_menu_item_orphaned", "1433946113");
INSERT INTO `wp_postmeta` VALUES("674", "100", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("675", "100", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("676", "100", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("677", "100", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("678", "100", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("679", "100", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("680", "100", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("681", "100", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("682", "100", "_menu_item_orphaned", "1433946113");
INSERT INTO `wp_postmeta` VALUES("683", "101", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("684", "101", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("685", "101", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("686", "101", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("687", "101", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("688", "101", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("689", "101", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("690", "101", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("691", "101", "_menu_item_orphaned", "1433946113");
INSERT INTO `wp_postmeta` VALUES("692", "102", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("693", "102", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("694", "102", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("695", "102", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("696", "102", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("697", "102", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("698", "102", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("699", "102", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("700", "102", "_menu_item_orphaned", "1433946113");
INSERT INTO `wp_postmeta` VALUES("701", "103", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("702", "103", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("703", "103", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("704", "103", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("705", "103", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("706", "103", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("707", "103", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("708", "103", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("709", "103", "_menu_item_orphaned", "1433946113");
INSERT INTO `wp_postmeta` VALUES("710", "104", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("711", "104", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("712", "104", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("713", "104", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("714", "104", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("715", "104", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("716", "104", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("717", "104", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("718", "104", "_menu_item_orphaned", "1433946197");
INSERT INTO `wp_postmeta` VALUES("719", "105", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("720", "105", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("721", "105", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("722", "105", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("723", "105", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("724", "105", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("725", "105", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("726", "105", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("727", "105", "_menu_item_orphaned", "1433946197");
INSERT INTO `wp_postmeta` VALUES("728", "106", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("729", "106", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("730", "106", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("731", "106", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("732", "106", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("733", "106", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("734", "106", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("735", "106", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("736", "106", "_menu_item_orphaned", "1433946197");
INSERT INTO `wp_postmeta` VALUES("737", "107", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("738", "107", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("739", "107", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("740", "107", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("741", "107", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("742", "107", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("743", "107", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("744", "107", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("745", "107", "_menu_item_orphaned", "1433946197");
INSERT INTO `wp_postmeta` VALUES("746", "108", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("747", "108", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("748", "108", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("749", "108", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("750", "108", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("751", "108", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("752", "108", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("753", "108", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("754", "108", "_menu_item_orphaned", "1433946197");
INSERT INTO `wp_postmeta` VALUES("755", "109", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("756", "109", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("757", "109", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("758", "109", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("759", "109", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("760", "109", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("761", "109", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("762", "109", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("763", "109", "_menu_item_orphaned", "1433946197");
INSERT INTO `wp_postmeta` VALUES("764", "110", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("765", "110", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("766", "110", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("767", "110", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("768", "110", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("769", "110", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("770", "110", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("771", "110", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("772", "110", "_menu_item_orphaned", "1433946197");
INSERT INTO `wp_postmeta` VALUES("773", "111", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("774", "111", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("775", "111", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("776", "111", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("777", "111", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("778", "111", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("779", "111", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("780", "111", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("781", "111", "_menu_item_orphaned", "1433946197");
INSERT INTO `wp_postmeta` VALUES("782", "112", "fw-shortcode-default-values", "{\"section\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"}}");
INSERT INTO `wp_postmeta` VALUES("783", "112", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("784", "112", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("785", "113", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("786", "112", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2847:\"[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-binoculars\",\"title\":\"Systemy CMS\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-calculator\",\"title\":\"Reklamy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-certificate\",\"title\":\"Programowanie C++\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-envelope-o\",\"title\":\"WordPress\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-check\",\"title\":\"Publikacje elektroniczne\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-bookmark-o\",\"title\":\"Pozycjonowanie i SEO\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-download\",\"title\":\"Systemy CMS\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}]\";s:14:\"corrected_json\";s:3062:\"[{\"_items\":[{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-binoculars\",\"title\":\"Systemy CMS\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-calculator\",\"title\":\"Reklamy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-certificate\",\"title\":\"Programowanie C++\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-envelope-o\",\"title\":\"WordPress\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-check\",\"title\":\"Publikacje elektroniczne\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-bookmark-o\",\"title\":\"Pozycjonowanie i SEO\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-download\",\"title\":\"Systemy CMS\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:3017:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-binoculars\" title=\"Systemy CMS\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-calculator\" title=\"Reklamy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-certificate\" title=\"Programowanie C++\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-envelope-o\" title=\"WordPress\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-check\" title=\"Publikacje elektroniczne\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-bookmark-o\" title=\"Pozycjonowanie i SEO\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-download\" title=\"Systemy CMS\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("787", "112", "_edit_lock", "1434956988:1");
INSERT INTO `wp_postmeta` VALUES("788", "114", "fw-shortcode-default-values", "{\"section\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"}}");
INSERT INTO `wp_postmeta` VALUES("789", "114", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("790", "114", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("791", "115", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("792", "114", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1586:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Przyk\\u0142adowa strona\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.<\\/p><p>Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.<\\/p>\"}}]\";s:14:\"corrected_json\";s:1861:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Przyk\\u0142adowa strona\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.<\\/p><p>Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:1854:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Przykładowa strona\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.&lt;/p&gt;&lt;p&gt;Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("793", "114", "_edit_lock", "1434017696:1");
INSERT INTO `wp_postmeta` VALUES("794", "116", "fw-shortcode-default-values", "[]");
INSERT INTO `wp_postmeta` VALUES("795", "116", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("796", "116", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("797", "117", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("798", "116", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1783:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}]\";s:14:\"corrected_json\";s:2334:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:2310:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("799", "116", "_edit_lock", "1434017590:1");
INSERT INTO `wp_postmeta` VALUES("800", "118", "fw-shortcode-default-values", "[]");
INSERT INTO `wp_postmeta` VALUES("801", "118", "fw-shortcode-settings", "[]");
INSERT INTO `wp_postmeta` VALUES("802", "118", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("803", "119", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("804", "118", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2:\"[]\";s:14:\"corrected_json\";s:2:\"[]\";s:18:\"shortcode_notation\";s:0:\"\";s:14:\"builder_active\";b:0;}}");
INSERT INTO `wp_postmeta` VALUES("805", "118", "_edit_lock", "1434626742:1");
INSERT INTO `wp_postmeta` VALUES("806", "120", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("807", "120", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("808", "120", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("809", "120", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("810", "120", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("811", "120", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("812", "120", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("813", "120", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("815", "121", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("816", "121", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("817", "121", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("818", "121", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("819", "121", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("820", "121", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("821", "121", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("822", "121", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("824", "122", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("825", "122", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("826", "122", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("827", "122", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("828", "122", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("829", "122", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("830", "122", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("831", "122", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("832", "122", "_menu_item_orphaned", "1433946607");
INSERT INTO `wp_postmeta` VALUES("833", "123", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("834", "123", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("835", "123", "_menu_item_object_id", "116");
INSERT INTO `wp_postmeta` VALUES("836", "123", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("837", "123", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("838", "123", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("839", "123", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("840", "123", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("842", "124", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("843", "124", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("844", "124", "_menu_item_object_id", "118");
INSERT INTO `wp_postmeta` VALUES("845", "124", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("846", "124", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("847", "124", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("848", "124", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("849", "124", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("851", "125", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("852", "125", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("853", "125", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("854", "125", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("855", "125", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("856", "125", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("857", "125", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("858", "125", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("859", "125", "_menu_item_orphaned", "1433946607");
INSERT INTO `wp_postmeta` VALUES("860", "126", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("861", "126", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("862", "126", "_menu_item_object_id", "114");
INSERT INTO `wp_postmeta` VALUES("863", "126", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("864", "126", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("865", "126", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("866", "126", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("867", "126", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("869", "127", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("870", "127", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("871", "127", "_menu_item_object_id", "30");
INSERT INTO `wp_postmeta` VALUES("872", "127", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("873", "127", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("874", "127", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("875", "127", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("876", "127", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("877", "127", "_menu_item_orphaned", "1433946607");
INSERT INTO `wp_postmeta` VALUES("878", "128", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("879", "128", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("880", "128", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("881", "128", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("882", "128", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("883", "128", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("884", "128", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("885", "128", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("886", "128", "_menu_item_orphaned", "1433946607");
INSERT INTO `wp_postmeta` VALUES("887", "129", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("888", "129", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("889", "129", "_menu_item_object_id", "112");
INSERT INTO `wp_postmeta` VALUES("890", "129", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("891", "129", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("892", "129", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("893", "129", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("894", "129", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("896", "130", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("897", "130", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("898", "130", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("899", "130", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("900", "130", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("901", "130", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("902", "130", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("903", "130", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("904", "130", "_menu_item_orphaned", "1433946607");
INSERT INTO `wp_postmeta` VALUES("905", "131", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("906", "131", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("907", "131", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("908", "131", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("909", "131", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("910", "131", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("911", "131", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("912", "131", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("913", "131", "_menu_item_orphaned", "1433946607");
INSERT INTO `wp_postmeta` VALUES("914", "132", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2845:\"[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}],\"width\":\"1_3\"},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}]\";s:14:\"corrected_json\";s:3060:\"[{\"_items\":[{\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}],\"width\":\"1_3\"},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:3015:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("915", "133", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1586:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Przyk\\u0142adowa strona\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.<\\/p><p>Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.<\\/p>\"}}]\";s:14:\"corrected_json\";s:1861:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Przyk\\u0142adowa strona\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.<\\/p><p>Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:1854:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Przykładowa strona\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.&lt;/p&gt;&lt;p&gt;Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("918", "135", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1783:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}]\";s:14:\"corrected_json\";s:2334:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:2310:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("921", "138", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2:\"[]\";s:14:\"corrected_json\";s:2:\"[]\";s:18:\"shortcode_notation\";s:0:\"\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("922", "139", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2:\"[]\";s:14:\"corrected_json\";s:2:\"[]\";s:18:\"shortcode_notation\";s:0:\"\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("923", "140", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2845:\"[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}],\"width\":\"1_3\"},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}]\";s:14:\"corrected_json\";s:3060:\"[{\"_items\":[{\"_items\":[{\"type\":\"column\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}],\"width\":\"1_3\"},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:3015:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("924", "141", "_wp_attached_file", "2015/06/page_header_3.jpg");
INSERT INTO `wp_postmeta` VALUES("925", "141", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:569;s:4:\"file\";s:25:\"2015/06/page_header_3.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"page_header_3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"page_header_3-300x133.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:133;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"page_header_3-1024x455.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:455;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("926", "141", "_wp_attachment_image_alt", "elementy");
INSERT INTO `wp_postmeta` VALUES("927", "116", "_thumbnail_id", "141");
INSERT INTO `wp_postmeta` VALUES("928", "142", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2:\"[]\";s:14:\"corrected_json\";s:2:\"[]\";s:18:\"shortcode_notation\";s:0:\"\";s:14:\"builder_active\";b:0;}}");
INSERT INTO `wp_postmeta` VALUES("929", "143", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1783:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}},{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}]\";s:14:\"corrected_json\";s:2334:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"WordPress\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:2310:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("930", "144", "_wp_attached_file", "2015/06/page_header_1.jpg");
INSERT INTO `wp_postmeta` VALUES("931", "144", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:529;s:4:\"file\";s:25:\"2015/06/page_header_1.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"page_header_1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"page_header_1-300x124.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:124;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"page_header_1-1024x423.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:423;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("932", "144", "_wp_attachment_image_alt", "uslugi");
INSERT INTO `wp_postmeta` VALUES("933", "112", "_thumbnail_id", "144");
INSERT INTO `wp_postmeta` VALUES("934", "145", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1586:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Przyk\\u0142adowa strona\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}},{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.<\\/p><p>Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.<\\/p>\"}}]\";s:14:\"corrected_json\";s:1861:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Przyk\\u0142adowa strona\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":false}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"text_block\",\"atts\":{\"text\":\"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.<\\/p><p>Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.<\\/p>\"}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:1854:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Przykładowa strona\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.&lt;/p&gt;&lt;p&gt;Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("935", "146", "_wp_attached_file", "2015/06/page_header_2.jpg");
INSERT INTO `wp_postmeta` VALUES("936", "146", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:557;s:4:\"file\";s:25:\"2015/06/page_header_2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"page_header_2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"page_header_2-300x131.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:131;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"page_header_2-1024x446.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:446;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("937", "146", "_wp_attachment_image_alt", "strony");
INSERT INTO `wp_postmeta` VALUES("938", "114", "_thumbnail_id", "146");
INSERT INTO `wp_postmeta` VALUES("939", "147", "_wp_attached_file", "2015/06/page_headerdd_4.jpg");
INSERT INTO `wp_postmeta` VALUES("940", "147", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:487;s:4:\"file\";s:27:\"2015/06/page_headerdd_4.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"page_headerdd_4-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"page_headerdd_4-300x114.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:114;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:28:\"page_headerdd_4-1024x390.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:390;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("941", "147", "_wp_attachment_image_alt", "kontakt");
INSERT INTO `wp_postmeta` VALUES("942", "118", "_thumbnail_id", "147");
INSERT INTO `wp_postmeta` VALUES("948", "150", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("949", "150", "_edit_lock", "1434097677:1");
INSERT INTO `wp_postmeta` VALUES("952", "151", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("953", "152", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("954", "152", "_edit_lock", "1434097667:1");
INSERT INTO `wp_postmeta` VALUES("957", "153", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("958", "154", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("959", "154", "_edit_lock", "1434097658:1");
INSERT INTO `wp_postmeta` VALUES("960", "155", "_wp_attached_file", "2015/06/blog_1.jpg");
INSERT INTO `wp_postmeta` VALUES("961", "155", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1024;s:6:\"height\";i:683;s:4:\"file\";s:18:\"2015/06/blog_1.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"blog_1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"blog_1-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"blog_1-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("962", "155", "_wp_attachment_image_alt", "blog 1");
INSERT INTO `wp_postmeta` VALUES("963", "154", "_thumbnail_id", "155");
INSERT INTO `wp_postmeta` VALUES("966", "156", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("967", "157", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("968", "157", "_edit_lock", "1434097648:1");
INSERT INTO `wp_postmeta` VALUES("969", "158", "_wp_attached_file", "2015/06/blog_2.jpg");
INSERT INTO `wp_postmeta` VALUES("970", "158", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1024;s:6:\"height\";i:683;s:4:\"file\";s:18:\"2015/06/blog_2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"blog_2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"blog_2-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"blog_2-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("971", "158", "_wp_attachment_image_alt", "blog 2");
INSERT INTO `wp_postmeta` VALUES("972", "157", "_thumbnail_id", "158");
INSERT INTO `wp_postmeta` VALUES("975", "159", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("978", "160", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("981", "161", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("984", "162", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("987", "163", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("990", "164", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("993", "165", "fw_options", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("994", "167", "ml-slider_settings", "a:35:{s:4:\"type\";s:4:\"flex\";s:6:\"random\";s:5:\"false\";s:8:\"cssClass\";s:0:\"\";s:8:\"printCss\";s:4:\"true\";s:7:\"printJs\";s:4:\"true\";s:5:\"width\";s:4:\"1920\";s:6:\"height\";s:3:\"970\";s:3:\"spw\";i:7;s:3:\"sph\";i:5;s:5:\"delay\";s:4:\"3000\";s:6:\"sDelay\";i:30;s:7:\"opacity\";d:0.69999999999999996;s:10:\"titleSpeed\";i:500;s:6:\"effect\";s:4:\"fade\";s:10:\"navigation\";s:5:\"false\";s:5:\"links\";s:4:\"true\";s:10:\"hoverPause\";s:4:\"true\";s:5:\"theme\";s:7:\"default\";s:9:\"direction\";s:10:\"horizontal\";s:7:\"reverse\";s:5:\"false\";s:14:\"animationSpeed\";s:3:\"600\";s:8:\"prevText\";s:1:\"<\";s:8:\"nextText\";s:1:\">\";s:6:\"slices\";i:15;s:6:\"center\";s:4:\"true\";s:9:\"smartCrop\";s:4:\"true\";s:12:\"carouselMode\";s:5:\"false\";s:14:\"carouselMargin\";s:1:\"5\";s:6:\"easing\";s:6:\"linear\";s:8:\"autoPlay\";s:4:\"true\";s:11:\"thumb_width\";i:150;s:12:\"thumb_height\";i:100;s:9:\"fullWidth\";s:4:\"true\";s:10:\"noConflict\";s:4:\"true\";s:12:\"smoothHeight\";s:5:\"false\";}");
INSERT INTO `wp_postmeta` VALUES("1008", "171", "_wp_attached_file", "2015/06/slider_1.jpg");
INSERT INTO `wp_postmeta` VALUES("1009", "171", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1700;s:6:\"height\";i:1133;s:4:\"file\";s:20:\"2015/06/slider_1.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:20:\"slider_1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:20:\"slider_1-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:21:\"slider_1-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1010", "172", "_wp_attached_file", "2015/06/slider_2.jpg");
INSERT INTO `wp_postmeta` VALUES("1011", "172", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1700;s:6:\"height\";i:1133;s:4:\"file\";s:20:\"2015/06/slider_2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:20:\"slider_2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:20:\"slider_2-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:21:\"slider_2-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1012", "173", "_wp_attached_file", "2015/06/slider_3.jpg");
INSERT INTO `wp_postmeta` VALUES("1013", "173", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1700;s:6:\"height\";i:1133;s:4:\"file\";s:20:\"2015/06/slider_3.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:20:\"slider_3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:20:\"slider_3-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:21:\"slider_3-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1014", "171", "_wp_attachment_image_alt", "slajd 1");
INSERT INTO `wp_postmeta` VALUES("1015", "172", "_wp_attachment_image_alt", "slajd 2");
INSERT INTO `wp_postmeta` VALUES("1016", "173", "_wp_attachment_image_alt", "slajd 3");
INSERT INTO `wp_postmeta` VALUES("1017", "173", "ml-slider_type", "image");
INSERT INTO `wp_postmeta` VALUES("1018", "171", "ml-slider_type", "image");
INSERT INTO `wp_postmeta` VALUES("1019", "172", "ml-slider_type", "image");
INSERT INTO `wp_postmeta` VALUES("1020", "173", "_wp_attachment_backup_sizes", "a:1:{s:16:\"resized-1700x858\";a:5:{s:4:\"path\";s:94:\"C:Bitnamiwordpress-4.2.2-0appswordpresshtdocs/wp-content/uploads/2015/06/slider_3-1700x858.jpg\";s:4:\"file\";s:21:\"slider_3-1700x858.jpg\";s:5:\"width\";i:1700;s:6:\"height\";i:858;s:9:\"mime-type\";s:10:\"image/jpeg\";}}");
INSERT INTO `wp_postmeta` VALUES("1021", "171", "_wp_attachment_backup_sizes", "a:1:{s:16:\"resized-1700x858\";a:5:{s:4:\"path\";s:94:\"C:Bitnamiwordpress-4.2.2-0appswordpresshtdocs/wp-content/uploads/2015/06/slider_1-1700x858.jpg\";s:4:\"file\";s:21:\"slider_1-1700x858.jpg\";s:5:\"width\";i:1700;s:6:\"height\";i:858;s:9:\"mime-type\";s:10:\"image/jpeg\";}}");
INSERT INTO `wp_postmeta` VALUES("1022", "172", "_wp_attachment_backup_sizes", "a:1:{s:16:\"resized-1700x858\";a:5:{s:4:\"path\";s:94:\"C:Bitnamiwordpress-4.2.2-0appswordpresshtdocs/wp-content/uploads/2015/06/slider_2-1700x858.jpg\";s:4:\"file\";s:21:\"slider_2-1700x858.jpg\";s:5:\"width\";i:1700;s:6:\"height\";i:858;s:9:\"mime-type\";s:10:\"image/jpeg\";}}");
INSERT INTO `wp_postmeta` VALUES("1023", "173", "ml-slider_crop_position", "center-center");
INSERT INTO `wp_postmeta` VALUES("1024", "171", "ml-slider_crop_position", "center-center");
INSERT INTO `wp_postmeta` VALUES("1025", "172", "ml-slider_crop_position", "center-center");
INSERT INTO `wp_postmeta` VALUES("1026", "174", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2:\"[]\";s:14:\"corrected_json\";s:2:\"[]\";s:18:\"shortcode_notation\";s:0:\"\";s:14:\"builder_active\";b:0;}}");
INSERT INTO `wp_postmeta` VALUES("1027", "175", "_form", "<div class=\"form-control-wrapper\">\n[text name class:form-control]<div class=\"floating-label\">\nImię i nazwisko\n</div>\n</div>\n\n<div class=\"form-control-wrapper\">\n[tel phone class:form-control]<div class=\"floating-label\">\nTelefon\n</div>\n</div>\n\n<div class=\"form-control-wrapper\">\n[email email class:form-control]<div class=\"floating-label\">\nEmail\n</div>\n</div>\n\n<div class=\"form-control-wrapper\">\n[textarea message class:form-control]<div class=\"floating-label\">\nWiadomość\n</div>\n</div>\n\n[submit class:fw-btn class:fw-btn-black class:fw-btn-1 \"Wyślij zapytanie\"]");
INSERT INTO `wp_postmeta` VALUES("1028", "175", "_mail", "a:8:{s:7:\"subject\";s:14:\"[your-subject]\";s:6:\"sender\";s:35:\"[your-name] <admin@strefakursow.pl>\";s:4:\"body\";s:184:\"Nadawca: [your-name] <[your-email]>\nTemat: [your-subject]\n\nTreść wiadomości:\n[your-message]\n\n--\nThis e-mail was sent from a contact form on Kurs WP (http://localhost:8080/wordpress)\";s:9:\"recipient\";s:21:\"admin@strefakursow.pl\";s:18:\"additional_headers\";s:22:\"Reply-To: [your-email]\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";b:0;s:13:\"exclude_blank\";b:0;}");
INSERT INTO `wp_postmeta` VALUES("1029", "175", "_mail_2", "a:9:{s:6:\"active\";b:0;s:7:\"subject\";s:14:\"[your-subject]\";s:6:\"sender\";s:31:\"Kurs WP <admin@strefakursow.pl>\";s:4:\"body\";s:125:\"Treść wiadomości:\n[your-message]\n\n--\nThis e-mail was sent from a contact form on Kurs WP (http://localhost:8080/wordpress)\";s:9:\"recipient\";s:12:\"[your-email]\";s:18:\"additional_headers\";s:31:\"Reply-To: admin@strefakursow.pl\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";b:0;s:13:\"exclude_blank\";b:0;}");
INSERT INTO `wp_postmeta` VALUES("1030", "175", "_messages", "a:23:{s:12:\"mail_sent_ok\";s:49:\"Twoja wiadomość została wysłana. Dziękujemy.\";s:12:\"mail_sent_ng\";s:40:\"Twoja wiadomość nie została wysłana.\";s:16:\"validation_error\";s:85:\"Wystąpiły błędy. Sprawdź wszystkie pola formularza i spróbuj wysłać ponownie.\";s:4:\"spam\";s:40:\"Twoja wiadomość nie została wysłana.\";s:12:\"accept_terms\";s:85:\"Proszę zapoznać się z warunkami oraz zaznaczyć odpowiednie pole aby kontynuować.\";s:16:\"invalid_required\";s:34:\"Please fill in the required field.\";s:16:\"invalid_too_long\";s:23:\"This input is too long.\";s:17:\"invalid_too_short\";s:24:\"This input is too short.\";s:17:\"captcha_not_match\";s:32:\"Wpisany kod jest nieprawidłowy.\";s:14:\"invalid_number\";s:31:\"Format liczby jest niepoprawny.\";s:16:\"number_too_small\";s:26:\"Ta liczba jest zbyt mała.\";s:16:\"number_too_large\";s:26:\"Ta liczba jest zbyt duża.\";s:13:\"invalid_email\";s:37:\"Podany adres e-mail jest niepoprawny.\";s:11:\"invalid_url\";s:27:\"Adres URL jest niepoprawny.\";s:11:\"invalid_tel\";s:39:\"Podany numer telefonu jest niepoprawny.\";s:23:\"quiz_answer_not_correct\";s:32:\"Odpowiedź nie jest prawidłowa.\";s:12:\"invalid_date\";s:29:\"Format daty jest niepoprawny.\";s:14:\"date_too_early\";s:30:\"Podana data jest zbyt wczesna.\";s:13:\"date_too_late\";s:30:\"Podana data jest zbyt późna.\";s:13:\"upload_failed\";s:34:\"Błąd podczas przesyłania pliku.\";s:24:\"upload_file_type_invalid\";s:50:\"Przesyłanie tego rodzaju pliku jest niedozwolone.\";s:21:\"upload_file_too_large\";s:21:\"Plik jest zbyt duży.\";s:23:\"upload_failed_php_error\";s:52:\"Nie udało się przesłać pliku. Wystąpił błąd.\";}");
INSERT INTO `wp_postmeta` VALUES("1031", "175", "_additional_settings", "");
INSERT INTO `wp_postmeta` VALUES("1032", "175", "_locale", "pl_PL");
INSERT INTO `wp_postmeta` VALUES("1033", "176", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2:\"[]\";s:14:\"corrected_json\";s:2:\"[]\";s:18:\"shortcode_notation\";s:0:\"\";s:14:\"builder_active\";b:0;}}");
INSERT INTO `wp_postmeta` VALUES("1034", "177", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:948:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Dlaczego warto nas wybra\\u0107\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Rozwojowy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Responsywny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]}]\";s:14:\"corrected_json\";s:1180:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Dlaczego warto nas wybra\\u0107\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Rozwojowy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Responsywny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:1147:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Dlaczego warto nas wybrać\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Rozwojowy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Responsywny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("1036", "179", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1528:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zalety naszego produktu\",\"subtitle\":\"Jasze wi\\u0119cej jeszcze lepszych rzeczy za naprawde jeszcze ma\\u0142\\u0105 cen\\u0119\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"30\"}}}},{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"},\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"19\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png\"},\"width\":\"500\",\"height\":\"387\",\"link\":\"\",\"target\":\"_self\"}}]},{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Animacje oraz skrypty\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Material Design\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}}]}]}]\";s:14:\"corrected_json\";s:1852:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zalety naszego produktu\",\"subtitle\":\"Jasze wi\\u0119cej jeszcze lepszych rzeczy za naprawde jeszcze ma\\u0142\\u0105 cen\\u0119\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"30\"}}}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}},{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":false},\"_items\":[{\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"19\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png\"},\"width\":\"500\",\"height\":\"387\",\"link\":\"\",\"target\":\"_self\"}}]},{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Animacje oraz skrypty\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Material Design\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}}]}],\"type\":\"row\"}]}]\";s:18:\"shortcode_notation\";s:2160:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Zalety naszego produktu\" subtitle=\"Jasze więcej jeszcze lepszych rzeczy za naprawde jeszcze małą cenę\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;30&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][/column][/row][/section][section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;19&quot;,&quot;url&quot;:&quot;\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png&quot;}\" width=\"500\" height=\"387\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Animacje oraz skrypty\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Material Design\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("1038", "181", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:1530:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zalety naszego produktu\",\"subtitle\":\"Jasze wi\\u0119cej jeszcze lepszych rzeczy za naprawde jeszcze ma\\u0142\\u0105 cen\\u0119\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"30\"}}}},{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\"},\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"19\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png\"},\"width\":\"500\",\"height\":\"387\",\"link\":\"\",\"target\":\"_self\"}}]},{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-road\",\"title\":\"Animacje oraz skrypty\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-camera\",\"title\":\"Material Design\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}}]}]}]\";s:14:\"corrected_json\";s:1854:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Zalety naszego produktu\",\"subtitle\":\"Jasze wi\\u0119cej jeszcze lepszych rzeczy za naprawde jeszcze ma\\u0142\\u0105 cen\\u0119\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"30\"}}}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}},{\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":false},\"_items\":[{\"_items\":[{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"media_image\",\"atts\":{\"image\":{\"attachment_id\":\"19\",\"url\":\"\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png\"},\"width\":\"500\",\"height\":\"387\",\"link\":\"\",\"target\":\"_self\"}}]},{\"type\":\"column\",\"width\":\"1_2\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-bell\",\"title\":\"Oparty na HTML5 i CSS3\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-road\",\"title\":\"Animacje oraz skrypty\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}},{\"type\":\"simple\",\"shortcode\":\"divider\",\"atts\":{\"style\":{\"ruler_type\":\"space\",\"space\":{\"height\":\"24\"}}}},{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-2\",\"icon\":\"fa fa-camera\",\"title\":\"Material Design\",\"content\":\"Curabitur consectetur mi sit amet nibh cursus, dapibus\"}}]}],\"type\":\"row\"}]}]\";s:18:\"shortcode_notation\";s:2162:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Zalety naszego produktu\" subtitle=\"Jasze więcej jeszcze lepszych rzeczy za naprawde jeszcze małą cenę\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;30&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][/column][/row][/section][section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;19&quot;,&quot;url&quot;:&quot;\\/\\/localhost:8080\\/wordpress\\/wp-content\\/uploads\\/2015\\/06\\/tablet.png&quot;}\" width=\"500\" height=\"387\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-road\" title=\"Animacje oraz skrypty\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-camera\" title=\"Material Design\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("1039", "182", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:957:\"[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Dlaczego warto nas wybra\\u0107\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-plus-circle\",\"title\":\"Rozwojowy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-user\",\"title\":\"Responsywny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]}]\";s:14:\"corrected_json\";s:1189:\"[{\"_items\":[{\"_items\":[{\"_items\":[{\"type\":\"simple\",\"shortcode\":\"special_heading\",\"atts\":{\"title\":\"Dlaczego warto nas wybra\\u0107\",\"subtitle\":\"\",\"heading\":\"h2\",\"centered\":true}}],\"type\":\"column\",\"width\":\"1_1\"}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-cog\",\"title\":\"Nowoczesny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-plus-circle\",\"title\":\"Rozwojowy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-user\",\"title\":\"Responsywny\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\"}}]}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:1156:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Dlaczego warto nas wybrać\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-plus-circle\" title=\"Rozwojowy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-user\" title=\"Responsywny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");
INSERT INTO `wp_postmeta` VALUES("1040", "183", "fw_options", "a:1:{s:12:\"page-builder\";a:4:{s:4:\"json\";s:2847:\"[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-binoculars\",\"title\":\"Systemy CMS\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-calculator\",\"title\":\"Reklamy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-certificate\",\"title\":\"Programowanie C++\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-envelope-o\",\"title\":\"WordPress\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-check\",\"title\":\"Publikacje elektroniczne\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-bookmark-o\",\"title\":\"Pozycjonowanie i SEO\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-download\",\"title\":\"Systemy CMS\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}]\";s:14:\"corrected_json\";s:3062:\"[{\"_items\":[{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-binoculars\",\"title\":\"Systemy CMS\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-calculator\",\"title\":\"Reklamy\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-certificate\",\"title\":\"Programowanie C++\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-envelope-o\",\"title\":\"WordPress\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-check\",\"title\":\"Publikacje elektroniczne\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"},{\"_items\":[{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-bookmark-o\",\"title\":\"Pozycjonowanie i SEO\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-camera\",\"title\":\"Programowanie PHP\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]},{\"type\":\"column\",\"width\":\"1_3\",\"_items\":[{\"type\":\"simple\",\"shortcode\":\"icon_box\",\"atts\":{\"style\":\"fw-iconbox-1\",\"icon\":\"fa fa-download\",\"title\":\"Systemy CMS\",\"content\":\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\"}}]}],\"type\":\"row\"}],\"type\":\"section\",\"atts\":{\"is_fullwidth\":false,\"background_color\":\"\",\"background_image\":\"\",\"video\":\"\",\"auto_generated\":true}}]\";s:18:\"shortcode_notation\";s:3017:\"[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-binoculars\" title=\"Systemy CMS\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-calculator\" title=\"Reklamy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-certificate\" title=\"Programowanie C++\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-envelope-o\" title=\"WordPress\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-check\" title=\"Publikacje elektroniczne\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-bookmark-o\" title=\"Pozycjonowanie i SEO\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-download\" title=\"Systemy CMS\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]\";s:14:\"builder_active\";b:1;}}");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("2", "1", "2015-06-09 13:24:23", "2015-06-09 13:24:23", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http:/wordpress/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "trash", "open", "open", "", "sample-page", "", "", "2015-06-09 16:10:35", "2015-06-09 14:10:35", "", "0", "http:/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("4", "1", "2015-06-09 16:10:35", "2015-06-09 14:10:35", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http:/wordpress/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "inherit", "closed", "open", "", "2-revision-v1", "", "", "2015-06-09 16:10:35", "2015-06-09 14:10:35", "", "2", "http://127.0.0.1:8080/wordpress/2015/06/09/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("5", "1", "2015-06-09 16:10:58", "2015-06-09 14:10:58", "", "Start", "", "publish", "closed", "open", "", "start", "", "", "2015-06-10 12:03:34", "2015-06-10 10:03:34", "", "0", "http://127.0.0.1:8080/wordpress/?page_id=5", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("6", "1", "2015-06-09 16:10:58", "2015-06-09 14:10:58", "", "Start", "", "inherit", "closed", "open", "", "5-revision-v1", "", "", "2015-06-09 16:10:58", "2015-06-09 14:10:58", "", "5", "http://127.0.0.1:8080/wordpress/2015/06/09/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("7", "1", "2015-06-09 16:11:13", "2015-06-09 14:11:13", "", "Blog", "", "publish", "closed", "open", "", "blog", "", "", "2015-06-09 16:11:13", "2015-06-09 14:11:13", "", "0", "http://127.0.0.1:8080/wordpress/?page_id=7", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2015-06-09 16:11:13", "2015-06-09 14:11:13", "", "Blog", "", "inherit", "closed", "open", "", "7-revision-v1", "", "", "2015-06-09 16:11:13", "2015-06-09 14:11:13", "", "7", "http://127.0.0.1:8080/wordpress/2015/06/09/7-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2015-06-10 11:09:51", "2015-06-10 09:09:51", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"To jest strona Start\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;To jest blok tekstu&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]", "Start", "", "inherit", "closed", "open", "", "5-revision-v1", "", "", "2015-06-10 11:09:51", "2015-06-10 09:09:51", "", "5", "http://localhost:8080/wordpress/2015/06/10/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2015-06-10 11:12:56", "2015-06-10 09:12:56", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" first_in_builder=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"To jest strona Start\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;To jest blok tekstu&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-arrow-circle-up\" title=\"Box 1\" content=\"Zawartość\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_2\" _made_with_builder=\"true\"][button label=\"ZOBACZ\" link=\"#\" target=\"_self\" color=\"blue\" _made_with_builder=\"true\"][/button][/column][/row][/section]", "Start", "", "inherit", "closed", "open", "", "5-revision-v1", "", "", "2015-06-10 11:12:56", "2015-06-10 09:12:56", "", "5", "http://localhost:8080/wordpress/2015/06/10/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2015-06-10 12:03:34", "2015-06-10 10:03:34", "", "Start", "", "inherit", "closed", "open", "", "5-revision-v1", "", "", "2015-06-10 12:03:34", "2015-06-10 10:03:34", "", "5", "http://localhost:8080/wordpress/2015/06/10/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2015-06-10 13:01:41", "2015-06-10 11:01:41", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Dlaczego warto nas wybrać\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-plus-circle\" title=\"Rozwojowy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-user\" title=\"Responsywny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Trzy kluczowe cechy", "", "publish", "closed", "open", "", "trzy-kluczowe-cechy", "", "", "2015-06-22 09:08:35", "2015-06-22 07:08:35", "", "0", "http://localhost:8080/wordpress/?page_id=15", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2015-06-10 13:01:41", "2015-06-10 11:01:41", "", "Trzy kluczowe cechy", "", "inherit", "closed", "open", "", "15-revision-v1", "", "", "2015-06-10 13:01:41", "2015-06-10 11:01:41", "", "15", "http://localhost:8080/wordpress/2015/06/10/15-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2015-06-10 13:01:41", "2015-06-10 11:01:41", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Dlaczego warto nas wybrać\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Trzy kluczowe cechy", "", "inherit", "closed", "open", "", "15-revision-v1", "", "", "2015-06-10 13:01:41", "2015-06-10 11:01:41", "", "15", "http://localhost:8080/wordpress/2015/06/10/15-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2015-06-10 14:11:47", "2015-06-10 12:11:47", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Zalety naszego produktu\" subtitle=\"Jasze więcej jeszcze lepszych rzeczy za naprawde jeszcze małą cenę\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;30&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][/column][/row][/section][section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;19&quot;,&quot;url&quot;:&quot;\\\\/\\\\/localhost:8080\\\\/wordpress\\\\/wp-content\\\\/uploads\\\\/2015\\\\/06\\\\/tablet.png&quot;}\" width=\"500\" height=\"387\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-road\" title=\"Animacje oraz skrypty\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-camera\" title=\"Material Design\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Zalety produktu", "", "publish", "closed", "open", "", "zalety-produktu", "", "", "2015-06-22 09:07:42", "2015-06-22 07:07:42", "", "0", "http://localhost:8080/wordpress/?page_id=18", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2015-06-10 14:08:39", "2015-06-10 12:08:39", "", "tablet", "", "inherit", "closed", "open", "", "tablet", "", "", "2015-06-10 14:08:49", "2015-06-10 12:08:49", "", "18", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/tablet.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2015-06-10 14:11:47", "2015-06-10 12:11:47", "", "Zalety produktu", "", "inherit", "closed", "open", "", "18-revision-v1", "", "", "2015-06-10 14:11:47", "2015-06-10 12:11:47", "", "18", "http://localhost:8080/wordpress/2015/06/10/18-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2015-06-10 14:11:47", "2015-06-10 12:11:47", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Zalety naszego produktu\" subtitle=\"Jasze więcej jeszcze lepszych rzeczy za naprawde jeszcze małą cenę\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;30&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][/column][/row][/section][section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;19&quot;,&quot;url&quot;:&quot;\\\\/\\\\/localhost:8080\\\\/wordpress\\\\/wp-content\\\\/uploads\\\\/2015\\\\/06\\\\/tablet.png&quot;}\" width=\"500\" height=\"387\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Zalety produktu", "", "inherit", "closed", "open", "", "18-revision-v1", "", "", "2015-06-10 14:11:47", "2015-06-10 12:11:47", "", "18", "http://localhost:8080/wordpress/2015/06/10/18-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2015-06-10 14:56:33", "2015-06-10 12:56:33", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" first_in_builder=\"1\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][special_heading title=\"Zobacz więcej jeszcze lepszych rzeczy o naszym produkcie \" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][text_block text=\"&lt;p&gt;Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][button label=\"Zobacz to\" link=\"#\" target=\"_self\" color=\"\" _made_with_builder=\"true\"][/button][button label=\"Wybierz nas\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;25&quot;,&quot;url&quot;:&quot;\\\\/\\\\/localhost:8080\\\\/wordpress\\\\/wp-content\\\\/uploads\\\\/2015\\\\/06\\\\/tablet_2.png&quot;}\" width=\"500\" height=\"260\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][/row][/section]", "Zobacz więcej", "", "publish", "closed", "open", "", "zobacz-wiecej", "", "", "2015-06-10 14:58:24", "2015-06-10 12:58:24", "", "0", "http://localhost:8080/wordpress/?page_id=22", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2015-06-10 14:56:33", "2015-06-10 12:56:33", "", "Zobacz więcej", "", "inherit", "closed", "open", "", "22-revision-v1", "", "", "2015-06-10 14:56:33", "2015-06-10 12:56:33", "", "22", "http://localhost:8080/wordpress/2015/06/10/22-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2015-06-10 14:56:33", "2015-06-10 12:56:33", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" first_in_builder=\"1\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][special_heading title=\"Zobacz więcej jeszcze lepszych rzeczy o naszym produkcie \" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][text_block text=\"&lt;p&gt;Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][button label=\"Zobacz to\" link=\"#\" target=\"_self\" color=\"\" _made_with_builder=\"true\"][/button][button label=\"Wybierz nas\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][/row][/section]", "Zobacz więcej", "", "inherit", "closed", "open", "", "22-revision-v1", "", "", "2015-06-10 14:56:33", "2015-06-10 12:56:33", "", "22", "http://localhost:8080/wordpress/2015/06/10/22-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2015-06-10 14:57:50", "2015-06-10 12:57:50", "", "tablet_2", "", "inherit", "closed", "open", "", "tablet_2", "", "", "2015-06-10 14:57:57", "2015-06-10 12:57:57", "", "22", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/tablet_2.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2015-06-10 14:58:24", "2015-06-10 12:58:24", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" first_in_builder=\"1\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][special_heading title=\"Zobacz więcej jeszcze lepszych rzeczy o naszym produkcie \" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][text_block text=\"&lt;p&gt;Nam neque erat, mattis eu volutpat eget, pharetra ac tortor. Mauris aliquet dapibus nunc quis semper. Pellentesque tortor urna, volutpat sed nibh finibus, egestas suscipit nisl. Etiam placerat risus quis metus dictum interdum.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;12&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][button label=\"Zobacz to\" link=\"#\" target=\"_self\" color=\"\" _made_with_builder=\"true\"][/button][button label=\"Wybierz nas\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;25&quot;,&quot;url&quot;:&quot;\\\\/\\\\/localhost:8080\\\\/wordpress\\\\/wp-content\\\\/uploads\\\\/2015\\\\/06\\\\/tablet_2.png&quot;}\" width=\"500\" height=\"260\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][/row][/section]", "Zobacz więcej", "", "inherit", "closed", "open", "", "22-revision-v1", "", "", "2015-06-10 14:58:24", "2015-06-10 12:58:24", "", "22", "http://localhost:8080/wordpress/2015/06/10/22-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2015-06-10 15:32:24", "2015-06-10 13:32:24", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"2_3\" _made_with_builder=\"true\"][special_heading title=\"Zarejestruj się już dziś!\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][column width=\"1_3\" _made_with_builder=\"true\"][button label=\"Rejestracja\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][/row][/section]", "Call to Action", "", "publish", "closed", "open", "", "call-to-action", "", "", "2015-06-10 15:32:24", "2015-06-10 13:32:24", "", "0", "http://localhost:8080/wordpress/?page_id=27", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2015-06-10 15:32:24", "2015-06-10 13:32:24", "", "Call to Action", "", "inherit", "closed", "open", "", "27-revision-v1", "", "", "2015-06-10 15:32:24", "2015-06-10 13:32:24", "", "27", "http://localhost:8080/wordpress/2015/06/10/27-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2015-06-10 15:32:24", "2015-06-10 13:32:24", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"2_3\" _made_with_builder=\"true\"][special_heading title=\"Zarejestruj się już dziś!\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][column width=\"1_3\" _made_with_builder=\"true\"][button label=\"Rejestracja\" link=\"#\" target=\"_self\" color=\"black\" _made_with_builder=\"true\"][/button][/column][/row][/section]", "Call to Action", "", "inherit", "closed", "open", "", "27-revision-v1", "", "", "2015-06-10 15:32:24", "2015-06-10 13:32:24", "", "27", "http://localhost:8080/wordpress/2015/06/10/27-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("30", "1", "2015-06-10 16:02:55", "2015-06-10 14:02:55", "[metaslider id=167]", "Top slider", "", "publish", "closed", "open", "", "top-slider", "", "", "2015-06-17 10:40:37", "2015-06-17 08:40:37", "", "0", "http://localhost:8080/wordpress/?page_id=30", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2015-06-10 16:02:55", "2015-06-10 14:02:55", "tu będzie slider", "Top slider", "", "inherit", "closed", "open", "", "30-revision-v1", "", "", "2015-06-10 16:02:55", "2015-06-10 14:02:55", "", "30", "http://localhost:8080/wordpress/2015/06/10/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2015-06-10 16:08:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:08:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=32", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("33", "1", "2015-06-10 16:08:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:08:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=33", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2015-06-10 16:08:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:08:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=34", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("35", "1", "2015-06-10 16:08:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:08:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=35", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2015-06-10 16:08:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:08:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=36", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("37", "1", "2015-06-10 16:08:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:08:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=37", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("38", "1", "2015-06-10 16:08:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:08:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=38", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("39", "1", "2015-06-10 16:08:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:08:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=39", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("40", "1", "2015-06-10 16:18:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:18:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=40", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("41", "1", "2015-06-10 16:18:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:18:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=41", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("42", "1", "2015-06-10 16:18:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:18:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=42", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("43", "1", "2015-06-10 16:18:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:18:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=43", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("44", "1", "2015-06-10 16:18:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:18:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=44", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("45", "1", "2015-06-10 16:18:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:18:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=45", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("46", "1", "2015-06-10 16:18:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:18:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=46", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("47", "1", "2015-06-10 16:18:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:18:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=47", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("48", "1", "2015-06-10 16:19:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=48", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("49", "1", "2015-06-10 16:19:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=49", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("50", "1", "2015-06-10 16:19:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=50", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("51", "1", "2015-06-10 16:19:05", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:05", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=51", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("56", "1", "2015-06-10 16:19:28", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:28", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=56", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("57", "1", "2015-06-10 16:19:29", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:29", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=57", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("58", "1", "2015-06-10 16:19:29", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:29", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=58", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("59", "1", "2015-06-10 16:19:29", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:29", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=59", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("60", "1", "2015-06-10 16:19:29", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:29", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=60", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("61", "1", "2015-06-10 16:19:29", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:29", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=61", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("62", "1", "2015-06-10 16:19:29", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:29", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=62", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("63", "1", "2015-06-10 16:19:29", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:29", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=63", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("64", "1", "2015-06-10 16:19:39", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:39", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=64", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("65", "1", "2015-06-10 16:19:39", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:39", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=65", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("66", "1", "2015-06-10 16:19:39", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:39", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=66", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("67", "1", "2015-06-10 16:19:39", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:39", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=67", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("68", "1", "2015-06-10 16:19:39", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:39", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=68", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("69", "1", "2015-06-10 16:19:39", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:39", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=69", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("70", "1", "2015-06-10 16:19:39", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:39", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=70", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("71", "1", "2015-06-10 16:19:39", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:19:39", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=71", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("72", "1", "2015-06-10 16:20:08", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:08", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=72", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("73", "1", "2015-06-10 16:20:08", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:08", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=73", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("74", "1", "2015-06-10 16:20:08", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:08", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=74", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("75", "1", "2015-06-10 16:20:08", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:08", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=75", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2015-06-10 16:20:08", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:08", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=76", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("77", "1", "2015-06-10 16:20:08", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:08", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=77", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("78", "1", "2015-06-10 16:20:08", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:08", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=78", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("79", "1", "2015-06-10 16:20:08", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:08", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=79", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("80", "1", "2015-06-10 16:20:21", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:21", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=80", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("81", "1", "2015-06-10 16:20:21", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:21", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=81", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("82", "1", "2015-06-10 16:20:21", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:21", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=82", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("83", "1", "2015-06-10 16:20:21", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:21", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=83", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("84", "1", "2015-06-10 16:20:21", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:21", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=84", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("85", "1", "2015-06-10 16:20:21", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:21", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=85", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("86", "1", "2015-06-10 16:20:21", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:21", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=86", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("87", "1", "2015-06-10 16:20:21", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:20:21", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=87", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("88", "1", "2015-06-10 16:21:10", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:10", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=88", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("89", "1", "2015-06-10 16:21:11", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:11", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=89", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("90", "1", "2015-06-10 16:21:11", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:11", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=90", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("91", "1", "2015-06-10 16:21:11", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:11", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=91", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("92", "1", "2015-06-10 16:21:11", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:11", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=92", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("93", "1", "2015-06-10 16:21:11", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:11", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=93", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("94", "1", "2015-06-10 16:21:11", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:11", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=94", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("95", "1", "2015-06-10 16:21:11", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:11", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=95", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("96", "1", "2015-06-10 16:21:53", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:53", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=96", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("97", "1", "2015-06-10 16:21:53", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:53", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=97", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("98", "1", "2015-06-10 16:21:53", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:53", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=98", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("99", "1", "2015-06-10 16:21:53", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:53", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=99", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("100", "1", "2015-06-10 16:21:53", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:53", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=100", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("101", "1", "2015-06-10 16:21:53", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:53", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=101", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("102", "1", "2015-06-10 16:21:53", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:53", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=102", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("103", "1", "2015-06-10 16:21:53", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:21:53", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=103", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("104", "1", "2015-06-10 16:23:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:23:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=104", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("105", "1", "2015-06-10 16:23:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:23:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=105", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("106", "1", "2015-06-10 16:23:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:23:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=106", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("107", "1", "2015-06-10 16:23:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:23:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=107", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("108", "1", "2015-06-10 16:23:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:23:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=108", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("109", "1", "2015-06-10 16:23:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:23:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=109", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("110", "1", "2015-06-10 16:23:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:23:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=110", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("111", "1", "2015-06-10 16:23:17", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:23:17", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=111", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("112", "1", "2015-06-10 16:28:30", "2015-06-10 14:28:30", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-binoculars\" title=\"Systemy CMS\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-calculator\" title=\"Reklamy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-certificate\" title=\"Programowanie C++\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-envelope-o\" title=\"WordPress\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-check\" title=\"Publikacje elektroniczne\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-bookmark-o\" title=\"Pozycjonowanie i SEO\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-download\" title=\"Systemy CMS\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Usługi", "", "publish", "closed", "open", "", "uslugi", "", "", "2015-06-22 09:11:17", "2015-06-22 07:11:17", "", "0", "http://localhost:8080/wordpress/?page_id=112", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("113", "1", "2015-06-10 16:28:30", "2015-06-10 14:28:30", "", "Usługi", "", "inherit", "closed", "open", "", "112-revision-v1", "", "", "2015-06-10 16:28:30", "2015-06-10 14:28:30", "", "112", "http://localhost:8080/wordpress/2015/06/10/112-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("114", "1", "2015-06-10 16:28:40", "2015-06-10 14:28:40", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Przykładowa strona\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.&lt;/p&gt;&lt;p&gt;Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]", "Strony", "", "publish", "closed", "open", "", "strony", "", "", "2015-06-11 12:17:16", "2015-06-11 10:17:16", "", "0", "http://localhost:8080/wordpress/?page_id=114", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("115", "1", "2015-06-10 16:28:40", "2015-06-10 14:28:40", "", "Strony", "", "inherit", "closed", "open", "", "114-revision-v1", "", "", "2015-06-10 16:28:40", "2015-06-10 14:28:40", "", "114", "http://localhost:8080/wordpress/2015/06/10/114-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("116", "1", "2015-06-10 16:29:01", "2015-06-10 14:29:01", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]", "Elementy", "", "publish", "closed", "open", "", "elementy", "", "", "2015-06-11 12:15:32", "2015-06-11 10:15:32", "", "0", "http://localhost:8080/wordpress/?page_id=116", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("117", "1", "2015-06-10 16:29:01", "2015-06-10 14:29:01", "", "Elementy", "", "inherit", "closed", "open", "", "116-revision-v1", "", "", "2015-06-10 16:29:01", "2015-06-10 14:29:01", "", "116", "http://localhost:8080/wordpress/2015/06/10/116-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("118", "1", "2015-06-10 16:29:14", "2015-06-10 14:29:14", "[contact-form-7 id=\"175\" title=\"Formularz 1\"]", "Kontakt", "", "publish", "closed", "open", "", "kontakt", "", "", "2015-06-18 13:28:04", "2015-06-18 11:28:04", "", "0", "http://localhost:8080/wordpress/?page_id=118", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("119", "1", "2015-06-10 16:29:14", "2015-06-10 14:29:14", "", "Kontakt", "", "inherit", "closed", "open", "", "118-revision-v1", "", "", "2015-06-10 16:29:14", "2015-06-10 14:29:14", "", "118", "http://localhost:8080/wordpress/2015/06/10/118-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("120", "1", "2015-06-10 16:31:46", "2015-06-10 14:31:46", " ", "", "", "publish", "closed", "open", "", "120", "", "", "2015-06-10 16:31:46", "2015-06-10 14:31:46", "", "0", "http://localhost:8080/wordpress/?p=120", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("121", "1", "2015-06-10 16:31:46", "2015-06-10 14:31:46", " ", "", "", "publish", "closed", "open", "", "121", "", "", "2015-06-10 16:31:46", "2015-06-10 14:31:46", "", "0", "http://localhost:8080/wordpress/?p=121", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("122", "1", "2015-06-10 16:30:07", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:30:07", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=122", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("123", "1", "2015-06-10 16:31:46", "2015-06-10 14:31:46", " ", "", "", "publish", "closed", "open", "", "123", "", "", "2015-06-10 16:31:46", "2015-06-10 14:31:46", "", "0", "http://localhost:8080/wordpress/?p=123", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("124", "1", "2015-06-10 16:31:46", "2015-06-10 14:31:46", " ", "", "", "publish", "closed", "open", "", "124", "", "", "2015-06-10 16:31:46", "2015-06-10 14:31:46", "", "0", "http://localhost:8080/wordpress/?p=124", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("125", "1", "2015-06-10 16:30:07", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:30:07", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=125", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("126", "1", "2015-06-10 16:31:46", "2015-06-10 14:31:46", " ", "", "", "publish", "closed", "open", "", "126", "", "", "2015-06-10 16:31:46", "2015-06-10 14:31:46", "", "0", "http://localhost:8080/wordpress/?p=126", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("127", "1", "2015-06-10 16:30:07", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:30:07", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=127", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("128", "1", "2015-06-10 16:30:07", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:30:07", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=128", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("129", "1", "2015-06-10 16:31:46", "2015-06-10 14:31:46", " ", "", "", "publish", "closed", "open", "", "129", "", "", "2015-06-10 16:31:46", "2015-06-10 14:31:46", "", "0", "http://localhost:8080/wordpress/?p=129", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("130", "1", "2015-06-10 16:30:07", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:30:07", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=130", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("131", "1", "2015-06-10 16:30:07", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "open", "", "", "", "", "2015-06-10 16:30:07", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=131", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("132", "1", "2015-06-11 12:00:07", "2015-06-11 10:00:07", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Usługi", "", "inherit", "closed", "open", "", "112-revision-v1", "", "", "2015-06-11 12:00:07", "2015-06-11 10:00:07", "", "112", "http://localhost:8080/wordpress/2015/06/11/112-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("133", "1", "2015-06-11 12:01:48", "2015-06-11 10:01:48", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Przykładowa strona\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.&lt;/p&gt;&lt;p&gt;Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]", "Strony", "", "inherit", "closed", "open", "", "114-revision-v1", "", "", "2015-06-11 12:01:48", "2015-06-11 10:01:48", "", "114", "http://localhost:8080/wordpress/2015/06/11/114-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("135", "1", "2015-06-11 12:03:21", "2015-06-11 10:03:21", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]", "Elementy", "", "inherit", "closed", "open", "", "116-revision-v1", "", "", "2015-06-11 12:03:21", "2015-06-11 10:03:21", "", "116", "http://localhost:8080/wordpress/2015/06/11/116-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("138", "1", "2015-06-11 12:07:38", "2015-06-11 10:07:38", "", "Usługi", "", "inherit", "closed", "open", "", "112-revision-v1", "", "", "2015-06-11 12:07:38", "2015-06-11 10:07:38", "", "112", "http://localhost:8080/wordpress/2015/06/11/112-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("139", "1", "2015-06-11 12:07:52", "2015-06-11 10:07:52", "", "Strony", "", "inherit", "closed", "open", "", "114-revision-v1", "", "", "2015-06-11 12:07:52", "2015-06-11 10:07:52", "", "114", "http://localhost:8080/wordpress/2015/06/11/114-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("140", "1", "2015-06-11 12:13:26", "2015-06-11 10:13:26", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Usługi", "", "inherit", "closed", "open", "", "112-revision-v1", "", "", "2015-06-11 12:13:26", "2015-06-11 10:13:26", "", "112", "http://localhost:8080/wordpress/2015/06/11/112-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("141", "1", "2015-06-11 12:15:18", "2015-06-11 10:15:18", "", "page_header_3", "", "inherit", "closed", "open", "", "page_header_3", "", "", "2015-06-11 12:15:30", "2015-06-11 10:15:30", "", "116", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/page_header_3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("142", "1", "2015-06-11 12:15:32", "2015-06-11 10:15:32", "", "Elementy", "", "inherit", "closed", "open", "", "116-revision-v1", "", "", "2015-06-11 12:15:32", "2015-06-11 10:15:32", "", "116", "http://localhost:8080/wordpress/2015/06/11/116-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("143", "1", "2015-06-11 12:15:32", "2015-06-11 10:15:32", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"WordPress\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]", "Elementy", "", "inherit", "closed", "open", "", "116-revision-v1", "", "", "2015-06-11 12:15:32", "2015-06-11 10:15:32", "", "116", "http://localhost:8080/wordpress/2015/06/11/116-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("144", "1", "2015-06-11 12:15:47", "2015-06-11 10:15:47", "", "page_header_1", "", "inherit", "closed", "open", "", "page_header_1", "", "", "2015-06-11 12:15:53", "2015-06-11 10:15:53", "", "112", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/page_header_1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("145", "1", "2015-06-11 12:16:51", "2015-06-11 10:16:51", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Przykładowa strona\" subtitle=\"\" heading=\"h2\" centered=\"\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][text_block text=\"&lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam lacus enim, euismod non massa eget, mattis semper magna. Quisque nisi diam, dictum ac nunc vitae, lacinia mattis magna. Etiam egestas mi euismod magna commodo aliquet. Vestibulum mollis augue vel arcu ornare rhoncus id convallis ex. Maecenas aliquet condimentum elit, ac gravida diam consequat ac. Fusce congue tempus nunc non venenatis. Cras accumsan enim at venenatis suscipit. Cras id neque eu odio eleifend porta ac vitae massa. Nam euismod enim in nibh luctus iaculis. Sed in ante ac metus venenatis malesuada ac at sem. Suspendisse lacus sapien, vestibulum in euismod non, dictum congue purus. Praesent dignissim nisi est, non interdum nulla gravida ac. Quisque a sollicitudin odio. Mauris imperdiet, diam quis ullamcorper sollicitudin, augue ipsum elementum magna, eget laoreet mauris orci ut purus.&lt;/p&gt;&lt;p&gt;Nulla facilisi. Aenean malesuada pharetra sagittis. Aliquam pellentesque condimentum lacus at pharetra. Fusce turpis ligula, lobortis et urna non, tincidunt molestie est. Proin elementum risus velit, sit amet consectetur dui pretium eget. Praesent eget nisi sodales, rhoncus sapien sodales, viverra dui. Vestibulum ut venenatis metus. Suspendisse egestas et metus quis suscipit. Aliquam porta sodales lacus, non mollis lacus fermentum vel. Etiam nibh augue, blandit vitae dictum eget, viverra id est.&lt;/p&gt;\" _made_with_builder=\"true\"][/text_block][/column][/row][/section]", "Strony", "", "inherit", "closed", "open", "", "114-revision-v1", "", "", "2015-06-11 12:16:51", "2015-06-11 10:16:51", "", "114", "http://localhost:8080/wordpress/2015/06/11/114-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("146", "1", "2015-06-11 12:17:04", "2015-06-11 10:17:04", "", "page_header_2", "", "inherit", "closed", "open", "", "page_header_2", "", "", "2015-06-11 12:17:13", "2015-06-11 10:17:13", "", "114", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/page_header_2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("147", "1", "2015-06-11 12:17:36", "2015-06-11 10:17:36", "", "page_headerdd_4", "", "inherit", "closed", "open", "", "page_headerdd_4", "", "", "2015-06-11 12:17:41", "2015-06-11 10:17:41", "", "118", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/page_headerdd_4.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("150", "1", "2015-06-11 12:50:37", "2015-06-11 10:50:37", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci.\r\n\r\nSed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam.", "10 przydatnych narzędzi dla programistów i projektantów", "", "publish", "closed", "open", "", "10-przydatnych-narzedzi-dla-programistow-i-projektantow", "", "", "2015-06-12 10:30:19", "2015-06-12 08:30:19", "", "0", "http://localhost:8080/wordpress/?p=150", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("151", "1", "2015-06-11 12:50:37", "2015-06-11 10:50:37", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci.<!--more-->\r\n\r\n Sed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam. ", "10 przydatnych narzędzi dla programistów i projektantów", "", "inherit", "closed", "open", "", "150-revision-v1", "", "", "2015-06-11 12:50:37", "2015-06-11 10:50:37", "", "150", "http://localhost:8080/wordpress/2015/06/11/150-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("152", "1", "2015-06-11 12:51:22", "2015-06-11 10:51:22", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci. Sed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium.\r\n\r\nVivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam.", "Ekspresowe tworzenie stron z Bootstrap & LESS", "", "publish", "closed", "open", "", "ekspresowe-tworzenie-stron-z-bootstrap-less", "", "", "2015-06-12 10:30:09", "2015-06-12 08:30:09", "", "0", "http://localhost:8080/wordpress/?p=152", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("153", "1", "2015-06-11 12:51:22", "2015-06-11 10:51:22", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci. Sed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. <!--more-->\r\n\r\nVivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam. ", "Ekspresowe tworzenie stron z Bootstrap & LESS", "", "inherit", "closed", "open", "", "152-revision-v1", "", "", "2015-06-11 12:51:22", "2015-06-11 10:51:22", "", "152", "http://localhost:8080/wordpress/2015/06/11/152-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("154", "1", "2015-06-11 12:52:21", "2015-06-11 10:52:21", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci.\r\n\r\nSed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam.", "Nasza oferta dla ciebie", "", "publish", "closed", "open", "", "nasza-oferta-dla-ciebie-obrazek", "", "", "2015-06-12 10:30:00", "2015-06-12 08:30:00", "", "0", "http://localhost:8080/wordpress/?p=154", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("155", "1", "2015-06-11 12:51:59", "2015-06-11 10:51:59", "", "blog_1", "", "inherit", "closed", "open", "", "blog_1", "", "", "2015-06-11 12:52:04", "2015-06-11 10:52:04", "", "154", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/blog_1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("156", "1", "2015-06-11 12:52:21", "2015-06-11 10:52:21", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci. <!--more-->\r\n\r\nSed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam. ", "Nasza oferta dla ciebie + obrazek", "", "inherit", "closed", "open", "", "154-revision-v1", "", "", "2015-06-11 12:52:21", "2015-06-11 10:52:21", "", "154", "http://localhost:8080/wordpress/2015/06/11/154-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("157", "1", "2015-06-11 12:53:12", "2015-06-11 10:53:12", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci.\r\n\r\nSed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam.", "Generowanie stylów CSS w programie Photoshop", "", "publish", "closed", "open", "", "generowanie-stylow-css-w-programie-photoshop-obrazek", "", "", "2015-06-12 10:29:49", "2015-06-12 08:29:49", "", "0", "http://localhost:8080/wordpress/?p=157", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("158", "1", "2015-06-11 12:52:49", "2015-06-11 10:52:49", "", "blog_2", "", "inherit", "closed", "open", "", "blog_2", "", "", "2015-06-11 12:52:56", "2015-06-11 10:52:56", "", "157", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/blog_2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("159", "1", "2015-06-11 12:53:12", "2015-06-11 10:53:12", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci.<!--more-->\r\n\r\n Sed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam. ", "Generowanie stylów CSS w programie Photoshop + obrazek", "", "inherit", "closed", "open", "", "157-revision-v1", "", "", "2015-06-11 12:53:12", "2015-06-11 10:53:12", "", "157", "http://localhost:8080/wordpress/2015/06/11/157-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("160", "1", "2015-06-11 16:22:47", "2015-06-11 14:22:47", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci. <!--more-->\r\n\r\nSed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam. ", "Nasza oferta dla ciebie", "", "inherit", "closed", "open", "", "154-revision-v1", "", "", "2015-06-11 16:22:47", "2015-06-11 14:22:47", "", "154", "http://localhost:8080/wordpress/2015/06/11/154-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("161", "1", "2015-06-11 16:22:56", "2015-06-11 14:22:56", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci.<!--more-->\r\n\r\n Sed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam. ", "Generowanie stylów CSS w programie Photoshop", "", "inherit", "closed", "open", "", "157-revision-v1", "", "", "2015-06-11 16:22:56", "2015-06-11 14:22:56", "", "157", "http://localhost:8080/wordpress/2015/06/11/157-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("162", "1", "2015-06-12 10:29:49", "2015-06-12 08:29:49", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci.\r\n\r\nSed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam.", "Generowanie stylów CSS w programie Photoshop", "", "inherit", "closed", "open", "", "157-revision-v1", "", "", "2015-06-12 10:29:49", "2015-06-12 08:29:49", "", "157", "http://localhost:8080/wordpress/2015/06/12/157-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("163", "1", "2015-06-12 10:30:00", "2015-06-12 08:30:00", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci.\r\n\r\nSed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam.", "Nasza oferta dla ciebie", "", "inherit", "closed", "open", "", "154-revision-v1", "", "", "2015-06-12 10:30:00", "2015-06-12 08:30:00", "", "154", "http://localhost:8080/wordpress/2015/06/12/154-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("164", "1", "2015-06-12 10:30:09", "2015-06-12 08:30:09", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci. Sed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium.\r\n\r\nVivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam.", "Ekspresowe tworzenie stron z Bootstrap & LESS", "", "inherit", "closed", "open", "", "152-revision-v1", "", "", "2015-06-12 10:30:09", "2015-06-12 08:30:09", "", "152", "http://localhost:8080/wordpress/2015/06/12/152-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("165", "1", "2015-06-12 10:30:19", "2015-06-12 08:30:19", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget commodo arcu, ut placerat arcu. Nunc ac mi sit amet lorem accumsan consectetur a quis nunc. Donec bibendum quam et odio imperdiet, nec lacinia ligula luctus. Curabitur ultrices at quam eu pharetra. Suspendisse quis metus imperdiet, fermentum sapien sed, blandit mauris. Nullam luctus, eros eget dictum tempus, elit erat porta diam, a sollicitudin elit nunc at orci.\r\n\r\nSed rutrum ipsum quis risus mattis, et laoreet nisi maximus. Pellentesque a mi quam. Fusce eu nulla ipsum. Sed lobortis rutrum pretium. Vivamus sit amet orci et magna posuere cursus id nec ante. Curabitur libero arcu, consectetur ut leo vitae, molestie porttitor mauris. Ut a pellentesque ex. Morbi sagittis nunc id laoreet sollicitudin. Donec rhoncus tincidunt odio. Morbi fringilla velit neque, et condimentum arcu sagittis et. Donec consequat dui at suscipit dictum. Quisque semper molestie quam ut sagittis. Integer sit amet erat felis. Suspendisse mollis tellus vulputate pulvinar iaculis. Proin vulputate id mi id vehicula. Fusce faucibus iaculis ipsum sed aliquam. Aenean ipsum quam, lobortis ut consectetur et, volutpat quis erat. Sed fermentum, elit non malesuada tristique, justo ipsum euismod nisi, tincidunt volutpat ante risus id lectus. Maecenas ut massa in libero lobortis lacinia. Mauris et sapien dignissim turpis ornare tincidunt at luctus est. Duis eu vestibulum ex, sed varius felis. Etiam aliquet dignissim diam nec dictum. Ut et lacinia ex. Nullam fringilla vitae lorem ut viverra. Phasellus a accumsan libero. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Integer lacinia risus odio, quis iaculis mauris elementum eu. Duis sed sapien sit amet eros condimentum aliquam.", "10 przydatnych narzędzi dla programistów i projektantów", "", "inherit", "closed", "open", "", "150-revision-v1", "", "", "2015-06-12 10:30:19", "2015-06-12 08:30:19", "", "150", "http://localhost:8080/wordpress/2015/06/12/150-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("166", "1", "2015-06-17 10:05:22", "0000-00-00 00:00:00", "", "Automatycznie zapisany szkic", "", "auto-draft", "closed", "open", "", "", "", "", "2015-06-17 10:05:22", "0000-00-00 00:00:00", "", "0", "http://localhost:8080/wordpress/?p=166", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("167", "1", "2015-06-17 10:06:34", "2015-06-17 08:06:34", "", "Nowy slider", "", "publish", "closed", "open", "", "nowy-slider", "", "", "2015-06-22 09:05:17", "2015-06-22 07:05:17", "", "0", "http://localhost:8080/wordpress/?post_type=ml-slider&#038;p=167", "0", "ml-slider", "", "0");
INSERT INTO `wp_posts` VALUES("171", "1", "2015-06-17 10:38:06", "2015-06-17 08:38:06", "", "slider_1", "<div class=\"container\">\r\n	<span class=\"slide-heading\">Nowoczesne i sprawdzone rozwiązania</span>\r\n	<p class=\"slide-desc\">Lorem ipsum dolor sit amet, consectetur elit.</p>\r\n	<a class=\"fw-btn fw-btn-1 slide-btn\" href=\"\"><span>Sprawdź to!</span></a>\r\n</div>", "inherit", "closed", "open", "", "slider_1", "", "", "2015-06-22 09:05:17", "2015-06-22 07:05:17", "", "0", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/slider_1.jpg", "1", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("172", "1", "2015-06-17 10:38:07", "2015-06-17 08:38:07", "", "slider_2", "<div class=\"container\">\r\n	<span class=\"slide-heading\">WordPress LESS Bootstrap Material</span>\r\n	<p class=\"slide-desc\">Lorem ipsum dolor sit amet, consectetur elit.</p>\r\n	<a class=\"fw-btn fw-btn-1 slide-btn\" href=\"\"><span>Sprawdź to!</span></a>\r\n       <a class=\"fw-btn fw-btn-1 slide-btn fw-btn-black\" href=\"\"><span>Sprawdź to!</span></a>\r\n</div>", "inherit", "closed", "open", "", "slider_2", "", "", "2015-06-22 09:05:17", "2015-06-22 07:05:17", "", "0", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/slider_2.jpg", "2", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("173", "1", "2015-06-17 10:38:08", "2015-06-17 08:38:08", "", "slider_3", "<div class=\"container\">\r\n	<span class=\"slide-heading\">W pełni responsywny projekt</span>\r\n	<p class=\"slide-desc\">Lorem ipsum dolor sit amet, consectetur elit.</p>\r\n	<a class=\"fw-btn fw-btn-1 slide-btn\" href=\"\"><span>Sprawdź to!</span></a>\r\n</div>", "inherit", "closed", "open", "", "slider_3", "", "", "2015-06-22 09:05:17", "2015-06-22 07:05:17", "", "0", "http://localhost:8080/wordpress/wp-content/uploads/2015/06/slider_3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("174", "1", "2015-06-17 10:40:37", "2015-06-17 08:40:37", "[metaslider id=167]", "Top slider", "", "inherit", "closed", "open", "", "30-revision-v1", "", "", "2015-06-17 10:40:37", "2015-06-17 08:40:37", "", "30", "http://localhost:8080/wordpress/2015/06/17/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("175", "1", "2015-06-18 13:26:31", "2015-06-18 11:26:31", "<div class=\"form-control-wrapper\">\r\n[text name class:form-control]<div class=\"floating-label\">\r\nImię i nazwisko\r\n</div>\r\n</div>\r\n\r\n<div class=\"form-control-wrapper\">\r\n[tel phone class:form-control]<div class=\"floating-label\">\r\nTelefon\r\n</div>\r\n</div>\r\n\r\n<div class=\"form-control-wrapper\">\r\n[email email class:form-control]<div class=\"floating-label\">\r\nEmail\r\n</div>\r\n</div>\r\n\r\n<div class=\"form-control-wrapper\">\r\n[textarea message class:form-control]<div class=\"floating-label\">\r\nWiadomość\r\n</div>\r\n</div>\r\n\r\n[submit class:fw-btn class:fw-btn-black class:fw-btn-1 \"Wyślij zapytanie\"]\n[your-subject]\n[your-name] <admin@strefakursow.pl>\nNadawca: [your-name] <[your-email]>\r\nTemat: [your-subject]\r\n\r\nTreść wiadomości:\r\n[your-message]\r\n\r\n--\r\nThis e-mail was sent from a contact form on Kurs WP (http://localhost:8080/wordpress)\nadmin@strefakursow.pl\nReply-To: [your-email]\n\n\n\n\n[your-subject]\nKurs WP <admin@strefakursow.pl>\nTreść wiadomości:\r\n[your-message]\r\n\r\n--\r\nThis e-mail was sent from a contact form on Kurs WP (http://localhost:8080/wordpress)\n[your-email]\nReply-To: admin@strefakursow.pl\n\n\n\nTwoja wiadomość została wysłana. Dziękujemy.\nTwoja wiadomość nie została wysłana.\nWystąpiły błędy. Sprawdź wszystkie pola formularza i spróbuj wysłać ponownie.\nTwoja wiadomość nie została wysłana.\nProszę zapoznać się z warunkami oraz zaznaczyć odpowiednie pole aby kontynuować.\nPlease fill in the required field.\nThis input is too long.\nThis input is too short.\nWpisany kod jest nieprawidłowy.\nFormat liczby jest niepoprawny.\nTa liczba jest zbyt mała.\nTa liczba jest zbyt duża.\nPodany adres e-mail jest niepoprawny.\nAdres URL jest niepoprawny.\nPodany numer telefonu jest niepoprawny.\nOdpowiedź nie jest prawidłowa.\nFormat daty jest niepoprawny.\nPodana data jest zbyt wczesna.\nPodana data jest zbyt późna.\nBłąd podczas przesyłania pliku.\nPrzesyłanie tego rodzaju pliku jest niedozwolone.\nPlik jest zbyt duży.\nNie udało się przesłać pliku. Wystąpił błąd.", "Formularz 1", "", "publish", "closed", "open", "", "formularz-1", "", "", "2015-06-18 14:02:46", "2015-06-18 12:02:46", "", "0", "http://localhost:8080/wordpress/?post_type=wpcf7_contact_form&#038;p=175", "0", "wpcf7_contact_form", "", "0");
INSERT INTO `wp_posts` VALUES("176", "1", "2015-06-18 13:28:04", "2015-06-18 11:28:04", "[contact-form-7 id=\"175\" title=\"Formularz 1\"]", "Kontakt", "", "inherit", "closed", "open", "", "118-revision-v1", "", "", "2015-06-18 13:28:04", "2015-06-18 11:28:04", "", "118", "http://localhost:8080/wordpress/2015/06/18/118-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("177", "1", "2015-06-22 09:06:21", "2015-06-22 07:06:21", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Dlaczego warto nas wybrać\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Rozwojowy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Responsywny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Trzy kluczowe cechy", "", "inherit", "closed", "open", "", "15-revision-v1", "", "", "2015-06-22 09:06:21", "2015-06-22 07:06:21", "", "15", "http://localhost:8080/wordpress/2015/06/22/15-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("179", "1", "2015-06-22 09:07:09", "2015-06-22 07:07:09", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Zalety naszego produktu\" subtitle=\"Jasze więcej jeszcze lepszych rzeczy za naprawde jeszcze małą cenę\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;30&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][/column][/row][/section][section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;19&quot;,&quot;url&quot;:&quot;\\\\/\\\\/localhost:8080\\\\/wordpress\\\\/wp-content\\\\/uploads\\\\/2015\\\\/06\\\\/tablet.png&quot;}\" width=\"500\" height=\"387\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Animacje oraz skrypty\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Material Design\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Zalety produktu", "", "inherit", "closed", "open", "", "18-revision-v1", "", "", "2015-06-22 09:07:09", "2015-06-22 07:07:09", "", "18", "http://localhost:8080/wordpress/2015/06/22/18-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("181", "1", "2015-06-22 09:07:42", "2015-06-22 07:07:42", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Zalety naszego produktu\" subtitle=\"Jasze więcej jeszcze lepszych rzeczy za naprawde jeszcze małą cenę\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_1\" _made_with_builder=\"true\"][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;30&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][/column][/row][/section][section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"\" _made_with_builder=\"true\"][row][column width=\"1_2\" _made_with_builder=\"true\"][media_image image=\"{&quot;attachment_id&quot;:&quot;19&quot;,&quot;url&quot;:&quot;\\\\/\\\\/localhost:8080\\\\/wordpress\\\\/wp-content\\\\/uploads\\\\/2015\\\\/06\\\\/tablet.png&quot;}\" width=\"500\" height=\"387\" link=\"\" target=\"_self\" _array_keys=\"{&quot;image&quot;:&quot;image&quot;}\" _made_with_builder=\"true\"][/media_image][/column][column width=\"1_2\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-bell\" title=\"Oparty na HTML5 i CSS3\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-road\" title=\"Animacje oraz skrypty\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][divider style=\"{&quot;ruler_type&quot;:&quot;space&quot;,&quot;space&quot;:{&quot;height&quot;:&quot;24&quot;}}\" _array_keys=\"{&quot;style&quot;:&quot;style&quot;}\" _made_with_builder=\"true\"][/divider][icon_box style=\"fw-iconbox-2\" icon=\"fa fa-camera\" title=\"Material Design\" content=\"Curabitur consectetur mi sit amet nibh cursus, dapibus\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Zalety produktu", "", "inherit", "closed", "open", "", "18-revision-v1", "", "", "2015-06-22 09:07:42", "2015-06-22 07:07:42", "", "18", "http://localhost:8080/wordpress/2015/06/22/18-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("182", "1", "2015-06-22 09:08:35", "2015-06-22 07:08:35", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_1\" _made_with_builder=\"true\"][special_heading title=\"Dlaczego warto nas wybrać\" subtitle=\"\" heading=\"h2\" centered=\"1\" _made_with_builder=\"true\"][/special_heading][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-cog\" title=\"Nowoczesny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-plus-circle\" title=\"Rozwojowy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-user\" title=\"Responsywny\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi sagittis, sem quis lacinia faucibus.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Trzy kluczowe cechy", "", "inherit", "closed", "open", "", "15-revision-v1", "", "", "2015-06-22 09:08:35", "2015-06-22 07:08:35", "", "15", "http://localhost:8080/wordpress/2015/06/22/15-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("183", "1", "2015-06-22 09:11:17", "2015-06-22 07:11:17", "[section is_fullwidth=\"\" background_color=\"\" background_image=\"\" video=\"\" auto_generated=\"1\" _made_with_builder=\"true\"][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-binoculars\" title=\"Systemy CMS\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-calculator\" title=\"Reklamy\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-certificate\" title=\"Programowanie C++\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-envelope-o\" title=\"WordPress\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-check\" title=\"Publikacje elektroniczne\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][row][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-bookmark-o\" title=\"Pozycjonowanie i SEO\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-camera\" title=\"Programowanie PHP\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][column width=\"1_3\" _made_with_builder=\"true\"][icon_box style=\"fw-iconbox-1\" icon=\"fa fa-download\" title=\"Systemy CMS\" content=\"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean cursus nibh posuere luctus. Cras interdum convallis mauris vel vulputate.\" _made_with_builder=\"true\"][/icon_box][/column][/row][/section]", "Usługi", "", "inherit", "closed", "open", "", "112-revision-v1", "", "", "2015-06-22 09:11:17", "2015-06-22 07:11:17", "", "112", "http://localhost:8080/wordpress/2015/06/22/112-revision-v1/", "0", "revision", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("120", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("121", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("123", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("124", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("129", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("150", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("152", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("154", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("157", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("171", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("172", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("173", "5", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "nav_menu", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "ml-slider", "", "0", "0");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Uncategorized", "uncategorized", "0");
INSERT INTO `wp_terms` VALUES("4", "Menu glowne", "menu-glowne", "0");
INSERT INTO `wp_terms` VALUES("5", "167", "167", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "nickname", "admin");
INSERT INTO `wp_usermeta` VALUES("2", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("12", "1", "dismissed_wp_pointers", "wp360_locks,wp390_widgets,wp410_dfw");
INSERT INTO `wp_usermeta` VALUES("14", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("16", "1", "wp_dashboard_quick_press_last_post_id", "166");
INSERT INTO `wp_usermeta` VALUES("17", "1", "wp_user-settings", "editor=tinymce&libraryContent=browse");
INSERT INTO `wp_usermeta` VALUES("18", "1", "wp_user-settings-time", "1434530410");
INSERT INTO `wp_usermeta` VALUES("19", "1", "managenav-menuscolumnshidden", "a:4:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";}");
INSERT INTO `wp_usermeta` VALUES("20", "1", "metaboxhidden_nav-menus", "a:2:{i:0;s:8:\"add-post\";i:1;s:12:\"add-post_tag\";}");
INSERT INTO `wp_usermeta` VALUES("21", "1", "nav_menu_recently_edited", "4");
INSERT INTO `wp_usermeta` VALUES("28", "1", "closedpostboxes_toplevel_page_wpcf7", "a:0:{}");
INSERT INTO `wp_usermeta` VALUES("29", "1", "metaboxhidden_toplevel_page_wpcf7", "a:0:{}");
INSERT INTO `wp_usermeta` VALUES("32", "1", "session_tokens", "a:1:{s:64:\"aaab1d0f92ef3360ac63bea6354aaafd65ef3081a3ebb1b7d4a8eee5cbf41c05\";a:4:{s:10:\"expiration\";i:1435129403;s:2:\"ip\";s:3:\"::1\";s:2:\"ua\";s:72:\"Mozilla/5.0 (Windows NT 6.2; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0\";s:5:\"login\";i:1434956603;}}");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "admin", "$P$B0vKc2PmjGy8iN9EeTyk4MqqACLFNg.", "admin", "admin@strefakursow.pl", "", "2015-06-09 13:24:23", "", "0", "admin");

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2015-06-22 07:14:07*/
/* DUPLICATOR_MYSQLDUMP_EOF */
